package jcsc;

import java.awt.Color;
import java.io.File;

import javax.swing.JOptionPane;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

/**
 * F̑IE쐬_CAO
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  26 May 2007
 */
public class Jcsc {
	private final boolean DEBUG = false;

	private String title;

	private Color currentColor = Color.black;
	private Color chosenColor = null;
	private ExtColor[] colordic = null;

	private JcscCmapPanel cp;
	private JcscEditPanel ep;

	/**
	 * RXgN^
	 */
	public Jcsc(String colordicFilePath, String colordic2ndFilePath) {
		if (!initialize(colordicFilePath, false)) {
			initialize(colordic2ndFilePath, true);
		}
	}

	/**
	 * 
	 */
	private boolean initialize(String colordicFilePath, boolean isResource) {
		if (!loadColordic(colordicFilePath, isResource)) {
			return false;
		}

		cp = new JcscCmapPanel(this);
		cp.setColordic(colordic);

		ep = new JcscEditPanel(this);
		ep.setSpinnersValue(currentColor);

		return true;
	}

	/**
	 * J[Tv̓ǂݍ
	 * @param ColordicFilePath
	 * @return
	 */	
	private boolean loadColordic(String colordicFilePath, boolean isResource) {
		boolean isOpened = false;

		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();

			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();

			// p[XsDocumentIuWFNg擾
			Document doc;
			if (isResource) {
				// \[Xǂݍ
				doc = builder.parse(
				getClass().getClassLoader().getResourceAsStream(colordicFilePath));
			} else {
				// t@CVXeǂݍ
				doc = builder.parse(new File(colordicFilePath));
			}

			isOpened = true;

			// [gvf擾
			Element root = doc.getDocumentElement();
			if (root == null) {
				if (DEBUG) System.out.println("Illeagal input.");
				return false;
			}
			if (root.getTagName().compareTo("colordic") != 0) {
				if (DEBUG) System.out.println("Illeagal input.");
				return false;
			} 

			// F擾
			if (DEBUG) System.out.println("***** F *****");

			NodeList clist = root.getElementsByTagName("color");
			int cnum = clist.getLength();
			if (cnum == 0) {
				colordic = null;
				return false;
			} else {
				colordic = new ExtColor[cnum];
			}

			for (int i = 0; i < clist.getLength(); i++) {

				Element celem = (Element)clist.item(i);

				colordic[i] = new ExtColor(
					celem.getAttribute("name"),
					(int)Double.parseDouble(celem.getAttribute("R")),
					(int)Double.parseDouble(celem.getAttribute("G")),
					(int)Double.parseDouble(celem.getAttribute("B"))
				);
				ExtColorCalc.toHSV(colordic[i]);

				if (DEBUG) {
					ExtColor exc = colordic[i];
					System.out.println("--------<" + colordic[i].name);
					System.out.println("\tR:" + exc.color.getRed()
									 + ", G:" + exc.color.getGreen()
									 + ", B:" + exc.color.getBlue());
					System.out.println("\tH:" + exc.h
									 + ", S:" + exc.s
									 + ", V:" + exc.v);
				}				
			}
		} catch (Exception e) {
			if (isOpened) e.printStackTrace();

			colordic = null;
			return false;
		}

		return true;
	}

	/**
	 * _CAO\
	 */
	public void setVisible(boolean visible) {
		chosenColor = null;

		Object[] message = {cp, ep};

		int result = JOptionPane.showOptionDialog(
			null,
			message,
			title,
			JOptionPane.OK_CANCEL_OPTION,
			JOptionPane.PLAIN_MESSAGE,
			null,
			null,
			null
			);

		switch (result) {
			case 0:
			chosenColor = currentColor;
			break;
			
			default:
			break;
		}
	}

	/**
	 * ^Cg̐ݒ
	 * @param s
	 */
	public void setTitle(String s) {
		title = s;
	}

	/**
	 * F̃ZbgƔf
	 * @param defaultColor
	 */
	public void setDefaultColor(Color defaultColor) {
		setCurrentColor(defaultColor);
		ep.setSpinnersValue(currentColor);
		ep.refreshColorNameLabel();
	}

	/**
	 * JgJ[̃Zbg
	 * @param color
	 */
	protected void setCurrentColor(Color color) {
		currentColor = color;
	}

	/**
	 * JgJ[Ԃ
	 * @return
	 */
	protected Color getCurrentColor() {
		return currentColor;
	}

	/**
	 * JgJ[ɂΖOԂ
	 * @return
	 */
	public String getCurrentColorName() {
		String name = null;
		int r = currentColor.getRed();
		int g = currentColor.getGreen();
		int b = currentColor.getBlue();

		for (int i = 0; i < colordic.length; i++) {
			if (
				(r == colordic[i].color.getRed()) &&
				(g == colordic[i].color.getGreen()) &&
				(b == colordic[i].color.getBlue())
				) name = colordic[i].name.toString();
		}
		return name;
	}

	/**
	 * IFԂ
	 * @return
	 */
	public Color getChosenColor() {
		return chosenColor;
	}

}
