package jcsc;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Graphics;

import javax.swing.Box;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 * F̍쐬pl
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  26 May 2007
 */
public class JcscEditPanel extends JPanel
	implements 	ChangeListener {
	private Jcsc jcsc;
	private ColorSamplePanel csp;

	private JSpinner spnr;
	private JSpinner spng;
	private JSpinner spnb;
	private SpinnerNumberModel spmr;
	private SpinnerNumberModel spmg;
	private SpinnerNumberModel spmb;

	private JLabel clb;

	/**
	 * RXgN^
	 * @param parent
	 */
	public JcscEditPanel(Jcsc parent) {
		jcsc = parent;

		/*
		 * J[Tv
		 */
		csp = new ColorSamplePanel(parent); 

		/*
		 *  RGBXsi[ƐF\
		 */
		Box box = Box.createVerticalBox();

		JPanel p;

			/*
			 * RGBXsi[
			 */
		p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.CENTER));

		int sz = p.getFont().getSize();
		JLabel lb;
		Integer min = Integer.valueOf(0);
		Integer max = Integer.valueOf(255);
		Integer step = Integer.valueOf(1);

				/*
				 * R
				 */
		lb = new JLabel(" R:");
		p.add(lb);
		spnr = new JSpinner();
		spmr = new SpinnerNumberModel(min, min, max, step);
		spnr.setPreferredSize(new Dimension(sz*5/2+12, sz+8));
		spnr.setModel(spmr);
		spnr.addChangeListener(this);
		p.add(spnr);

				/*
				 * G
				 */
		lb = new JLabel(" G:");
		p.add(lb);
		spng = new JSpinner();
		spmg = new SpinnerNumberModel(min, min, max, step);
		spng.setPreferredSize(new Dimension(sz*5/2+12, sz+8));
		spng.setModel(spmg);
		spng.addChangeListener(this);
		p.add(spng);

				/*
				 * B
				 */
		lb = new JLabel(" B:");
		p.add(lb);
		spnb = new JSpinner();
		spmb = new SpinnerNumberModel(min, min, max, step);
		spnb.setPreferredSize(new Dimension(sz*5/2+12, sz+8));
		spnb.setModel(spmb);
		spnb.addChangeListener(this);
		p.add(spnb);

		box.add(p);

			/*
			 * Fx
			 */
		p = new JPanel();
		p.setLayout(new FlowLayout(FlowLayout.LEFT));

		clb = new JLabel();
		clb.setPreferredSize(new Dimension(160, sz+8));
		p.add(clb);

		box.add(p);

		/*
		 * S̃CAEg
		 */
		setLayout(new BorderLayout());
		add(csp, BorderLayout.WEST);
		add(box, BorderLayout.CENTER);
	}

	/**
	 * Fx̍XV
	 */
	public void refreshColorNameLabel() {
		clb.setText(jcsc.getCurrentColorName());		
	}

	/**
	 * Xsi[ɐFRGBlݒ
	 * @param color
	 */
	public void setSpinnersValue(Color color) {
		spnr.setValue(Integer.valueOf(color.getRed()));
		spng.setValue(Integer.valueOf(color.getGreen()));
		spnb.setValue(Integer.valueOf(color.getBlue()));
	}

	/**
	 * Xsi[Cxg
	 */
	public void stateChanged(ChangeEvent e) {
		int r = ((Integer)spnr.getValue()).intValue();
		int g = ((Integer)spng.getValue()).intValue();
		int b = ((Integer)spnb.getValue()).intValue();

		if (
			(r < 0) || (r > 255) ||
			(g < 0) || (g > 255) ||
			(b < 0) || (b > 255)
			) return;

		jcsc.setCurrentColor(new Color(r, g, b, 255));

		clb.setText(null);
		csp.repaint();
	}

	/**
	 * J[TvplNX
	 */
	private class ColorSamplePanel extends JPanel {
		private final int width  = 40;
		private final int height = 56;

		private Jcsc jcsc;

		public ColorSamplePanel(Jcsc parent) {
			jcsc = parent;
			setPreferredSize(new Dimension(width, height));
		}

		public void paint(Graphics g) {
			g.setColor(jcsc.getCurrentColor());
			g.fillRect(0, 0, width, height);
		}
	}

	/*
	 * Xsi[̃ANZ[^悤ƂLOc
	 */
	/**
	 * }EXXi[Q
	 *   @param e }EXCxg
	 */
	/*
	public void mouseDragged(MouseEvent e) {}
	public void mouseReleased(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		e.consume();
		System.out.println("Press");
	}
	*/	
}
