package jte;

import java.awt.Color;
import java.awt.Component;
import java.io.File;

import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import jcsc.Jcsc;
import jte.editpanel.EditPanel;
import jte.editpanel.EditToolBar;
import jte.guidepanel.GuideImagePanel;
import jte.guidepanel.GuideToolBar;
import jte.jtehtml.JteHtmlMaker;
import jte.listpanel.ListData;
import jte.listpanel.ListPanel;
import jte.listpanel.ListToolBar;
import jte.mainframe.Menu;
import jte.mainframe.StatusBar;
import jte.mainframe.ToolBar;
import tangram.PieceInfo;
import tangram.PieceInfoTool;
import tangram.Tangram;
import tangram.svcs.Listios;
import tangram.svcs.Undom;

/**
 * ʃNX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class Common {
	private static final boolean DEBUG = false;		// fobOp
	
	private static boolean filechanged = false;

	private static Tangram tan = null;
	private static Listios lios = null;
	private static Undom undom = null;

	private static Menu menu = null;
	private static StatusBar sb = null;
	private static ToolBar tb = null;
	private static EditPanel ep = null;
	private static EditToolBar etb = null;
	private static GuideImagePanel gip = null;
	private static GuideToolBar gtb = null;
	private static ListData ld = null;
	private static ListPanel lp = null;
	private static ListToolBar ltb = null;

	private static Jcsc jcsc = null;

	public Common() {
	}

	/**
	 * ^O֘Ap[c̃Zbg
	 * @param tan_
	 * @param lios_
	 * @param undom_
	 */
	public static void setTangramParts(
		Tangram tan_,
		Listios lios_,
		Undom undom_
	) {
		tan = tan_;
		lios = lios_;
		undom = undom_;
	}

	/**
	 * GfB^p[c̃Zbg
	 * @param menu_
	 * @param sb_
	 * @param tb_
	 * @param ep_
	 * @param etb_
	 * @param gip_
	 * @param gtb_
	 * @param ld_
	 * @param lp_
	 * @param ltb_
	 */
	public static void setEditorParts(
		Menu menu_,
		StatusBar sb_,
		ToolBar tb_,
		EditPanel ep_,
		EditToolBar etb_,
		GuideImagePanel gip_,
		GuideToolBar gtb_,
		ListData ld_,
		ListPanel lp_,
		ListToolBar ltb_
	) {
		menu = menu_;
		sb = sb_;
		tb = tb_;
		ep = ep_;
		etb = etb_;
		gip = gip_;
		gtb = gtb_;
		ld = ld_;
		lp = lp_;
		ltb = ltb_;
	}

/*
 * 擾T[rX
 */
	 /**
	  * t@CύXꂽǂԂ
	  * @return
	  */
	 public static boolean isFileChanged() {
		 return filechanged;
	 }

	/**
	 * ^OԂ
	 * @return
	 */		
	public static Tangram getTangram() {
		return tan;
	}

	/**
	 * XgIOT[rXԂ
	 * @return
	 */
	public static Listios getListios() {
		return lios;
	}

	/**
	 * Xg̃CfbNXԂ
	 * @return
	 */
	public static int getListIndex() {
		return ld.getList().getSelectedIndex();
	}

	/**
	 * Xg̃CfbNXw肷
	 * @return
	 */
	public static boolean setListIndex(int idx) {
		if (idx < 0 || idx >= lios.getCount()) return false;
		lios.moveIndexTo(idx);
		ld.getList().setSelectedIndex(idx);
		
		actionEditEdit();		
		return true;
	}

	/**
	 * Xg̍ڐԂ
	 * @return
	 */
	public static int getListCount() {
		return ld.getLsrc().size();
	}

	/**
	 * e[u\[hǂԂ
	 * @return
	 */
	public static boolean isTabled() {
		return ltb.isTabled();
	}

	/**
	 * GfBbgpl̊g嗦Ԃ
	 * @return
	 */
	public static double getEditImageRatio() {
		return ep.getRatio();
	}

	/**
	 * AhD[\ǂԂ
	 * @return
	 */
	public static boolean isUndoable() {
		return undom.isUndoable();
	}

	/**
	 * hD[\ǂԂ
	 * @return
	 */
	public static boolean isRedoable() {
		return undom.isRedoable();
	}

/*
 * IuWFNg̍XVƃZbg
 */
	/**
	 * Tangramw肵ăKChpl̍ĕ`
	 * @param tan
	 * @param forced
	 */
	public static void refreshGuidePanel(Tangram tan, boolean forced) {
		if ((!gtb.isLocked()) || forced) {
			gip.setTangram(tan);
		}
		gip.repaint();
	}

	/**
	 * PieceInfow肵ăKChpl̍ĕ`
	 * @param pi
	 * @param forced
	 */
	public static void refreshGuidePanel(PieceInfo pinfo, boolean forced) {
		if ((!gtb.isLocked()) || forced) {
			gip.setTangram(pinfo);
		}
		gip.repaint();
	}

	/**
	 * KChpl̍ĕ`
	 * @param forced
	 */
	public static void refreshGuidePanel() {
		gip.repaint();
	}

	/**
	 * Tangramw肵ĕҏWpl̍ĕ`
	 * @param tan
	 * @param forced
	 */
	public static void refreshEditPanel(Tangram tan) {
		ep.setTangram(tan);
		ep.repaint();
	}

	/**
	 * PieceInfow肵ĕҏWpl̍ĕ`
	 * @param pi
	 * @param forced
	 */
	public static void refreshEditPanel(PieceInfo pinfo) {
		ep.setTangram(pinfo);
		ep.repaint();
	}

	/**
	 * ҏWpl̍ĕ`
	 * @param pi
	 * @param forced
	 */
	public static void refreshEditPanel() {
		ep.repaint();
	}

	/**
	 * ҏWc[o[̍ĕ`
	 */
	public static void refreshEditToolBar() {
		etb.refresh();
		tb.refresh();
		menu.refresh();
	}

	/**
	 * Xgpl̍ĕ`
	 */
	public static void refreshListPanel() {
		int idx = ld.getList().getSelectedIndex();
		ld.getList().setListData(ld.getLsrc());
		ld.getList().setSelectedIndex(idx);
		lp.repaint();
	}

	/**
	 * Xgc[o[̍ĕ`
	 */
	public static void refreshListToolBar() {
		ltb.refresh();
		tb.refresh();
		menu.refresh();
	}

	/**
	 * Xe[^Xo[̍ĕ`
	 */
	public static void refreshStatuBar() {
		sb.refresh();
	}

	/**
	 * F̃Zbg
	 */
	public static void resetColors() {
		ep.resetColors();
		ep.repaint();

		gip.resetColors();
		gip.repaint();
	}

	/**
	 * AhD[obt@Zbg
	 */
	public static void resetUndom() {
		undom.reset(tan);
		undom.entry(tan);

		refreshEditToolBar();
	}

	/**
	 * AhD[obt@KXZbg
	 */
	public static void adpresetUndom() {
		if (undom.adpreset(tan)) {
			undom.entry(tan);
		}

		refreshEditToolBar();
	}

/*
 * ANV]t@C
 */
	/**
	 * I
	 */
	public static void actionFileExit() {
		if (!confirmationSave(ResourceManage.getString("message.exitwithchanged")))
			return;

		PropertyManage.writeProperties();
		System.exit(0);
	}

	/**
	 * Z[umF
	 */
	public static boolean confirmationSave(String mes) {
		if (isFileChanged()) {
			int ret = 
				JOptionPane.showConfirmDialog(
					(Component)null, mes,
					ResourceManage.getString("dialog.confirmation"),
					JOptionPane.INFORMATION_MESSAGE |
					JOptionPane.YES_NO_CANCEL_OPTION
				);
			switch (ret) {
			case JOptionPane.YES_OPTION:
				if (DEBUG) System.out.println("save");
				actionFileSave();
				break;
			case JOptionPane.NO_OPTION:
				break;
			default:
				if (DEBUG) System.out.println("cancel");
				return false;
			}
		}
		return true;
	}

	/**
	 * VK쐬
	 */
	public static void actionFileNew() {
		if (!confirmationSave(ResourceManage.getString("message.newwithchanged")))
			return;

		lios.clear();
		ld.resetListWithListios(lios);

		filechanged = false;

		if (gtb.isLocked()) gtb.toggleLocked();
		actionEditBreak();

		refreshListPanel();
		refreshListToolBar();
		refreshStatuBar();
	}

	/**
	 * t@CJ
	 */
	public static void actionFileOpen(String path) {
		if (!confirmationSave(ResourceManage.getString("message.newwithchanged")))
			return;

		String oldpuzzlename = tan.getPuzzleName();

		// _CAOJt@CI
		if (path == null) {
			path = chooseFile(null, PropertyManage.extension);
			if (path == null) return;
		}

		// jtet@Cǂݍ
		loadJteFile(tan, path, false);

		// t@Cǂݍ݌
		filechanged = false;

		ld.resetListWithListios(lios);
		if (lios.getCount() > 0) {
			ld.getList().setSelectedIndex(0);
			lios.moveIndexTo(0);
			tan.importPinfo(lios.get(lios.getIndex()));
			etb.setText(tan.getName());
		}

		// ނȂAhD[obt@p
		if (!(oldpuzzlename.equals(tan.getPuzzleName()))) {
			resetUndom();
		} else {
			actionEditEntry();
		}

		refreshEditPanel(tan);
		refreshEditToolBar();
		refreshGuidePanel(tan, true);

		ltb.setTabled(false);
		refreshListPanel();
		refreshListToolBar();
		refreshStatuBar();
	}

	/**
	 * s[XZbg̕ύX
	 */
	public static void actionFileKind() {
		String oldpuzzlename = tan.getPuzzleName();

		// _CAOJt@CI
		String path = chooseFile(null, PropertyManage.extension);
		if (path == null) return;

		// jtet@Cǂݍ
		loadJteFile(tan, path, true);

		// t@Cǂݍ݌
		filechanged = false;

		// ނȂAhD[obt@p
		if (!(oldpuzzlename.equals(tan.getPuzzleName()))) {
			resetUndom();
		} else {
			actionEditEntry();
		}
		// VGbgRs[
		getTangram().setName(tan.pinit.name.toString());

		refreshEditPanel(tan);
		refreshEditToolBar();
		refreshGuidePanel(tan, true);

		ltb.setTabled(false);
		refreshListPanel();
		refreshListToolBar();
		refreshStatuBar();
	}

	/**
	 * jtet@C̓ǂݍ
	 * @param tan_
	 * @param path
	 * @param pieceonly
	 */
	public static boolean loadJteFile(
		Tangram tan_,
		String path,
		boolean pieceonly
	) {
		if (lios.loadXML(tan_, path, pieceonly, false)) {
			// ǂݍݐ
			if (pieceonly) {
				// s[X̂ݓǂ񂾏ꍇ́AVKt@C
				lios.setName(
				ResourceManage.getString("newcorrectionname"));
			} else {
				// WȂ痚c
				PropertyManage.recentFiles.push(path);
			}

			return true;
		} else {
			// G[
			JOptionPane.showMessageDialog(
				(Component)null,
				ResourceManage.getString("message.jtefilereaderror"),
				ResourceManage.getString("dialog.error"),
				JOptionPane.ERROR_MESSAGE
			);
			return false;
		}
	}

	/**
	 * Otĕۑ
	 */
	public static void actionFileSaveAs() {
		// _CAOJt@CI
		String path = chooseFile(new File(lios.getName()).getName(),
									PropertyManage.extension);
		if (path == null) return;

		// t@C㏑mF
		if (new File(path).exists()) {
			int ret = 
				JOptionPane.showConfirmDialog(
					(Component)null,
					ResourceManage.getString("message.fileoverwrite"),
					ResourceManage.getString("dialog.confirmation"),
					JOptionPane.INFORMATION_MESSAGE |
					JOptionPane.YES_NO_CANCEL_OPTION
				);
			switch (ret) {
			case JOptionPane.YES_OPTION:
				if (DEBUG) System.out.println("overwrite");
				break;
			default:
				if (DEBUG) System.out.println("cancel save as");
				return;
			}
		}

		// jtet@C
		if (saveJteFile(tan, path)) {
			// ݐ
			filechanged = false;
			
			refreshStatuBar();
		}
	}

	/**
	 * ㏑ۑ
	 */
	public static void actionFileSave() {
		// VKt@CȂ疼Otĕۑ
		if (lios.getName().equals(
			ResourceManage.getString("newcorrectionname"))) {
			actionFileSaveAs();
			return;
		}

		// jtet@C
		if (saveJteFile(tan, lios.getName())) {
			// ݐ
			filechanged = false;

			refreshStatuBar();
		}
	}

	/**
	 * jtet@C̏
	 * @param tan_
	 * @param path
	 */
	private static boolean saveJteFile(
		Tangram tan_,
		String path
	) {
		if (lios.saveXML(tan_, path, false)) {
			// ݐ
			lios.setName(path);
			// c
			PropertyManage.recentFiles.push(path);
			refreshEditToolBar();
			return true;
		} else {
			// G[
			JOptionPane.showMessageDialog(
				(Component)null,
				ResourceManage.getString("message.jtefilewriteerror"),
				ResourceManage.getString("dialog.error"),
				JOptionPane.ERROR_MESSAGE
			);
			return false;
		}
	}

	/**
	 * t@CI_CAO
	 * @param defaultpath nullȂI[v_CAOA
	 * ȊOdefaultpathŃZ[u_CAOJ
	 * @return _CAOŃLZꂽnullAȊO̓t@CpX
	 */
	private static String chooseFile(String defaultpath, String extension) {
		String path;
		JFileChooser chooser = new JFileChooser();
		CustomizedFileFilter jff = new CustomizedFileFilter(extension);
		
		chooser.setFileFilter(jff);
		chooser.setCurrentDirectory(
			new File(PropertyManage.problemsfilepath));
		
		int ret;
		if (defaultpath == null) {
			// I[v_CAO
			ret = chooser.showOpenDialog(null);
		} else {
			// Z[u_CAO
			chooser.setSelectedFile(new File(defaultpath));
			ret = chooser.showSaveDialog(null);
		}			

		if (ret == JFileChooser.APPROVE_OPTION) {
			path = chooser.getSelectedFile().getPath();
			if (DEBUG) System.out.println("path : " + path);

			if (defaultpath != null) {
				// Z[ȕꍇAgq̃`FbNƕ⊮s
				if (!jff.accept(new File(path))) {
					path += "." + PropertyManage.extension;
				}
			}			
		} else {
			// _CAOŃLZꂽꍇ
			if (DEBUG) System.out.println("cancel dialog");
			path = null;
		}
		return path;
	}

	/**
	 * HTMLo
	 */
	public static void actionFileExportHTML(boolean isAnswer) {
		JteHtmlMaker jhm = new JteHtmlMaker();
		jhm.saveHTML(tan, lios, ep.getImgs(), isAnswer, tb.progbar);
	}
 /*
  * ANV]ҏW
  */
	/**
	 * s[X
	 */
	public static void actionEditBreak() {
		tan.breakup();
		etb.clearText();		
		actionEditEntry();
	
		ltb.setTabled(false);
		ltb.refresh();
		
		ep.repaint();
		refreshGuidePanel(tan, false);
	}
	
	/**
	 * ʂ̒
	 */
	public static void actionEditCentering() {
		tan.activeAll();
		tan.move(-tan.getActivesOriginX(), -tan.getActivesOriginY());
		tan.sleepAll();
		actionEditEntry();
	
		ltb.setTabled(false);
		ltb.refresh();
		
		ep.repaint();
		refreshGuidePanel(tan, false);
	}

	/**
	 * VGbgXgɑ}
	 */
	public static void actionEditInsert() {
		int idx = ld.getList().getSelectedIndex();
		idx = (idx < 0) ? 0 : idx;
	
		tan.setName(etb.getText());
		lios.moveIndexTo(idx);
		lios.add(etb.getText(), tan.exportPinfo());
	
		idx = lios.getIndex();
		ld.getLsrc().insertElementAt(tan.getName(), idx);
		ld.getList().setSelectedIndex(idx);
	
		filechanged = true;
	
		refreshListPanel();
		refreshListToolBar();
		refreshGuidePanel(tan, true);
		refreshStatuBar();
	}

	/**
	 * VGbgXgɏ㏑ǉ
	 */
	public static void actionEditAdd() {
		boolean exchange = false;

		if (lios.getCount() > 0) {
			// łȂ΁A܂͍폜
			int idx = ld.getList().getSelectedIndex();
			if (idx == lios.getCount() - 2) {
				// Ōォ2Ԗڂ̍ڂ͑}ɓւN
				exchange = true;
			}
			lios.moveIndexTo(idx);
	
			undom.virtualUndo();
			undom.entry(lios.get(idx));
			undom.entry(tan);
	
			lios.delete();
	
			ld.getLsrc().removeElementAt(idx);
			ld.getList().setSelectedIndex(lios.getIndex());
		}

		// Xgɒǉ
		actionEditInsert();		

		// ւ
		if (exchange) actionEditUp();
	}

	/**
	 * IꂽXg̃VGbg폜
	 */
	public static void actionEditDelete() {
		int idx = ld.getList().getSelectedIndex();
		lios.moveIndexTo(idx);

		undom.virtualUndo();
		undom.entry(lios.get(idx));
		undom.entry(tan);

		lios.delete();

		ld.getLsrc().removeElementAt(idx);
		ld.getList().setSelectedIndex(lios.getIndex());

		if (lios.getName().equals(ResourceManage.getString("newcorrectionname"))) {
			// VKt@CŋɂȂύXȂɂ
			filechanged = (lios.getCount() != 0);
		} else {
			filechanged = true;
		}

		refreshListPanel();
		refreshListToolBar();
		refreshEditToolBar();
		refreshGuidePanel(
			(lios.getCount() != 0) ?
				lios.get(getListIndex())
				: tan.pinfo
			, true);
		refreshStatuBar();
	}

	/**
	 * Xg̑IꂽڂPɈړ
	 */
	public static void actionEditUp() {
		int idx = getListIndex();
		PieceInfo pi = new PieceInfo();
		PieceInfoTool.copy(pi, lios.get(idx));

		lios.moveIndexTo(idx);
		lios.delete();
		ld.getLsrc().removeElementAt(idx);

		lios.moveIndexTo(idx-1);
		lios.insert(pi);
		ld.getLsrc().add(idx-1, pi.name);
		ld.getList().setSelectedIndex(idx-1);

		filechanged = true;

		refreshListPanel();
		refreshListToolBar();
		refreshStatuBar();
	}

	/**
	 * Xg̑IꂽڂPɈړ
	 */
	public static void actionEditDown() {
		int idx = getListIndex();
		PieceInfo pi = new PieceInfo();
		PieceInfoTool.copy(pi, lios.get(idx));

		lios.moveIndexTo(idx);
		lios.delete();
		ld.getLsrc().removeElementAt(idx);

		if (lios.moveIndexTo(idx+1)) {
			lios.insert(pi);
		} else {
			lios.add(pi);
		}
		ld.getLsrc().add(idx+1, pi.name);
		ld.getList().setSelectedIndex(idx+1);

		filechanged = true;

		refreshListPanel();
		refreshListToolBar();
		refreshStatuBar();		
	}

	/**
	 * IꂽXg̃VGbgҏWplɍڂ
	 */
	public static void actionEditEdit() {
		int idx = getListIndex();
		ltb.setTabled(false);
		ltb.refresh();
		
		refreshGuidePanel(lios.get(idx), true);
		refreshEditPanel(lios.get(idx));
		refreshEditToolBar();
		actionEditEntry();
	}

	/**
	 * AhD[obt@ɃGg[
	 */
	public static void actionEditEntry() {
		tan.setName(etb.getText());
		undom.entry(tan);

		refreshEditToolBar();
	}

	/**
	 * PieceInfoʓrw肵ăAhD[obt@ɃGg[
	 */
	public static void actionEditEntry(PieceInfo pi) {
		undom.entry(pi);

		refreshEditToolBar();
	}

	/**
	 * AhD[
	 *   @return Ȃtrue
	 */
	public static boolean actionEditUndo() {
		if (!undom.undo(tan)) return false;

		ltb.setTabled(false);
		ltb.refresh();
		
		ep.repaint();
		refreshGuidePanel(tan, false);
		refreshEditToolBar();

		return true;
	}

	/**
	 * hD[
	 *   @return Ȃtrue
	 */
	public static boolean actionEditRedo() {
		if (!undom.redo(tan)) return false;

		ltb.setTabled(false);
		ltb.refresh();
		
		ep.repaint();
		refreshGuidePanel(tan, false);
		refreshEditToolBar();

		return true;
	}

/*
 * ANV]IvV
 */
	/**
	 * Y[C
	 */
	public static void actionOptionZoomin() {
		actionOptionZoom(ep.getRatio() + 0.01);
	}

	/**
	 * Y[AEg
	 */
	public static void actionOptionZoomout() {
		actionOptionZoom(ep.getRatio() - 0.01);
	}

	/**
	 * Y[
	 *   @return Ȃtrue
	 */
	public static void actionOptionZoom(double ratio) {
		ep.setRatio(ratio);

		ep.repaint();
		refreshGuidePanel();
	}

	/**
	 * F̃Zbg
	 * @param n
	 * @return
	 */
	public static void actionOptionPalletSet(int n) {
		int r, g, b;
		if ((r = PropertyManage.palette_bR[n]) < 0) { r = PropertyManage.backgroundColor.getRed(); }
		if ((g = PropertyManage.palette_bG[n]) < 0) { g = PropertyManage.backgroundColor.getGreen(); }
		if ((b = PropertyManage.palette_bB[n]) < 0) { b = PropertyManage.backgroundColor.getBlue(); }
		PropertyManage.backgroundColor = new Color(r, g, b, 255);

		if ((r = PropertyManage.palette_0R[n]) < 0) { r = PropertyManage.piecesColor.getRed(); }
		if ((g = PropertyManage.palette_0G[n]) < 0) { g = PropertyManage.piecesColor.getGreen(); }
		if ((b = PropertyManage.palette_0B[n]) < 0) { b = PropertyManage.piecesColor.getBlue(); }
		PropertyManage.piecesColor = new Color(r, g, b, 255);

		if ((r = PropertyManage.palette_1R[n]) < 0) { r = PropertyManage.piecesColord.getRed(); }
		if ((g = PropertyManage.palette_1G[n]) < 0) { g = PropertyManage.piecesColord.getGreen(); }
		if ((b = PropertyManage.palette_1B[n]) < 0) { b = PropertyManage.piecesColord.getBlue(); }
		PropertyManage.piecesColord = new Color(r, g, b, 255);

		ep.resetColors();
		ep.repaint();
		gip.resetColors();
		refreshGuidePanel();
	}

	/**
	 * Fݒ̋L
	 */
	public static void actionOptionSavecolors() {
		PropertyManage.backgroundColor_stack = new Color(
				PropertyManage.backgroundColor.getRed(),
				PropertyManage.backgroundColor.getGreen(),
				PropertyManage.backgroundColor.getBlue(),
				255);
				
		PropertyManage.piecesColor_stack = new Color(
				PropertyManage.piecesColor.getRed(),
				PropertyManage.piecesColor.getGreen(),
				PropertyManage.piecesColor.getBlue(),
				255);
				
		PropertyManage.piecesColord_stack = new Color(
				PropertyManage.piecesColord.getRed(),
				PropertyManage.piecesColord.getGreen(),
				PropertyManage.piecesColord.getBlue(),
				255);
	}

	/**
	 * Fݒ̌Ăяo
	 */
	public static void actionOptionRestorecolors() {
		PropertyManage.backgroundColor = new Color(
				PropertyManage.backgroundColor_stack.getRed(),
				PropertyManage.backgroundColor_stack.getGreen(),
				PropertyManage.backgroundColor_stack.getBlue(),
				255);
				
		PropertyManage.piecesColor = new Color(
				PropertyManage.piecesColor_stack.getRed(),
				PropertyManage.piecesColor_stack.getGreen(),
				PropertyManage.piecesColor_stack.getBlue(),
				255);
				
		PropertyManage.piecesColord = new Color(
				PropertyManage.piecesColord_stack.getRed(),
				PropertyManage.piecesColord_stack.getGreen(),
				PropertyManage.piecesColord_stack.getBlue(),
				255);

		ep.resetColors();
		ep.repaint();
		gip.resetColors();
		refreshGuidePanel();
	}

	/**
	 * Jcsc_CAOɂFI
	 * @param key
	 * @param defaultcolor
	 * @return
	 */
	public static void actionOptionSetColor(String key, Color defaultColor) {
		if (jcsc == null) {
			jcsc = new Jcsc(
				PropertyManage.defaultColordicFilePath,
				PropertyManage.defaultColordic2ndFilePath);
		}

		jcsc.setTitle(ResourceManage.getString(key));
		jcsc.setDefaultColor(defaultColor);
		jcsc.setVisible(true);

		Color color = jcsc.getChosenColor();

		if (color != null) {
			if (key.equals("option.editbgcolor")) PropertyManage.backgroundColor = color;
			if (key.equals("option.editfgheadscolor")) PropertyManage.piecesColor = color;
			if (key.equals("option.editfgtailscolor")) PropertyManage.piecesColord = color;
		}

		ep.resetColors();
		ep.repaint();
		gip.resetColors();
		refreshGuidePanel();
	}

	/**
	 * ݒύX̔f
	 */
	public static void actionOptionConfig() {
		ep.loadConfigurations();
		ep.repaint();
		refreshGuidePanel();
	}

/*
 * ANV]wv
 */

}