package jte;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Toolkit;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JApplet;
import javax.swing.JFrame;
import javax.swing.JMenuBar;
import javax.swing.UIManager;

import jte.editpanel.EditPanel;
import jte.editpanel.EditToolBar;
import jte.guidepanel.GuideImagePanel;
import jte.guidepanel.GuideToolBar;
import jte.listpanel.ListData;
import jte.listpanel.ListPanel;
import jte.listpanel.ListToolBar;
import jte.mainframe.Layout;
import jte.mainframe.Menu;
import jte.mainframe.StatusBar;
import jte.mainframe.ToolBar;
import tangram.Tangram;
import tangram.svcs.Listios;
import tangram.svcs.Undom;

/**
 * NNX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class Main extends JApplet {

	/** 
	 * AvP[V
	 */
	public static void main(String args[]) {
		Main main = new Main();

		JFrame f = new JFrame(PropertyManage.applicationname);
		f.addWindowListener(new WindowAdapter() {
			public void windowClosing(WindowEvent e) {
				Common.actionFileExit();
			}
		});
		f.pack();

		Dimension screenSize =
			Toolkit.getDefaultToolkit().getScreenSize();
		int prefw = 680;
		int prefh = 600;
		int w = screenSize.width;
		int h = screenSize.height;
		double ratio = Math.min(w*0.75/prefw, h*0.75/prefh);
		if( ratio > 1.0 ){
			prefw = (int)((double)prefw * ratio);
			prefh = (int)((double)prefh * ratio);
		}
		f.getContentPane().add("Center", main);
		f.setSize(prefw, prefh);
		f.setMinimumSize(new Dimension(600, 480));
		f.setLocation((w-prefw)/2, (h-prefh)/2);

		PropertyManage.editImageRatio = ratio;
		main.initialize(f, false);
		main.start();

		f.setVisible(true);
	}

	/**
	 * [`
	 *   @param isApplet AvP[VȂ̂ŏfalse
	 */
	public void initialize(JFrame f, boolean isApplet) {
		try {
			UIManager.setLookAndFeel(
				UIManager.getSystemLookAndFeelClassName());
		} catch (Exception e) {
			System.err.println("Error loading L&F: " + e);
		}
		
		ResourceManage.initialize();
		PropertyManage.initialize();

		Tangram tan = new Tangram();
		Listios lios = new Listios(
			ResourceManage.getString("newcorrectionname"));
		Undom undom = new Undom(100);

		Common.setTangramParts(tan, lios, undom);

		Menu menu = new Menu();
		StatusBar sb = new StatusBar();

		ToolBar tb = new ToolBar();
		ListToolBar ltb = new ListToolBar();
		EditToolBar etb = new EditToolBar();
		ListData ld = new ListData();
		ListPanel lp = new ListPanel(ld);
		EditPanel ep = new EditPanel();
		GuideToolBar gtb = new GuideToolBar();
		GuideImagePanel gip = new GuideImagePanel(gtb);

		Layout layout =
			new Layout(
				tb, ep, etb, gip, gtb, lp, ltb);

		setLayout(new BorderLayout());
		setJMenuBar((JMenuBar) menu);
		add(layout, BorderLayout.CENTER);
		add(sb, BorderLayout.SOUTH);

		Common.setEditorParts(
			menu, sb,
			tb, ep, etb, gip, gtb, ld, lp, ltb);

		Common.resetUndom();
		Common.resetColors();
		Common.refreshEditToolBar();
		Common.refreshGuidePanel(tan, true);
		Common.refreshListPanel();
		Common.refreshListToolBar();
		Common.refreshStatuBar();
	}
}
