package jte;

import java.awt.Color;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.Properties;

/**
 * vpeB[}l[W
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.2  20 May 2007
 */
public class PropertyManage {
	private static final boolean DEBUG = false;			// fobOp
	
	// 萔
	public static final String applicationname = "javade Tangram editor";
	public static final String applicationver = "0.55";
	public static final String problemsfilepath = "jtes";
	public static final String extension = "jte";

	private static final String propfilepath = "jte.properties";
	
	public static final String defaultColordicFilePath = "colordic.xml";
	public static final String defaultColordic2ndFilePath = "resources/data/colordic/colordic.xml";

	public static final int IMAGEQUALITY_NORMAL = 0;
	public static final int IMAGEQUALITY_BETTER = 1;
	public static final int IMAGEQUALITY_BEST = 2;
	public static final int PALETTES = 10;

	// vpeB[
	private static Properties prop = null;
	public static int recentFilesMax = 8;
	public static RecentFiles recentFiles = new RecentFiles(recentFilesMax);
	public static Color backgroundColor = new Color(255,255,255,255);
	public static Color piecesColor = new Color(0,0,0,255);
	public static Color piecesColord = new Color(0,0,0,255);
	public static Color backgroundColor_stack = new Color(255,255,255,255);
	public static Color piecesColor_stack = new Color(0,0,0,255);
	public static Color piecesColord_stack = new Color(0,0,0,255);

	public static int editImageQuality = IMAGEQUALITY_BETTER;
	public static int guideImageQuality = IMAGEQUALITY_BEST;
	public static double editImageRatio = 1.0;
	public static double guideImageRatio = 0.25;
	public static double monitorGamma = 1.0;
	public static int vertexAttach = 1;
	public static int adaptiveRotation = 0;
	
	public static int[] palette_bR = {255,0,-1,-1,-1,-1,-1,-1,-1,-1};
	public static int[] palette_bG = {255,0,-1,-1,-1,-1,-1,-1,-1,-1};
	public static int[] palette_bB = {255,0,-1,-1,-1,-1,-1,-1,-1,-1};
	public static int[] palette_0R = {0,255,247,204,212,58,90,198,255,241};
	public static int[] palette_0G = {0,255,101,182,238,169,56,49,255,241};
	public static int[] palette_0B = {0,255,116,200,199,46,103,50,255,230};
	public static int[] palette_1R = {0,255,174,17,90,252,13,133,255,255};
	public static int[] palette_1G = {0,255,68,193,119,63,96,38,70,255};
	public static int[] palette_1B = {0,255,87,92,75,82,37,33,84,255};


	public PropertyManage() {
	}

	public static void initialize() {
		prop = new Properties();
		readProperties();
	}
	
	/**
	 * vpeB[ǂݍ
	 * @return
	 */
	public static boolean readProperties() {
		FileInputStream fis;
		BufferedInputStream bis;
		try {
			fis = new FileInputStream(propfilepath);
			bis = new BufferedInputStream(fis);
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		try {
			prop.load((InputStream)bis);
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		readPropertiesToVals();

		try {
			bis.close();
			fis.close();
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		return true;
	}

	/**
	 * vpeB[̓ǂݍ݂ƓWJ
	 */
	private static void readPropertiesToVals() {
		int temp = getInteger("recentFileNum");
		if (temp > 0) {
			recentFiles.changeSize(temp);
			recentFilesMax = temp;
		}
		for (int i = 0; i < recentFilesMax; i++) {
			String s = getString("recentFile"+(recentFilesMax-(i+1)));
			if (s != null) {
				recentFiles.push(s);
			}
		}
		
		backgroundColor = new Color(
				getInteger("backgroundColor_R"),
				getInteger("backgroundColor_G"),
				getInteger("backgroundColor_B"),
				255
				);
				piecesColor = new Color(
				getInteger("piecesColor_R"),
				getInteger("piecesColor_G"),
				getInteger("piecesColor_B"),
				255
				);
				piecesColord = new Color(
				getInteger("piecesColord_R"),
				getInteger("piecesColord_G"),
				getInteger("piecesColord_B"),
				255
				);

		backgroundColor_stack = new Color(
				getInteger("backgroundColor_stack_R"),
				getInteger("backgroundColor_stack_G"),
				getInteger("backgroundColor_stack_B"),
				255
				);
		piecesColor_stack = new Color(
				getInteger("piecesColor_stack_R"),
				getInteger("piecesColor_stack_G"),
				getInteger("piecesColor_stack_B"),
				255
				);
		piecesColord_stack = new Color(
				getInteger("piecesColord_stack_R"),
				getInteger("piecesColord_stack_G"),
				getInteger("piecesColord_stack_B"),
				255
				);

		/* Œpbg̓fBtHglg
		for (int i = 0; i < PALETTES; i++) {
			palette_bR[i] = getInteger("palette"+i+"_bR");
			palette_bG[i] = getInteger("palette"+i+"_bG");
			palette_bB[i] = getInteger("palette"+i+"_bB");
			palette_0R[i] = getInteger("palette"+i+"_0R");
			palette_0G[i] = getInteger("palette"+i+"_0G");
			palette_0B[i] = getInteger("palette"+i+"_0B");
			palette_1R[i] = getInteger("palette"+i+"_1R");
			palette_1G[i] = getInteger("palette"+i+"_1G");
			palette_1B[i] = getInteger("palette"+i+"_1B");
		}
		*/

		editImageRatio = getDouble("editImageRatio");
		editImageQuality = getInteger("editImageQuality");
		guideImageRatio = getDouble("guideImageRatio");
		guideImageQuality = getInteger("guideImageQuality");
		monitorGamma = getDouble("monitorGamma");
		vertexAttach = getInteger("vertexAttach");
		adaptiveRotation = getInteger("adaptiveRotation");
	}

	/**
	 * vpeB[
	 * @return
	 */
	public static boolean writeProperties() {
		FileOutputStream fos;
		BufferedOutputStream bos;
		try {
			fos = new FileOutputStream(propfilepath);
			bos = new BufferedOutputStream(fos);
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		writeValsToProperties();

		try {
			prop.store((OutputStream)bos, null);
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		try {
			bos.close();
			fos.close();
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		return true;
	}

	/**
	 * vpeB[̏߂
	 */
	private static void writeValsToProperties() {
		putInteger("recentFileNum", recentFilesMax);
		for (int i = 0; i < recentFiles.size(); i++) {
			putString("recentFile"+i, recentFiles.get(i));
		}
		
		putInteger("backgroundColor_R", backgroundColor.getRed());
		putInteger("backgroundColor_G", backgroundColor.getGreen());
		putInteger("backgroundColor_B", backgroundColor.getBlue());

		putInteger("piecesColor_R", piecesColor.getRed());
		putInteger("piecesColor_G", piecesColor.getGreen());
		putInteger("piecesColor_B", piecesColor.getBlue());

		putInteger("piecesColord_R", piecesColord.getRed());
		putInteger("piecesColord_G", piecesColord.getGreen());
		putInteger("piecesColord_B", piecesColord.getBlue());

		putInteger("backgroundColor_stack_R", backgroundColor_stack.getRed());
		putInteger("backgroundColor_stack_G", backgroundColor_stack.getGreen());
		putInteger("backgroundColor_stack_B", backgroundColor_stack.getBlue());

		putInteger("piecesColor_stack_R", piecesColor_stack.getRed());
		putInteger("piecesColor_stack_G", piecesColor_stack.getGreen());
		putInteger("piecesColor_stack_B", piecesColor_stack.getBlue());

		putInteger("piecesColord_stack_R", piecesColord_stack.getRed());
		putInteger("piecesColord_stack_G", piecesColord_stack.getGreen());
		putInteger("piecesColord_stack_B", piecesColord_stack.getBlue());

		/* Œpbg̓fBtHglg
		for (int i = 0; i < PALETTES; i++) {
			putInteger("palette"+i+"_bR", palette_bR[i]);
			putInteger("palette"+i+"_bG", palette_bG[i]);
			putInteger("palette"+i+"_bB", palette_bB[i]);
			putInteger("palette"+i+"_0R", palette_0R[i]);
			putInteger("palette"+i+"_0G", palette_0G[i]);
			putInteger("palette"+i+"_0B", palette_0B[i]);
			putInteger("palette"+i+"_1R", palette_1R[i]);
			putInteger("palette"+i+"_1G", palette_1G[i]);
			putInteger("palette"+i+"_1B", palette_1B[i]);
		}
		*/
		
		putDouble("editImageRatio", editImageRatio);
		putInteger("editImageQuality", editImageQuality);
		putDouble("guideImageRatio", guideImageRatio);
		putInteger("guideImageQuality", guideImageQuality);
		putDouble("monitorGamma", monitorGamma);
		putInteger("vertexAttach", vertexAttach);
		putInteger("adaptiveRotation", adaptiveRotation);
	}

	/**
	 * L[當𓾂
	 * @param key
	 * @return
	 */
	public static String getString(String key) {
		if (DEBUG)
			System.out.println(key + "=" + prop.getProperty(key));
		String ret;
		try {
			ret = prop.getProperty(key);
		} catch(Exception e) {
			System.out.println(key+":"+e);
			ret = null;
		}
		return ret;
	}

	/**
	 * L[琮𓾂
	 * @param key
	 * @return
	 */
	public static int getInteger(String key) {
		String s = getString(key);
		
		if (s == null) {
			return 0;
		} else {
			return Integer.parseInt(s);
		}
	}

	/**
	 * L[𓾂
	 * @param key
	 * @return
	 */
	public static double getDouble(String key) {
		String s = getString(key);
		
		if (s == null) {
			return 0;
		} else {
			return Double.parseDouble(s);
		}
	}

	/**
	 * L[ɕݒ
	 * @param key
	 * @param value
	 */
	public static void putString(String key, String value) {
		if (DEBUG) System.out.println(key + "=" + value);
		try {
			prop.setProperty(key, value);
		} catch(Exception e) {
			System.out.println(key+":"+e);
		}
	}

	/**
	 * L[ɐݒ
	 * @param key
	 * @param value
	 */
	public static void putInteger(String key, int value) {
		putString(key, Integer.toString(value));
	}

	/**
	 * L[Ɏݒ
	 * @param key
	 * @param value
	 */
	public static void putDouble(String key, double value) {
		putString(key, Double.toString(value));
	}

}
