package jte;

import java.awt.Image;
import java.util.Hashtable;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

/**
 * \[X}l[W
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class ResourceManage {
	private static Hashtable<String, Image> images = null;
	private static ResourceBundle bundle = null;

	/**
	 * RXgN^
	 */
	public ResourceManage() {
	}

	/**
	 * 
	 */
	public static void initialize() {
		loadImages();
	}

	/**
	 * 摜̃[h
	 */
	private static void loadImages() {
		String imagedir = "resources/data/icons/";
		String [] imagefiles = {
			"add",			"break",		"centering",
			"edit",			"dropdown",		"down",
			"open",			"insert",		"kind",
			"lock",			"new",			"palette",
			"redo",			"save",			"table",
			"trash",		"undo",			"unlock",
			"up",							"zoom",
			"zoomin",		"zoomout",		"config",
			"tool",			"help",
			"palette0",		"palette1",		"palette2",
			"palette3",		"palette4",		"palette5",
			"palette6",		"palette7",		"palette8",
			"palette9",		"editbgcolor",
			"editfgheadscolor",		"editfgtailscolor",
			"unfilling"
		};

		ImageLoader il = new ImageLoader();
		images = il.load(imagedir, imagefiles);
	}

	/**
	 * 摜Ԃ
	 * @param name
	 * @return
	 */
	public static Image getImage(String name) {
		return (Image)images.get(name);
	}

	/**
	 * resource bundleL[ɐݒ肳Ă镶Ԃ
	 * @param key
	 * @return
	 */
	public static String getString(String key) {
		String value = null;
		try {
			value = getResourceBundle().getString(key);
		} catch (MissingResourceException e) {
			System.out.println("Couldn't find value for: " + key);
		}
		if(value == null) {
			value = "";
		}
		return value;
	}

	/**
	 * resource bundleASCIIϊL[ɐݒ肳Ă镶Ԃ
	 * @param src
	 * @return
	 */
	public static String getTranslation(String src) {
		String s = "";
		for (int n = 0; n < src.length(); n++) {
			s += Integer.toHexString((int)src.charAt(n));
		}
		String dst = getString("translation." + s);
		if (dst == "") {
			dst = src;
		}
		return dst;
	}

	/**
	 * resource bundleԂ
	 * @return
	 */
	public static ResourceBundle getResourceBundle() {
		if(bundle == null) {
			bundle = ResourceBundle.getBundle(
				"resources.data.locale.discription");
		}
		return bundle;
	}
}
