package jte.editpanel;

import java.awt.Dimension;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JTextField;
import javax.swing.JToolBar;

import jte.Common;
import jte.ResourceManage;

/**
 * ҏWc[o[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class EditToolBar extends JToolBar implements ActionListener {
	private final boolean DEBUG = false;			// fobOp

	private JTextField	input;
	private JButton insertbt;
	private JButton addbt;
	private JButton undobt;
	private JButton redobt;

	/**
	 * RXgN^
	 * @param resm
	 * @param propm
	 * @param cmn
	 */
	public EditToolBar() {
		setFloatable(false);

		add(insertbt = createButton("insert", this));
		add(addbt = createButton("add", this));
		add(undobt = createButton("undo", this));
		add(redobt = createButton("redo", this));
		add(createButton("centering", this));
		addSeparator();

		add(createButton("break", this));
		addSeparator(new Dimension(2,0));

		input = new JTextField();
		input.setMargin(new Insets(0,4,0,4));
		input.setEditable(true);
		input.setEnabled(true);
		input.setToolTipText(ResourceManage.getString("edit.input"));
		add(input);

		insertbt.addMouseListener(new EditToolBarMouseListener(this));
		addbt.addMouseListener(new EditToolBarMouseListener(this));
		addbt.setVisible(false);

	}

	/**
	 * }EXA_v^[
	 * @author QXg
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private class EditToolBarMouseListener extends MouseAdapter {
		EditToolBar target;

		/**
		 * RXgN^
		 * @param target
		 */
		public EditToolBarMouseListener(EditToolBar target) {
			this.target = target;
		}

		/**
		 * ENbN
		 */
		public void mouseClicked(MouseEvent e) {
			if (e.getButton() == MouseEvent.BUTTON3) {
				toggleAddInsertMode();
			 }
		}
	}

	/**
	 * ǉ[h̐؂ւ
	 */
	public void toggleAddInsertMode() {
		if (insertbt.isVisible()) {
			insertbt.setVisible(false);
			addbt.setVisible(true);
		} else {
			insertbt.setVisible(true);
			addbt.setVisible(false);
		}
		repaint();
	}

	/**
	 * {^쐬
	 * @param resm
	 * @param name
	 * @return
	 */
	private JButton createButton(String name, EditToolBar etb) {
		JButton bt = new JButton("",
			new ImageIcon(ResourceManage.getImage(name)));
		bt.setBorderPainted(false);
		bt.setRolloverEnabled(true);
		bt.setMargin(new Insets(0,0,0,0));
		bt.setFocusable(false);
		bt.setText(null);
		bt.setToolTipText(ResourceManage.getString("edit." + name));
		bt.setActionCommand("edit." + name);
		bt.addActionListener(etb);
		return bt;
	}

	/**
	 * eLXgtB[h̕Ԃ
	 * @return
	 */
	public String getText() {
		return input.getText();
	}

	/**
	 * eLXgtB[hɕݒ
	 * @return
	 */
	public void setText(String s) {
		input.setText(s);
	}

	/**
	 * eLXgtB[hNA
	 */
	public void clearText() {
		input.setText("");
	}

	/**
	 * ҏWc[o[̃tbV
	 */
	public void refresh() {
		input.setText(Common.getTangram().getName());
		undobt.setEnabled(Common.isUndoable());
		redobt.setEnabled(Common.isRedoable());
	}

	/**
	 * ANVfBXpb`
	 */
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (DEBUG) System.out.println(command);

		if (e.getSource() instanceof JButton) {
			if (command.equals("edit.insert")) {
				Common.actionEditInsert();
				return;
			}
			if (command.equals("edit.add")) {
				Common.actionEditAdd();
				return;
			}
			if (command.equals("edit.undo")) {
				Common.actionEditUndo();
				return;
			}
			if (command.equals("edit.redo")) {
				Common.actionEditRedo();
				return;
			}
			if (command.equals("edit.break")) {
				Common.actionEditBreak();
				return;
			}
			if (command.equals("edit.centering")) {
				Common.actionEditCentering();
				return;
			}
		}
	}	
}
