package jte.guidepanel;

import java.awt.BorderLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;

import jte.Common;
import jte.ResourceManage;


/**
 * KChc[o[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.2  20 May 2007
 */
public class GuideToolBar extends JToolBar implements ActionListener {
	private final boolean DEBUG = false;			// fobOp

	private JButton		lbt;
	private ImageIcon	iil;
	private ImageIcon	iiul;
	private String		tttxtl;
	private String		tttxtul;

	private JToggleButton	ufbt;

	private boolean		locked;

	public GuideToolBar() {
		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
		setFloatable(false);

		iil  = new ImageIcon(ResourceManage.getImage("lock"));
		iiul = new ImageIcon(ResourceManage.getImage("unlock"));
		tttxtl  = ResourceManage.getString("guide.lock");
		tttxtul = ResourceManage.getString("guide.unlock");

		lbt = new JButton("", iiul);
		lbt.setBorderPainted(false);
		lbt.setRolloverEnabled(true);
		lbt.setMargin(new Insets(0,0,0,0));
		lbt.setFocusable(false);
		lbt.setText(null);
		lbt.setActionCommand("togglelock");
		lbt.addActionListener(this);
		add(lbt, BorderLayout.NORTH);

		ufbt = new JToggleButton("",
			new ImageIcon(ResourceManage.getImage("unfilling")));
		ufbt.setBorderPainted(false);
		ufbt.setRolloverEnabled(true);
		ufbt.setMargin(new Insets(0,0,0,0));
		ufbt.setFocusable(false);
		ufbt.setText(null);
		ufbt.setToolTipText(ResourceManage.getString("guide.unfilling"));
		ufbt.setActionCommand("toggleunfilling");
		ufbt.addActionListener(this);
		add(ufbt, BorderLayout.SOUTH);

		locked = false;
		setLockButton();

	}
	
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (DEBUG) System.out.println(command);

		if (e.getSource() instanceof JButton) {
			if (command.equals("togglelock")) { toggleLocked(); return; }
		}
		if (e.getSource() instanceof JToggleButton) {
			if (command.equals("toggleunfilling")) { Common.refreshGuidePanel(); return; }
		}
	}	

	/*
	 * bN
	 */
	public boolean isLocked() {
		return locked;
	}

	public void toggleLocked() {
		locked = !locked;
		setLockButton();
	}

	public void setLockButton() {
		if (locked) {
			lbt.setIcon(iil);
			lbt.setToolTipText(tttxtl);
		} else {
			lbt.setIcon(iiul);
			lbt.setToolTipText(tttxtul);			
		}
	}

	/*
	 * KCh摜hԂݒ
	 */
	public boolean isUnfilling() {
		return ufbt.isSelected();
	}

}
