package jte.listpanel;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.BoxLayout;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.ListCellRenderer;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import jte.Common;

/**
 * Xgpl
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class ListPanel extends JPanel{
	private JList ls;
	//private Vector<String> lsrc;
	private JScrollPane scrollPane;
	
	/**
	 * RXgN^
	 * @param resm
	 * @param propm
	 * @param cmn
	 */
	public ListPanel(ListData ld) {
		this.ls = ld.getList();
		//this.lsrc = ld.getLsrc();

		SilhouettesListCellRenderer cr =
			new SilhouettesListCellRenderer(); 
		ls.setCellRenderer(cr);
		ls.setFont(new Font(ls.getFont().getName(), 0, 12));
		ls.setFixedCellHeight(14);
		ls.setFixedCellWidth(128);
		ls.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);

		setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));

		scrollPane = new JScrollPane(ls);
		scrollPane.setAutoscrolls(true);
		scrollPane.setWheelScrollingEnabled(true);
		add(scrollPane);

		ls.addListSelectionListener(new ListPanelListener(this));
		ls.addMouseListener(new ListPanelMouseListener(this));
	}

	/**
	 * XN[yCԂ
	 * @return
	 */
	public JScrollPane getScrollPane() {
		return scrollPane;
	}

	/**
	 * XgZNVXi[
	 * @author QXg
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private class ListPanelListener implements ListSelectionListener {
		ListPanel target;
	
		/**
		 * RXgN^
		 * @param target
		 */
		public ListPanelListener(ListPanel target) {
			this.target = target;
		}

		/**
		 * Jg̕ω
		 */
		public void valueChanged(ListSelectionEvent e) {
			int idx = target.ls.getSelectedIndex();
			if (idx < 0) return;

			Common.refreshGuidePanel(Common.getListios().get(idx), true);
			Common.refreshListToolBar();

			if (Common.isTabled()) {
				Common.refreshEditPanel();
			}
		}
	}

	/**
	 * }EXA_v^[
	 * @author QXg
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private class ListPanelMouseListener extends MouseAdapter {
		ListPanel target;

		/**
		 * RXgN^
		 * @param target
		 */
		public ListPanelMouseListener(ListPanel target) {
			this.target = target;
		}

		/**
		 * _uNbN
		 */
		public void mouseClicked(MouseEvent e) {
			if (e.getClickCount() == 2) {
				Common.actionEditEdit();
			}
		}
	}

	/**
	 * _[
	 * @author QXg
	 *
	 * To change the template for this generated type comment go to
	 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
	 */
	private class SilhouettesListCellRenderer extends JPanel implements ListCellRenderer {
		int index;
		String s;
		JList ls;
		boolean iS;

		/**
		 * RXgN^
		 */
		public SilhouettesListCellRenderer() {
			setOpaque(true);
		}

		public Component getListCellRendererComponent(
			JList list,
			Object value,
			int index,
			boolean isSelected,
			boolean cellHasFocus)
		{
			ls = list;
			iS = isSelected;
			s = value.toString();
			this.index = index;
			return this;
		}

		public void paint(Graphics g) {
			int x = 1;
			int n = index + 1;
			for (; n >= 10; n /= 10) x++;

			g.setColor(iS ? ls.getSelectionBackground() : ls.getBackground());
			g.fillRect(0,0,191,15);
			g.setColor(Color.GRAY);
			g.drawString(Integer.toString(index + 1)+".", 24-x*6, 12);
			g.setColor(iS ? ls.getSelectionForeground() : ls.getForeground());
			g.drawString(s,32,12);
		}
	}
}
