package jte.listpanel;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JToggleButton;
import javax.swing.JToolBar;

import jte.Common;
import jte.ResourceManage;

/**
 * Xgc[o[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class ListToolBar extends JToolBar implements ActionListener {
	private final boolean DEBUG = false;			// fobOp

	private JToggleButton ttbt = null;
	private JButton trashbt = null;
	private JButton upbt = null;
	private JButton downbt = null;
	private JButton editbt = null;

	/**
	 * RXgN^
	 * @param resm
	 * @param propm
	 * @param cmn
	 */
	public ListToolBar() {
		setFloatable(false);

		add(trashbt = createButton("trash", this));
		add(upbt = createButton("up", this));
		add(downbt = createButton("down", this));
		add(editbt = createButton("edit", this));
		addSeparator();

		ttbt = new JToggleButton("",
			new ImageIcon(ResourceManage.getImage("table")));
		ttbt.setBorderPainted(false);
		ttbt.setRolloverEnabled(true);
		ttbt.setMargin(new Insets(0,0,0,0));
		ttbt.setFocusable(false);
		ttbt.setText(null);
		ttbt.setToolTipText(ResourceManage.getString("edit.table"));
		ttbt.setActionCommand("edit.table");
		ttbt.addActionListener(this);
		add(ttbt);

		ttbt.setSelected(false);
	}

	/**
	 * {^̐
	 * @param resm
	 * @param name
	 * @param ltb
	 * @return
	 */
	private JButton createButton(String name, ListToolBar ltb) {
		JButton bt = new JButton("",
			new ImageIcon(ResourceManage.getImage(name)));
		bt.setBorderPainted(false);
		bt.setRolloverEnabled(true);
		bt.setMargin(new Insets(0,0,0,0));
		bt.setFocusable(false);
		bt.setText(null);
		bt.setToolTipText(ResourceManage.getString("edit." + name));
		bt.setActionCommand("edit." + name);
		bt.addActionListener(ltb);
		return bt;
	}

	/**
	 * ANVfBXpb`
	 */
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (DEBUG) System.out.println(command);

		if (e.getSource() instanceof JButton) {
			if (command.equals("edit.edit")) { Common.actionEditEdit(); return; }
			if (command.equals("edit.trash")) { Common.actionEditDelete(); return; }
			if (command.equals("edit.up")) { Common.actionEditUp(); return; }
			if (command.equals("edit.down")) { Common.actionEditDown(); return; }
		}
		if (e.getSource() instanceof JToggleButton) {
			if (command.equals("edit.table")) { Common.refreshEditPanel(); return; }
		}
	}	

	/**
	 * e[u\[hǂԂ
	 * @return
	 */
	public boolean isTabled() {
		if (ttbt == null) return false;

		return ttbt.isSelected();
	}

	/**
	 * e[u\[hZbg
	 * @param flag
	 */
	public void setTabled(boolean flag) {
		ttbt.setSelected(flag);
	}

	/**
	 * tbV
	 */
	public void refresh() {
		trashbt.setEnabled(Common.getListCount() > 0);
		upbt.setEnabled(Common.getListIndex() > 0);
		downbt.setEnabled(Common.getListIndex() < Common.getListCount()-1);
		editbt.setEnabled(Common.getListIndex() >= 0);
		if (Common.getListCount() <= 0) {
			if (ttbt.isSelected()) {
				ttbt.setSelected(false);
				Common.refreshEditPanel();
			}
			ttbt.setEnabled(false);
		} else {
			ttbt.setEnabled(true);
		}
		repaint();
	}
}
