package jte.mainframe;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;

import javax.swing.JPanel;
import javax.swing.border.CompoundBorder;
import javax.swing.border.EmptyBorder;
import javax.swing.border.EtchedBorder;
import javax.swing.border.TitledBorder;

import jte.ResourceManage;
import jte.editpanel.EditPanel;
import jte.editpanel.EditToolBar;
import jte.guidepanel.GuideImagePanel;
import jte.guidepanel.GuideToolBar;
import jte.listpanel.ListPanel;
import jte.listpanel.ListToolBar;

/**
 * t[CAEg
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class Layout extends JPanel {

	public Layout(
		ToolBar tb,
		EditPanel ep,
		EditToolBar etb,
		GuideImagePanel gip,
		GuideToolBar gtb,
		ListPanel lp,
		ListToolBar ltb
		) {
			setLayout(new BorderLayout());

			JPanel mp = new JPanel();
			mp.setLayout(new BorderLayout());

			JPanel gp = new JPanel();
			gp.setLayout(new FlowLayout(FlowLayout.CENTER));
			gp.setBorder(new CompoundBorder(
				new TitledBorder(null, ResourceManage.getString("guide"),
				TitledBorder.CENTER, TitledBorder.BOTTOM),
				new EmptyBorder(0,0,0,0)));
			gp.add(gtb);
			gp.add(gip);

			JPanel sp1n = new JPanel();
			sp1n.setLayout(new BorderLayout());
			sp1n.setPreferredSize(new Dimension(180,192));
			sp1n.add(gp, BorderLayout.CENTER);
			sp1n.add(ltb, BorderLayout.SOUTH);

			JPanel sp1 = new JPanel();
			sp1.setLayout(new BorderLayout());
			sp1.setPreferredSize(new Dimension(180,0));
			sp1.add(sp1n, BorderLayout.NORTH);
			sp1.add(lp, BorderLayout.CENTER);
			mp.add(sp1, BorderLayout.WEST);		

			JPanel sp2 = new JPanel();
			sp2.setLayout(new BorderLayout());
			sp2.setBorder(new EtchedBorder());
			sp2.add(ep, BorderLayout.CENTER);
			sp2.add(etb, BorderLayout.NORTH);
			mp.add(sp2, BorderLayout.CENTER);		

			add(tb, BorderLayout.NORTH);
			add(mp, BorderLayout.CENTER);
		}
}
