package jte.mainframe;

import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.InputEvent;
import java.util.ArrayList;

import javax.swing.ButtonGroup;
import javax.swing.Icon;
import javax.swing.ImageIcon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JRadioButtonMenuItem;
import javax.swing.KeyStroke;

import jte.Common;
import jte.PropertyManage;
import jte.ResourceManage;

/**
 * j[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class Menu extends JMenuBar implements ActionListener {
	private final boolean DEBUG = false;			// fobOp

	private JMenuItem undomi;
	private JMenuItem redomi;
	private JMenuItem trashmi;
	private JMenuItem editmi;
	private JMenuItem upmi;
	private JMenuItem downmi;
	private JMenuItem kindmi;
	ArrayList<JMenuItem> filesmi;

	private ButtonGroup btgeiq;
	private JRadioButtonMenuItem eiqbetter;
	private JRadioButtonMenuItem eiqnormal;
	private ButtonGroup btggiq;
	private JRadioButtonMenuItem giqbest;
	private JRadioButtonMenuItem giqbetter;
	private JRadioButtonMenuItem giqnormal;
	private JCheckBoxMenuItem vtxatt;
	private JCheckBoxMenuItem adprot;
	
	/**
	 * RXgN^
	 */
	public Menu() {
		
		/*
		 * t@C
		 */
		JMenu fmenu = (JMenu)add(new JMenu());
		fmenu.setText(ResourceManage.getString("file.menu"));
		fmenu.setMnemonic('F');
		createMenuItem(fmenu, "file", "new", 'N', InputEvent.CTRL_MASK, true);

		createMenuItem(fmenu, "file", "open", 'O', InputEvent.CTRL_MASK, true);

		fmenu.addSeparator();
		filesmi = new ArrayList<JMenuItem>(PropertyManage.recentFilesMax);
		for (int i = 0; i < PropertyManage.recentFilesMax; i++) {
			JMenuItem mi = fmenu.add(
				new JMenuItem("file" + i));
			mi.setMargin((new Insets(2,0,2,0)));
			mi.addActionListener(this);
			mi.setActionCommand("file" + i);
			filesmi.add(mi);
		}
		fmenu.addSeparator();

		createMenuItem(fmenu, "file", "save", 'S', InputEvent.CTRL_MASK, true);
		createMenuItem(fmenu, "file", "saveas", 'S', InputEvent.CTRL_MASK | InputEvent.SHIFT_MASK, false);

		/*
		fmenu.addSeparator();
		JMenu fmenuexport = (JMenu)fmenu.add(new JMenu());
		fmenuexport.setText(ResourceManage.getString("file.export"));
		createMenuItem(fmenuexport, "file", "exporthtml", (char)0, 0, false);
		createMenuItem(fmenuexport, "file", "exporthtmlans", (char)0, 0, false);
		*/

		fmenu.addSeparator();
		createMenuItem(fmenu, "file", "exit", 'W', InputEvent.CTRL_MASK, false);


		/*
		 * ҏW
		 */
		JMenu emenu = (JMenu)add(new JMenu());
		emenu.setText(ResourceManage.getString("edit.menu"));
		emenu.setMnemonic('E');
		createMenuItem(emenu, "edit", "insert", 'A', InputEvent.CTRL_MASK, true);
		undomi =
			createMenuItem(emenu, "edit", "undo", 'Z', InputEvent.CTRL_MASK, true);
		redomi =
			createMenuItem(emenu, "edit", "redo", 'Y', InputEvent.CTRL_MASK, true);
		createMenuItem(emenu, "edit", "centering", 'C', InputEvent.CTRL_MASK, true);
		createMenuItem(emenu, "edit", "break", 'B', InputEvent.CTRL_MASK, true);
		emenu.addSeparator();

		trashmi =
			createMenuItem(emenu, "edit", "trash", 'D', InputEvent.CTRL_MASK, true);
		upmi =
			createMenuItem(emenu, "edit", "up", (char)0, 0, true);
		downmi =
			createMenuItem(emenu, "edit", "down", (char)0, 0, true);
		editmi =
			createMenuItem(emenu, "edit", "edit", 'E', InputEvent.CTRL_MASK, true);
		emenu.addSeparator();

		kindmi = createMenuItem(emenu, "file", "kind", 'K', InputEvent.CTRL_MASK, true);


		/*
		 * IvV
		 */
		JMenu omenu = (JMenu)add(new JMenu());
		omenu.setText(ResourceManage.getString("option.menu"));
		omenu.setMnemonic('O');

			/*
			 * F
			 */
		JMenu omenupalette = (JMenu)omenu.add(new JMenu());
		omenupalette.setText(ResourceManage.getString("option.palette"));
		omenupalette.setIcon((Icon)new ImageIcon(ResourceManage.getImage("palette")));
		createMenuItem(omenupalette, "option", "editbgcolor", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "editfgheadscolor", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "editfgtailscolor", (char)0, 0, true);
		omenupalette.addSeparator();
		createMenuItem(omenupalette, "option", "palette0", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette1", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette2", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette3", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette4", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette5", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette6", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette7", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette8", (char)0, 0, true);
		createMenuItem(omenupalette, "option", "palette9", (char)0, 0, true);
		omenupalette.addSeparator();
		createMenuItem(omenupalette, "option", "savecolors", (char)0, 0, false);
		createMenuItem(omenupalette, "option", "restorecolors", (char)0, 0, false);

			/*
			 * Y[
			 */		
		JMenu omenuzoom = (JMenu)omenu.add(new JMenu());
		omenuzoom.setText(ResourceManage.getString("option.zoom"));
		omenuzoom.setIcon((Icon)new ImageIcon(ResourceManage.getImage("zoom")));
		createMenuItem(omenuzoom, "option", "zoom100", '1', InputEvent.CTRL_MASK, false);
		omenuzoom.addSeparator();
		createMenuItem(omenuzoom, "option", "zoomin", '.', InputEvent.CTRL_MASK, true);
		createMenuItem(omenuzoom, "option", "zoomout", ',', InputEvent.CTRL_MASK, true);
		omenuzoom.addSeparator();
		createMenuItem(omenuzoom, "option", "zoom25", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom33", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom40", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom50", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom66", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom70", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom81", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom86", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom90", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom95", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom115", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom122", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom150", (char)0, 0, false);
		createMenuItem(omenuzoom, "option", "zoom200", (char)0, 0, false);
		omenu.addSeparator();

			/*
			 * ݒ
			 */
		JMenu omenuconfig = (JMenu)omenu.add(new JMenu());
		omenuconfig.setText(ResourceManage.getString("option.config"));
		omenuconfig.setIcon((Icon)new ImageIcon(ResourceManage.getImage("config")));

				/*
				 * GfBbgpl̉掿
				 */
		JMenu omenueiq = (JMenu)omenuconfig.add(new JMenu());
		omenueiq.setText(ResourceManage.getString("option.config.editimagequality"));
		
		btgeiq = new ButtonGroup();
		eiqbetter =
			createRadioButtonMenuItem(omenueiq, btgeiq, "option.config", "editimagequality.better", (char)0, 0, false);
		eiqnormal =
			createRadioButtonMenuItem(omenueiq, btgeiq, "option.config", "editimagequality.normal", (char)0, 0, false);
				
				/*
				 * KChpl̉掿
				 */
		JMenu omenugiq = (JMenu)omenuconfig.add(new JMenu());
		omenugiq.setText(ResourceManage.getString("option.config.guideimagequality"));
		
		btggiq = new ButtonGroup();
		giqbest =
			createRadioButtonMenuItem(omenugiq, btggiq, "option.config", "guideimagequality.best", (char)0, 0, false);
		giqbetter =
			createRadioButtonMenuItem(omenugiq, btggiq, "option.config", "guideimagequality.better", (char)0, 0, false);
		giqnormal =
			createRadioButtonMenuItem(omenugiq, btggiq, "option.config", "guideimagequality.normal", (char)0, 0, false);
				
				/*
				 * _̏W
				 */
		vtxatt =
			createCheckBoxMenuItem(omenuconfig, "option.config", "vertexattach", (char)0, 0, false);
		
				/*
				 * ϑ]
				 */
		adprot =
			createCheckBoxMenuItem(omenuconfig, "option.config", "adaptiverotation", (char)0, 0, false);
		

		/*
		JMenuItem toolmi = createMenuItem(omenu, "option", "tool", (char)0, 0, true);
		toolmi.setEnabled(false);
		*/
		

		/*
		 * wv
		 */
		JMenu hmenu = (JMenu)add(new JMenu());
		hmenu.setText(ResourceManage.getString("help.menu"));
		hmenu.setMnemonic('H');
		JMenuItem helpmi = createMenuItem(hmenu, "help", "help", (char)0, 0, true);
		helpmi.setEnabled(false);

		JMenuItem mi = createMenuItem(hmenu, "help", "version", (char)0, 0, false);
		mi.setText(mi.getText() + " " + PropertyManage.applicationver);
	}

	/**
	 * j[ACe̐
	 * @param menu
	 * @param segname
	 * @param actname
	 * @param mnemonic
	 * @param keymask
	 * @param enableicon
	 * @return
	 */
	public JMenuItem createMenuItem(
		JMenu menu,
		String segname,
		String actname,
		char mnemonic,
		int keymask,
		boolean enableicon
	) {
		JMenuItem mi = (JMenuItem)menu.add(
			new JMenuItem(ResourceManage.getString(segname + "." + actname)));
		mi.setMargin((new Insets(2,0,2,0)));
		if (mnemonic != 0)	mi.setAccelerator(KeyStroke.getKeyStroke(mnemonic, keymask));
		if (enableicon)		mi.setIcon((Icon)new ImageIcon(ResourceManage.getImage(actname)));
		if (actname != null) {
			mi.addActionListener(this);
			mi.setActionCommand(segname + "." + actname);
		} else { 
			mi.setEnabled(false);
		}
		return mi;
	}

	/**
	 * `FbN{bNXj[ACe̐
	 * @param menu
	 * @param segname
	 * @param actname
	 * @param mnemonic
	 * @param keymask
	 * @param enableicon
	 * @return
	 */
	public JCheckBoxMenuItem createCheckBoxMenuItem(
		JMenu menu,
		String segname,
		String actname,
		char mnemonic,
		int keymask,
		boolean enableicon
	) {
		JCheckBoxMenuItem mi = (JCheckBoxMenuItem)menu.add(
			new JCheckBoxMenuItem(ResourceManage.getString(segname + "." + actname)));
		mi.setMargin((new Insets(2,0,2,0)));
		if (mnemonic != 0)	mi.setAccelerator(KeyStroke.getKeyStroke(mnemonic, keymask));
		if (enableicon)		mi.setIcon((Icon)new ImageIcon(ResourceManage.getImage(actname)));
		if (actname != null) {
			mi.addActionListener(this);
			mi.setActionCommand(segname /*+ "." + actname*/);
		} else { 
			mi.setEnabled(false);
		}
		return mi;
	}

	/**
	 * WI{^j[ACe̐
	 * @param menu
	 * @param segname
	 * @param actname
	 * @param mnemonic
	 * @param keymask
	 * @param enableicon
	 * @return
	 */
	public JRadioButtonMenuItem createRadioButtonMenuItem(
		JMenu menu,
		ButtonGroup buttongroup,
		String segname,
		String actname,
		char mnemonic,
		int keymask,
		boolean enableicon
	) {
		JRadioButtonMenuItem mi = (JRadioButtonMenuItem)menu.add(
			new JRadioButtonMenuItem(ResourceManage.getString(segname + "." + actname)));
		mi.setMargin((new Insets(2,0,2,0)));
		if (mnemonic != 0)	mi.setAccelerator(KeyStroke.getKeyStroke(mnemonic, keymask));
		if (enableicon)		mi.setIcon((Icon)new ImageIcon(ResourceManage.getImage(actname)));
		if (actname != null) {
			mi.addActionListener(this);
			mi.setActionCommand(segname /*+ "." + actname*/);
		} else { 
			mi.setEnabled(false);
		}
		buttongroup.add(mi);
		return mi;
	}

	/**
	 * ANVfBXpb`
	 */
	public void actionPerformed(ActionEvent e) {
		String command = e.getActionCommand();
		if (DEBUG) System.out.println(command);

		if (command.equals("file.exit")) { Common.actionFileExit(); return; }
		if (command.equals("file.new")) { Common.actionFileNew(); return; }
		if (command.equals("file.open")) { Common.actionFileOpen(null); return; }
		if (command.equals("file.kind")) { Common.actionFileKind(); return; }
		if (command.equals("file.save")) { Common.actionFileSave(); return; }
		if (command.equals("file.saveas")) { Common.actionFileSaveAs(); return; }
		if (command.equals("file.exporthtml")) { Common.actionFileExportHTML(false); return; }
		if (command.equals("file.exporthtmlans")) { Common.actionFileExportHTML(true); return; }
		if (command.equals("edit.insert")) { Common.actionEditInsert(); return; }
		if (command.equals("edit.undo")) { Common.actionEditUndo(); return; }
		if (command.equals("edit.redo")) { Common.actionEditRedo(); return; }
		if (command.equals("edit.break")) { Common.actionEditBreak(); return; }
		if (command.equals("edit.centering")) { Common.actionEditCentering(); return; }
		if (command.equals("edit.trash")) { Common.actionEditDelete(); return; }
		if (command.equals("edit.edit")) { Common.actionEditEdit(); return; }
		if (command.equals("edit.up")) { Common.actionEditUp(); return; }
		if (command.equals("edit.down")) { Common.actionEditDown(); return; }
		for (int i = 0; i < PropertyManage.recentFilesMax; i++) {
			if (command.equals("file" + i)) {
				Common.actionFileOpen(PropertyManage.recentFiles.get(i));
				return; }
		}

		if (command.equals("option.zoomin")) { Common.actionOptionZoomin(); return; }
		if (command.equals("option.zoomout")) { Common.actionOptionZoomout(); return; }
		if (command.equals("option.zoom25")) { Common.actionOptionZoom(0.25); return; }
		if (command.equals("option.zoom33")) { Common.actionOptionZoom(0.33); return; }
		if (command.equals("option.zoom40")) { Common.actionOptionZoom(0.4); return; }
		if (command.equals("option.zoom50")) { Common.actionOptionZoom(0.5); return; }
		if (command.equals("option.zoom66")) { Common.actionOptionZoom(0.66); return; }
		if (command.equals("option.zoom70")) { Common.actionOptionZoom(0.7); return; }
		if (command.equals("option.zoom81")) { Common.actionOptionZoom(0.81); return; }
		if (command.equals("option.zoom86")) { Common.actionOptionZoom(0.86); return; }
		if (command.equals("option.zoom90")) { Common.actionOptionZoom(0.90); return; }
		if (command.equals("option.zoom95")) { Common.actionOptionZoom(0.95); return; }
		if (command.equals("option.zoom100")) { Common.actionOptionZoom(1.0); return; }
		if (command.equals("option.zoom115")) { Common.actionOptionZoom(1.15); return; }
		if (command.equals("option.zoom122")) { Common.actionOptionZoom(1.22); return; }
		if (command.equals("option.zoom150")) { Common.actionOptionZoom(1.5); return; }
		if (command.equals("option.zoom200")) { Common.actionOptionZoom(2.0); return; }

		if (command.equals("option.savecolors")) { Common.actionOptionSavecolors(); return; }
		if (command.equals("option.restorecolors")) { Common.actionOptionRestorecolors(); return; }

		if (command.equals("option.palette0")) { Common.actionOptionPalletSet(0); return; }
		if (command.equals("option.palette1")) { Common.actionOptionPalletSet(1); return; }
		if (command.equals("option.palette2")) { Common.actionOptionPalletSet(2); return; }
		if (command.equals("option.palette3")) { Common.actionOptionPalletSet(3); return; }
		if (command.equals("option.palette4")) { Common.actionOptionPalletSet(4); return; }
		if (command.equals("option.palette5")) { Common.actionOptionPalletSet(5); return; }
		if (command.equals("option.palette6")) { Common.actionOptionPalletSet(6); return; }
		if (command.equals("option.palette7")) { Common.actionOptionPalletSet(7); return; }
		if (command.equals("option.palette8")) { Common.actionOptionPalletSet(8); return; }
		if (command.equals("option.palette9")) { Common.actionOptionPalletSet(9); return; }
		if (command.equals("option.editbgcolor")) {
			Common.actionOptionSetColor(command, PropertyManage.backgroundColor);
			return;
		}
		if (command.equals("option.editfgheadscolor")) {
			Common.actionOptionSetColor(command, PropertyManage.piecesColor);
			return;
		}
		if (command.equals("option.editfgtailscolor")) {
			Common.actionOptionSetColor(command, PropertyManage.piecesColord);
			return;
		}
			
		if (command.equals("option.config")) {
			feedbackProperties();
			Common.actionOptionConfig();
			return;
		}
	}

	/**
	 * tbV
	 */
	public void refresh() {
		int i;
		for (i = 0; i < PropertyManage.recentFilesMax; i++) {
			JMenuItem mi;
			mi = (JMenuItem)(filesmi.get(i));
			mi.setText(PropertyManage.recentFiles.getName(i));
			mi.setVisible((i < PropertyManage.recentFiles.size()));
		}
		
		undomi.setEnabled(Common.isUndoable());
		redomi.setEnabled(Common.isRedoable());
		trashmi.setEnabled(Common.getListCount() > 0);
		upmi.setEnabled(Common.getListIndex() > 0);
		downmi.setEnabled(Common.getListIndex() < Common.getListCount()-1);
		editmi.setEnabled(Common.getListIndex() >= 0);
		kindmi.setEnabled((Common.getListCount() <= 0) && (!Common.isFileChanged()));

		switch(PropertyManage.editImageQuality) {
			case PropertyManage.IMAGEQUALITY_NORMAL: eiqnormal.setSelected(true); break;
			case PropertyManage.IMAGEQUALITY_BETTER: eiqbetter.setSelected(true); break;
			default: eiqnormal.setSelected(true); break;
		}
		
		switch(PropertyManage.guideImageQuality) {
			case PropertyManage.IMAGEQUALITY_NORMAL: giqnormal.setSelected(true); break;
			case PropertyManage.IMAGEQUALITY_BETTER: giqbetter.setSelected(true); break;
			case PropertyManage.IMAGEQUALITY_BEST: giqbest.setSelected(true); break;
			default: giqnormal.setSelected(true); break;
		}

		if (PropertyManage.vertexAttach != 0) {	vtxatt.setSelected(true);
		} else {								vtxatt.setSelected(false);
		}

		if (PropertyManage.adaptiveRotation != 0) {	adprot.setSelected(true);
		} else {									adprot.setSelected(false);
		}
	}

	/**
	 * ݒ荀ڂ̃vpeB[ւ̃tB[hobN
	 */
	private void feedbackProperties() {
		if (eiqnormal.isSelected()) PropertyManage.editImageQuality = PropertyManage.IMAGEQUALITY_NORMAL;
		if (eiqbetter.isSelected()) PropertyManage.editImageQuality = PropertyManage.IMAGEQUALITY_BETTER;

		if (giqnormal.isSelected()) PropertyManage.guideImageQuality = PropertyManage.IMAGEQUALITY_NORMAL;
		if (giqbetter.isSelected()) PropertyManage.guideImageQuality = PropertyManage.IMAGEQUALITY_BETTER;
		if (  giqbest.isSelected()) PropertyManage.guideImageQuality = PropertyManage.IMAGEQUALITY_BEST;

		PropertyManage.vertexAttach = (vtxatt.isSelected()) ? 1 : 0;
		PropertyManage.adaptiveRotation = (adprot.isSelected()) ? 1 : 0;
	}

}
