#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

void main(int argc, char** argv){
	FILE *fp;
	int v[256];
	int i, j, n = 0;
	char id[20][32];
	unsigned char s[1024], t[64];
	unsigned char plt[1024];
	unsigned char *p, *p_;

	if (argc != 1+2) {
		printf("Usage:%s <Piecename list filename> <source Ete filename without extension>\n", argv[0]);
		exit(0);
	}

	sprintf(s, "%s", argv[1]);
	if ((fp = fopen(s, "r")) == NULL) {
		fprintf(stderr, "%s is not found\n", s);
		exit(0);
	}
	for (i = 0; i < 20; i++) {
		if (!fgets(s, 31, fp)) {
			sprintf(id[i], "id%02d", i);
		} else {
			sprintf(id[i], "%s", s);
			for (j=0; j<32; j++) id[i][j] = (id[i][j]<0x20) ? 0 : id[i][j];
			fprintf(stderr, "%s\n", id[i]);
		}
	}

	sprintf(s, "%s.ete", argv[2]);
	if ((fp = fopen(s, "r")) == NULL) {
		fprintf(stderr, "%s is not found\n", s);
		exit(0);
	}

	fgets(s, 1023, fp);
	fgets(plt, 1023, fp);

	while (fgets(s, 1023, fp)){
		for (p = s; *p >= 0x20; p++);
		*p = 0;

		printf("<silhouette name=\"%s\">\n", s);

		fgets(s, 1023, fp);
		n = 0;
		for (p = s, p_ = t;; p++) {
			if (*p == ',' || *p < 0x20) {
				*p_ = 0;
				v[n] = atoi(t);
				p_ = t;
				n++;
				if (*p < 0x20) break;
			} else {
				*(p_++) = *p;
			}
		}

		if (n % 4 != 0) {
			printf("fatal error: %d elements discripted.\n", n);
			exit(0);
		}

		for (i = 0; i < n / 4; i++) {
			if (strcmp(plt, "tan") == 0) {
				if (strcmp(id[i], "Sta") == 0) {
					printf("St ");
				} else if (strcmp(id[i], "Lta") == 0) {
					printf("Lt ");
				} else if (strcmp(id[i], "Stb") == 0) {
					printf("St ");
					v[i * 4 + 2] -= 180 * v[i * 4 + 3];
					v[i * 4 + 2] = (v[i * 4 + 2] + 720) % 720;
				} else if (strcmp(id[i], "Ltb") == 0) {
					printf("Lt ");
					v[i * 4 + 2] += 180 * v[i * 4 + 3];
					v[i * 4 + 2] = (v[i * 4 + 2] + 720) % 720;
				} else {
					printf("%s ",  id[i]);
				}
			} else {
				printf("%s ",  id[i]);
			}
			printf("%d ",  v[i * 4]-256);
			printf("%d ",  v[i * 4 + 1]-256);
			printf("%f ",  (double)v[i * 4 + 2] / 360.0 * M_PI);
			printf("%d\n", v[i * 4 + 3]);
		}
		printf("</silhouette>\n", s);

	}

	fclose(fp);

}
