package acolor;

import java.awt.*;

/**
 * ʃNX
 *   @(#)ColorTool.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  25 Mar.2006
 */
public class AColor {
	private static int r = 0, g = 0, b = 0;
	private static double h = 0, s = 0, v = 0;

	/**
	 * RXgN^
	 */
	public AColor(){
	}

	public static Color GetMatchColor(Color c, int n){
		r = c.getRed();
		g = c.getGreen();
		b = c.getBlue();
		calcHSV();
		if (false) {
			System.out.println(n + ": h=" + 
								h + ", s=" + s + ", v=" + v);
			System.out.println(n + ": r=" + 
								r + ", g=" + g + ", b=" + b);
		}

		calcMatchColor(n);

		calcRGB();
		if (false) {
			System.out.println(n + ": h=" + 
								h + ", s=" + s + ", v=" + v);
			System.out.println(n + ": r=" + 
								r + ", g=" + g + ", b=" + b);
		}
		return new Color(r, g, b);
	}

	private static void calcMatchColor(int n){
		double ph = h, ps = s, pv = v;
		double yh = h, ys = s, yv = v;
		double prh = h, prs = s, prv = v;
		double yxh = h, yxs = s, yxv = v;

		yv = v + ((v > 0.7) ? (-0.30) : (0.30));
		pv = v + ((v > 0.7) ? (-0.15) : (0.15));

		ph = yh = h;
		ps = ys = s;

		switch (n){
			case 0:
			h = ph; s = ps; v = pv;
			return;
			case 1:
			h = yh; s = ys; v = yv;
			return;
			default:
			break;
		}

		if (h < 30){
			prh = yxh = yh = h + 20;
			prs = yxs = ys = s;
			yxv = yv;
			prv = pv;
			yv = v;
		} else if (h < 60){
			prh = yxh = yh = h + 150;
			prs = yxs = ys = s;
			yxv = yv;
			prv = pv;
			yv = v;
		} else if (h < 180){
			yh = h - 40;
			ys = posmin(s - 0.3, 1);
			yv = posmin(v - 0.2, 1);
			prs = yxs = posmin(s - 0.7, 1);
			yxv = posmin(v + 0.2, 1);
			prv = v;
		} else if (h < 220){
			prh = yxh = yh = h - 170;
			prs = yxs = ys = s;
			yxv = yv;
			prv = pv;
			yv = v;
		} else if (h < 300){
			prh = yxh = yh = h;
			prs = yxs = ys = posmin(s - 0.6, 1);
			yxv = yv;
			prv = pv;
			yv = v;			
		} else {
			prh = yxh = yh = h + 20;
			prs = yxs = ys = s + ((s > 0.5) ? (-0.4) : (0.4));
			yxv = yv;
			prv = pv;
			yv = v;			
		}

		switch (n){
			case 2:
			h = yh; s = ys; v = yv;
			return;
			case 3:
			h = prh; s = prs; v = prv;
			return;
			case 4:
			h = yxh; s = yxs; v = yxv;
			return;
			case 5:
			h = s = 0; v = yv;
			return;
			case 6:
			h = s = 0; v = 1 - yv;
			return;
			case 7:
			h = s = 0; v = (v >= 0.5) ? 0 : 1;
			return;
			default:
			break;
		}
	}

	private static double posmin(double ca, double cb){
		if (ca < 0) ca = 0;
		if (cb < 0) cb = 0;
		return Math.min(ca, cb);
	}

	private static void calcHSV(){
		h = s = v = 0;

		double max, min, dif;
		max = (double)Math.max(r, Math.max(g, b));
		min = (double)Math.min(r, Math.min(g, b));
		dif = max - min;

		if (max == 0) return;
		v = max / 255.0;

		s = dif / max;
		if (s == 0) {
			h = 0;
 		} else {
			if ((int)max == r) h =         60.0 * (double)(g - b) / dif;
			if ((int)max == g) h = 120.0 + 60.0 * (double)(b - r) / dif;
			if ((int)max == b) h = 240.0 + 60.0 * (double)(r - g) / dif;
 		}
		if (h < 0) h += 360.0;
	}

	private static void calcRGB(){
		double i, f, p, q, t, rr, rg, rb;
		if (s == 0) {
			r = g = b = (int)(v * 255);
			return;
		}
		i = Math.floor(h / 60);
		f = h / 60 - i;
		p = v * (1 - s);
		q = v * (1 - s * f);
		t = v * (1 - s * (1 - f));
		switch ((int)i){
			case 0:	rr = v; rg = t; rb = p; break;
			case 1:	rr = q; rg = v; rb = p; break;
			case 2:	rr = p; rg = v; rb = t; break;
			case 3:	rr = p; rg = q; rb = v; break;
			case 4:	rr = t; rg = p; rb = v; break;
			default:rr = v; rg = p; rb = q; break;
		}
		r = (int)(rr * 255);
		g = (int)(rg * 255);
		b = (int)(rb * 255);
		r -= (r > 255) ? 1 : 0;
		g -= (g > 255) ? 1 : 0;
		b -= (b > 255) ? 1 : 0;
	}

	public static void setRGB(int R, int G, int B) {
		r = R;
		g = G;
		b = B;
		calcHSV();
	}

	public static void setHSV(double H, double S, double V) {
		h = H;
		s = S;
		v = V;
		calcRGB();
	}

	public static int getR() {return r;}
	public static int getG() {return g;}
	public static int getB() {return b;}

	public static double getH() {return h;}
	public static double getS() {return s;}
	public static double getV() {return v;}

}
