package imagingapp;

import java.awt.Color;
import java.awt.Graphics2D;
import java.awt.image.BufferedImage;
import java.io.File;
import java.io.IOException;

import javax.imageio.ImageIO;

import tangram.PieceInfo;
import tangram.PieceInfoExt;
import tangram.PieceInfoTool;
import tangram.Tangram;
import tangram.svcs.Imgs;
import tangram.svcs.Listios;

public class DefaultMap {
	final static double ZERO = 0.00001;		// TSPǏT@̋e덷
	final static boolean DEBUG = true;

	static private double[] coord;
	static private int coordlen = 0;
	static private int coordidx = 0;
	static private int startnum = 0;

	static public void addpoint(double x, double y) {
		if (coordlen <= coordidx) {
			coordlen = coordlen + 1024;

			double[] newcoord = new double[coordlen];
			coord = newcoord;
		}
		coord[coordidx++] = x;
		coord[coordidx++] = y;

		// JnCfbNX̍XV
		if (x < coord[startnum*2] && y < coord[startnum*2+1]) {
			startnum = coordidx/2 - 1;
		}

	}
	
	static public void drawMap(
		Tangram tan,
		Listios lios,
		Imgs imgs
		){
		int w = 400;
		int h = 400;
		double trim = 20;
		double efw = (double)w - trim * 2;
		double efh = (double)h - trim * 2;
		double x, y;
		double xs, ys;
		double xe, ye;
		double px[], py[];
		int num = lios.getCount();
		px = new double[num];
		py = new double[num];

		BufferedImage img;
		img = new BufferedImage(w, h, BufferedImage.TYPE_4BYTE_ABGR);
		Graphics2D g2 = (Graphics2D)img.getGraphics();

		// f[^mF
		if (DEBUG) {
			for (int i = 0; i < coordidx; ) {
				System.out.print(i/2 + ": ");
				System.out.print(coord[i++] + ", ");
				System.out.println(coord[i++]);
			}
		}

		// wih
		g2.setColor(new Color(228, 216, 220));
		g2.fillRect(0, 0, w, h);

		xs = xe = coord[0];
		ys = ye = coord[1];
		for (int n = 1; n < num; n++) {
			if (coord[n * 2] < xs) xs = coord[n * 2];
			if (coord[n * 2] > xe) xe = coord[n * 2];
			if (coord[n * 2 + 1] < ys) ys = coord[n * 2 + 1];
			if (coord[n * 2 + 1] > ye) ye = coord[n * 2 + 1];
		}
		for (int n = 0; n < num; n++) {
			x = (coord[n * 2] - xs) / (xe - xs);
			y = (coord[n * 2 + 1] - ys) / (ye - ys);
			px[n] = x;
			py[n] = y;

			imgs.setPiecesColor(new Color((int)(x*255), (int)((1-y)*128), 0, 128));
			imgs.setPiecesColord(new Color((int)(x*255), (int)((1-y)*128), 0, 128));

			x = trim + x * efw;
			y = trim + (1 - y) * efh;

			imgs.setRatio(0.1);
			imgs.setSlide((int)x, (int)y);
	
			lios.moveIndexTo(n);
			PieceInfo pi = new PieceInfo();
			PieceInfoTool.copy(pi, lios.get(n));
			imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
							true, false, true, null);
		}

		// TSPǏT@ŃpX
		int root[];
		root = tsp(px, py, num);
		xs = trim + px[root[num-1]] * efw;
		ys = trim + (1 - py[root[num-1]]) * efh;
		g2.setColor(new Color(255, 255, 255, 0));
		for (int n = 0; n < num; n++) {
			xe = trim + px[root[n]] * efw;
			ye = trim + (1 - py[root[n]]) * efh;
			g2.drawLine((int)xs, (int)ys, (int)xe, (int)ye);
			g2.setColor(new Color(64, 64, 64, 64));
			xs = xe;
			ys = ye;
		}

		// PNGt@C֏o
		String fn = "map.png";
		if (DEBUG) System.out.println(" ->" + fn);
		File f = new File(fn);
		try {
			ImageIO.write(img, "png", f);
		} catch (IOException ex) {
			ex.printStackTrace();
		}

		// }gNX\
		int ih = (int)trim*2 + ((num+9) / 10) * (int)efh/5;
		img = new BufferedImage(w, ih ,	BufferedImage.TYPE_4BYTE_ABGR);
		g2 = (Graphics2D)img.getGraphics();
		
		g2.setColor(new Color(228, 216, 220));
		g2.fillRect(0, 0, w, ih);
		for (int n = 0; n < num; n++) {
			imgs.setPiecesColor(Color.BLACK);
			imgs.setPiecesColord(Color.BLACK);

			x = trim + ((double)(n % 10) + 0.5) / 10 * efw;
			y = trim + ((double)(n / 10) + 0.5) / 5  * efh;

			imgs.setRatio(0.1);
			imgs.setSlide((int)x, (int)y);
	
			lios.moveIndexTo(root[n]);
			PieceInfo pi = new PieceInfo();
			PieceInfoTool.copy(pi, lios.get(root[n]));
			imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
							true, false, true, null);
		}

		// PNGt@C֏o
		fn = "map_mtrx.png";
		if (DEBUG) System.out.println(" ->" + fn);
		f = new File(fn);
		try {
			ImageIO.write(img, "png", f);
		} catch (IOException ex) {
			ex.printStackTrace();
		}

	}

	/**
	 * Z[X}ǏT@ɂߎ
	 * ASYi2-OPTOR-OPTߖT)
	 * 
	 * @param px
	 * @param py
	 * @param N
	 * @return
	 */
	private static int[] tsp(double px[], double py[], int N) {

		int i, j, k;
		int init[], lopt[], rslt[], start;
		init = new int[N];
		lopt = new int[N];
		rslt = new int[N];
		double initlg, bestlg;

		if (DEBUG) System.out.println("TSP :");
		if (DEBUG) {
			System.out.println(" N = " + N);
			for (int n = 0; n < N; n++)
				System.out.println(" ( " + px[n] + " , " + py[n] + " )");
		}
		
		initlg = initialtour(init, px, py, N);				// H̐
		if (DEBUG) System.out.println("initial tour");
		if (DEBUG) printtour(init, initlg, N);
		start = startnum;

		bestlg = localtour(init, initlg, lopt, px, py, N);	// ǏT
		if (DEBUG) System.out.println("local optimal tour");
		if (DEBUG) printtour(lopt, bestlg, N);

		k = -1;
		while (lopt[++k] != start);
		if (DEBUG) System.out.println("start : " + start + ", " + k);
		for (i = 0; i < N; i++) rslt[i] = lopt[(k+i)%N];
		if (DEBUG) printtour(rslt, bestlg, N);

		return rslt;
	}

	/**
	 * n_N̏Hxɍ쐬A̒o͂
	 * 
	 * @param x
	 * @param px
	 * @param py
	 * @param N
	 * @return
	 */
	private static double initialtour(int x[], double px[], double py[], int N) {
		int i, j, k;
		double lg;
		double r, rmin;

		boolean test[] = new boolean[N];	// test[i]͒n_i̗ptO
		for(i = 0; i < N; i++) test[i] = false;

		// o_߂
		k = 0;
		rmin = 0.0;
		for (i = 0; i < N; i++) {
			r = px[i] * Math.abs(px[i])
			  + py[i] * Math.abs(py[i]);
			if (r < rmin) {
				rmin = r;
				k = i;
			}
		} 
		x[0] = k;
		test[k] = true;
		
		// ߂̂珇ɓo^
		for (i = 1; i < N; i++) {

			rmin = -1;
			for (j = 0; j < N; j++) {
				if (test[j]) continue;
				r = Math.pow(px[j] - px[x[i-1]], 2)
				  + Math.pow(py[j] - py[x[i-1]], 2);
				if (r < rmin || rmin < 0) {
					rmin = r;
					k = j;
				}
			}
			x[i] = k;
			test[k] = true;
		}

		for (lg = 0.0, i = 0; i < N; i++) lg += calclength(i, i+1, x, px, py, N);// H̒
		return lg;
	}

	/**
	 * Hiniti̒initlgjƂāA2-OPTOR-OPTߖT
	 * ǏTKpAǏœKlopt̏Ho
	 * 
	 * @param init
	 * @param initlg
	 * @param lopt
	 * @param px
	 * @param py
	 * @param N
	 * @return
	 */
	private static double localtour(int init[], double initlg, int lopt[], double px[], double py[], int N) {
		int i, i0, j, k, h, temp, tm[];
		tm = new int[3];
		double lg, lgtemp, lg0, lg1;
		boolean improved;

		for (i = 0; i < N; i++) lopt[i] = init[i];
		lg = initlg;
		i0 = 0;

		while (true) {						// ߖTT̊Jn
			improved = false;

			for (i = i0; i < i0+N; i++) {	// 2-OPTߖT̒T
				for (j = i+2; j < i+N-1; j++) {// lgtemp͒̑
					lgtemp = calclength(i, j, lopt, px, py, N) + calclength(i+1, j+1, lopt, px, py, N)
							-calclength(i, i+1, lopt, px, py, N)-calclength(j, j+1, lopt, px, py, N);
					if (lgtemp < -ZERO) {	// ǉ̔
						// ǉ̍\
						for (k = 0; k < (j-i)/2; k++) {
							temp = lopt[(i+1+k)%N];
							lopt[(i+1+k)%N] = lopt[(j-k)%N]; 
							lopt[(j-k)%N] = temp;
						}
						// IMPROVED
						// b̍XVF̋ߖTT
						if (DEBUG) System.out.println("improved solution by 2-OPT");
						i0 = (i+1)%N; 
						for (lg = 0.0, i = 0; i < N; i++) lg += calclength(i, i+1, lopt, px, py, N);	// H̒
						printtour(lopt, lg, N);
						improved = true;
						break;
					}
				} 
				if (improved) break;
			} 
			if (improved) continue;

			for (i = i0; i < i0+N; i++) {	// Or-OPTߖT̒T
				for (k = i+1; k <= i+3; k++) {
					for (j = k+1; j < i+N-1; j++) {// lgtemp͒̑
						lg0 = calclength(i, i+1, lopt, px, py, N) + calclength(j, j+1,lopt, px, py, N) + calclength(k, k+1, lopt, px, py, N);
						lg1 = calclength(i, k+1, lopt, px, py, N) + calclength(j, k, lopt, px, py, N) + calclength(i+1, j+1,lopt, px, py, N);
						lgtemp = lg1 - lg0;
						if(lgtemp < -ZERO) {// ǉ̔
							// ǉ̍\
							for (h = i+1; h <= k; h++) tm[h-i-1] = lopt[h%N];
							for (h = k+1; h <= j; h++) lopt[(h-k+i)%N] = lopt[h%N];
							for (h = 0; h < k-i; h++) lopt[(j-k+i+1+h)%N] = tm[k-i-1-h];
							// IMPROVED
							// b̍XVF̋ߖTT
							if (DEBUG) System.out.println("improved solution by 2-OPT");
							i0 = (i+1)%N; 
							for (lg = 0.0, i = 0; i < N; i++) lg += calclength(i, i+1, lopt, px, py, N);	// H̒
							printtour(lopt, lg, N);
							improved = true;
							break;
						}

						if (k == i+1) continue;
						lg1 = calclength(i, k+1, lopt, px, py, N) + calclength(j, i+1, lopt, px, py, N) + calclength(k, j+1, lopt, px, py, N);// t̑}
						lgtemp = lg1 - lg0;
						if (lgtemp < -ZERO) {	// ǉ̔ 
							// ǉ̍\
							for (h = i+1; h <= k; h++) tm[h-i-1] = lopt[h%N];
							for (h = k+1; h <= j; h++) lopt[(h-k+i)%N] = lopt[h%N];
							for (h = 0; h < k-i; h++) lopt[(j-h)%N] = tm[k-i-1-h];
							if (DEBUG) System.out.println("improved solution by Or-OPT");
							// IMPROVED
							// b̍XVF̋ߖTT
							if (DEBUG) System.out.println("improved solution by 2-OPT");
							i0 = (i+1)%N; 
							for (lg = 0.0, i = 0; i < N; i++) lg += calclength(i, i+1, lopt, px, py, N);	// H̒
							printtour(lopt, lg, N);
							improved = true;
							break;
						}
					}
					if (improved) break;
				}
				if (improved) break;
			}
			if (!improved) break;
		}
		return lg;                     // ǏTI
	}

	/**
	 * x[i%N]x[j%N]̃[Nbh
	 * 
	 * @param i
	 * @param j
	 * @param x
	 * @param px
	 * @param py
	 * @param N
	 * @return
	 */
	private static double calclength(int i, int j, int x[], double px[], double py[], int N) {
		double l =
		Math.sqrt(
			Math.pow(px[x[i%N]]-px[x[j%N]], 2)
		  + Math.pow(py[x[i%N]]-py[x[j%N]], 2)
		   );
	 return l;
	}

	/**
	 * HxƂ̒lgo
	 * 
	 * @param x
	 * @param lg
	 * @param N
	 */
	private static void printtour(int x[], double lg, int N) {
		int i;
		System.out.print(" tour = (");
		for(i = 0; i < N; i++) System.out.print(x[i] + ")");
		System.out.println("\n length = " + lg);
	}

	/**
	 * [min, max]烉_ɐI
	 * rand0RAND_MAX܂ł̗𐶐W֐
	 * 
	 * @param min
	 * @param max
	 * @return
	 */
	private static int rand_from(int min, int max) {
		return (int)((double)Math.random()*(max-min+1))+min;
	}

}
