package imagingapp;

import java.io.*;
import javax.imageio.ImageIO;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.swing.*;
import tangram.svcs.*;
import tangram.*;

/**
 * CplNX
 *   @(#)MainPanel.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  4 Jun.2006
 */
public class MainPanel
		extends JPanel
		implements  MouseListener,
					MouseMotionListener
{

	private boolean DEBUG = true;		// fobOp
	private boolean PNGOUT = true;

	MainFrame mf;

	public Tangram tan;
	public Listios lios;
	public Imgs imgs;

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param mf eNX
	 */
	public MainPanel(MainFrame mf) {
		this.mf = mf;

		tan = mf.tan;
		lios = mf.lios;
		imgs = new Imgs();

		addMouseMotionListener(this);
		addMouseListener(this);

	}

	/**
	 * ʂ`
	 *   @param g `
	 */
	Image buf = null;
	int w;
	int h;
	public void paint(Graphics g) {
		if (DEBUG) System.out.println("paint");
		if (buf != null) {
			if (DEBUG) System.out.println(" " + w + "x" + h);
			g.drawImage(buf, 0, 0, w, h, this); // ۂ̕`
		}
	}

	/**
	 * }EXXi[Q
	 *   @param e }EXCxg
	 */
	public void mouseDragged(MouseEvent e) {}
	public void mousePressed(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {

			// t@Cǂݍ
			JFileChooser chooser = new JFileChooser();
			chooser.setCurrentDirectory(new File("res"));
			int retval = chooser.showOpenDialog(this);
			if (retval == JFileChooser.APPROVE_OPTION) {
				String path = chooser.getSelectedFile().getPath();
				String name = chooser.getSelectedFile().getName();

				lios.loadXML(tan, path, false, false);
				if (DEBUG) System.out.println(lios.getName());

			}
			
			for (int i = 0; i < lios.getCount(); i++) {
				visualization();
			}
		}
	}
	public void mouseReleased(MouseEvent e) {}
	public void mouseMoved(MouseEvent e) {}
	public void mouseWheelMoved(MouseWheelEvent e) {}
	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}

	int n = 0;
	int ip = 1;
	void visualization() {
		if (DEBUG) System.out.println("visualization");

		w = 128;//getSize().width;
		h = 128;//getSize().height;
		buf = createImage(w, h);
		Graphics2D g2 = (Graphics2D)buf.getGraphics();
		
		imgs.setRatio(0.20);
		imgs.setSlide(w / 2, h / 2);
	
		// wih
		g2.setColor(Color.WHITE);
		g2.fillRect(0, 0, w, h);

		// VGbg
		//lios.moveIndexTo((int)(Math.random() * lios.getCount()));
		lios.moveIndexTo(n);
		PieceInfo pi = new PieceInfo();
		PieceInfoTool.copy(pi, lios.get(n));
		imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
						true, false, true, null);
		if (DEBUG) System.out.println("no." + lios.getIndex()
			+ "/" + lios.getCount() + " : " + pi.name);

		// fo
		int[] px = new int[w * h];
		PixelGrabber grabber;
		grabber = new PixelGrabber(buf, 0, 0, w, h, px, 0, w);
		try {
			grabber.grabPixels();
		} catch(InterruptedException e) {
		}
		if ((grabber.status() & ImageObserver.ABORT) != 0) {
			// image fetch aborted or errored
		}

		// 摜
		String[] ipn = {"if", "gf", "rc"};
		switch (ip) {
			case 0:
			inductionfield(w, h, px, g2, 0.1);
			break;
			case 1:
			gaussianfilter(w, h, px, g2, 4, 0.75);
			break;
			case 2:
			radiuscomplexity(w, h, px, g2, 4, 0.8);
			break;
			default:
			break;
		}

		// 摜E`
		ImageProducer producer;
		producer = new MemoryImageSource(w, h, px, 0, w);
		Toolkit tk = Toolkit.getDefaultToolkit();
		buf.flush();
		buf = tk.createImage(producer);
		repaint();

		if (DEBUG && PNGOUT) {
			String fn = ipn[ip] + "_" + lios.getIndex() + ".png";
			System.out.println(" ->" + fn);
			File f = new File(fn);
			BufferedImage img;
			img = new BufferedImage(w, h, BufferedImage.TYPE_4BYTE_ABGR);
			Graphics grp = img.getGraphics();
			grp.drawImage(buf, 0, 0, w, h, null);
			try {
				ImageIO.write(img, "png", f);
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}

		n++;
		if (n >= lios.getCount()) {
			DefaultMap.drawMap(tan, lios, imgs);			
			n = 0;
		}

	}

	/**
	 * KEVAtB^[
	 * @param w
	 * @param h
	 * @param px
	 * @param g2
	 * @param sigma W΍
	 * @param thr K臒l
	 */
	private void gaussianfilter(int w, int h, int[] px, Graphics2D g2, int isigma, double thr) {
		if (DEBUG) System.out.println("gaussianfilter");

		// ze[u쐬
		double sigma = (double)isigma;
		double[] gv = new double[isigma * 4];
		final double dim = 2;
		final double C = 1 / Math.pow(Math.sqrt(2 * Math.PI) * sigma, dim);
		if (false) System.out.println(" C = " + C);
		for (int r = 0; r < isigma * 4; r++) {
			gv[r] = C * Math.exp(-Math.pow((double)r, 2) / (2 * Math.pow(sigma, 2)));
			if (false) System.out.println(" f(" + r + ") = " + gv[r]);
		}

		// a`FbN
		int i2sigma = isigma * 2;
		double sum = 0;
		for (int v = -i2sigma; v < i2sigma; v++) {
			int rsq = v ^ 2;
			for (int u = -i2sigma; u < i2sigma; u++) {
				int r = (int)(Math.sqrt((double)(rsq + u ^ 2)) + 0.5);
				sum += gv[r];
			}
		}
		if (false) System.out.println(" Sum = " + sum);
		double thresh = sum * thr;

		// 2l
		double[] pe = new double[w * h];
		boolean[] pj = new boolean[w * h];
		for (int i = 0; i < w * h; i++) {
			px[i] &= 0x80;
			px[i] >>= 7;
			pe[i] = 0;
			pj[i] = false;
		}

		// 摜8AGbWo
		int cur = 0;
		for (int y = 1; y < h - 1; y++) {
			cur = y * w + 1;
			for (int x = 1; x < w - 1; x++, cur++) {
				pj[cur] =
					(px[cur] == 0) &&
					((px[cur - 1] != 0) ||
					 (px[cur + 1] != 0) ||
					 (px[cur - w] != 0) ||
					 (px[cur + w] != 0));
			}
		}

		// ̃VGbg̕Gx
		cur = 0;
		double lco = 0;
		int ilco = 0;
		int So = 0;
		for (int y = 1; y < h - 1; y++) {
			cur = y * w + 1;
			for (int x = 1; x < w - 1; x++, cur++) {
				if (px[cur] != 0) continue;
				So += 1;
				if (pj[cur]) {
					ilco++;
					lco += callel(
						pj[cur - w - 1],
						pj[cur - w],
						pj[cur - w + 1],
						pj[cur - 1],
						pj[cur + 1],
						pj[cur + w - 1],
						pj[cur + w],
						pj[cur + w + 1]
					);
				}
			}
		}

		// KEVAtB^
		double M = 0;
		double maxM = 0;
		for (int y = 0; y < h; y++) {
			cur = y * w;
			for (int x = 0; x < w; x++, cur++) {

				M = 0;
				int vs = y - i2sigma;
				int ve = y + i2sigma;
				if (vs < 0) vs = 0;
				if (ve > h) ve = h;
				for (int v = vs; v < ve; v++) {
					int rsq = (y - v) ^ 2;
					int us = x - i2sigma;
					int ue = x + i2sigma;
					if (us < 0) us = 0;
					if (ue > w) ue = w;
					int ref = v * w + us;
					for (int u = us; u < ue; u++, ref++) {
						int r = (int)(Math.sqrt((double)(rsq + (x - u) ^ 2)) + 0.5);
						M += (double)px[ref] * gv[r];
					}
				}
				pe[cur] = M;
				
			}
		}

		// gU摜8AGbWo
		cur = 0;
		for (int y = 1; y < h - 1; y++) {
			cur = y * w + 1;
			for (int x = 1; x < w - 1; x++, cur++) {
				pj[cur] =
					(pe[cur] < thresh) &&
					((pe[cur - 1] >= thresh) ||
					 (pe[cur + 1] >= thresh) ||
					 (pe[cur - w] >= thresh) ||
					 (pe[cur + w] >= thresh));
			}
		}

		// 摜HƁA̕Gx
		double lc = 0;
		double S = 0;
		int ilc = 0;
		cur = 0;
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++, cur++) {
				if (x < i2sigma || x > w - i2sigma ||
					y < i2sigma || y > h - i2sigma ) {
						px[cur] = 128;
						continue;
					} 

				if (px[cur] != 0) px[cur] = 128;

				if (pe[cur] < thresh) {
					S += 1;
					if (pj[cur]) {
						ilc++;
	
						double lca = callel(
							pj[cur - w - 1],
							pj[cur - w],
							pj[cur - w + 1],
							pj[cur - 1],
							pj[cur + 1],
							pj[cur + w - 1],
							pj[cur + w],
							pj[cur + w + 1]
						);

						if (lca != 0) {
							px[cur] = 0xff0000;
							lc += lca;
						}
					}
				}
				if (px[cur] != 0) px[cur] |= (int)((1 - pe[cur] / sum) * 255) << 8;
			}
		}
		for (int i = 0; i < w * h; i++) px[i] += 0xff000000;

		if (DEBUG) System.out.println(" sigma = " + sigma);

		// ʕ\
		double cmplxo = lco * lco / So;
		double cmplx = lc * lc / S;
		if (DEBUG) {
			System.out.print(" Length l = " + lco + "(" + ilco + ")");
			System.out.println(" -> " + lc + "(" + ilc + ")"); 
			System.out.println(" Surface S = " + So + " -> " + S);
			System.out.println(" comlexity C=l^2/S = " + cmplxo + " -> " + cmplx);
			System.out.println(" comlexity diff. = " + (cmplxo - cmplx));
		}

		DefaultMap.addpoint(cmplxo, cmplx);
	}

	double callel(
		boolean d00,boolean d01,boolean d02,
		boolean d10,            boolean d12,
		boolean d20,boolean d21,boolean d22)
	{
		if (
		(d00 ? 1 : 0) +
		(d01 ? 1 : 0) +
		(d02 ? 1 : 0) +
		(d10 ? 1 : 0) +
		(d12 ? 1 : 0) +
		(d20 ? 1 : 0) +
		(d21 ? 1 : 0) +
		(d22 ? 1 : 0) != 2
		) return 1.0;

		if (d00 || d02 || d20 || d22) {
			if (d01 || d10 || d12 || d21) return (1.0 + Math.sqrt(2.0))/2.0;
			return Math.sqrt(2.0); 
		}
		return 1.0;
	}


	/**
	 * ɍWz
	 * @param w
	 * @param h
	 * @param px
	 * @param g2
	 * @param sigma W΍
	 * @param thr K臒l
	 */
	private void radiuscomplexity(int w, int h, int[] px, Graphics2D g2, int isigma, double thr) {
		if (DEBUG) System.out.println("radiuscomplexity");

		// 2l
		int[] pe = new int[w * h];
		for (int i = 0; i < w * h; i++) {
			pe[i] = ((px[i] & 0xff) > 0x80) ? 0xffffffff : 0xff000000;
			px[i] = 0xffffffff;
		}

		// ɍWe[u̐
		int wh = w/2;
		int hh = h/2;
		double[] xdiff = new double[w];
		double[] ydiff = new double[w];
		for (int i = 0; i < w; i++) {
			double rad = ((double)i/(double)w) * 2*Math.PI;
			xdiff[i] = Math.cos(rad);
			ydiff[i] = Math.sin(rad);
		}

		// 摜ϊ
		for (int y = 0; y < h/2; y++) {
			int cur = ((h/4)*3 - y) * w;
			for (int x = 0; x < w; x++, cur++) {
				px[cur] = pe[
					(hh + (int)((double)(y-1)*(double)(ydiff[x]))) * w +
					 wh + (int)((double)(y-1)*(double)(xdiff[x]))
				];
			}
		}

	}

	/**
	 * o̗U
	 * @param w
	 * @param h
	 * @param px
	 * @param g2
	 * @param thresh U̕\Ɏgp2l臒l
	 */
	private void inductionfield(int w, int h, int[] px, Graphics2D g2, double thresh) {
		if (DEBUG) System.out.println("inductionfield");

		// 2l
		double[] pe = new double[w * h];
		for (int i = 0; i < w * h; i++) {
			px[i]&= 0x80;
			pe[i] = 0;
		}

		// ̃VGbg̕Gx
		int cur = 0;
		double lco = 0;
		int So = 0;
		for (int y = 1; y < h - 1; y++) {
			cur = y * w + 1;
			for (int x = 1; x < w - 1; x++, cur++) {
				if (px[cur] != 0) continue;
				So += 1;
				if ((px[cur - 1] != 0) ||
					(px[cur + 1] != 0) ||
					(px[cur - w] != 0) ||
					(px[cur + w] != 0))	lco += 1;
			}
		}

		// o̗U
		cur = 0;
		double M, maxM = 0;
		int cnt;
		int ref;
		for (int y = 0; y < h; y++) {
			for (int x = 0; x < w; x++, cur++) {
				if (px[cur] == 0) continue;
				M = 0;
				cnt = 0;
				ref = 0;
				
				double dx;
				double dy;
				double r;
				boolean scrn;
				for (int v = 0; v < h; v++) {
					for (int u = 0; u < w; u++, ref++) {
						if (px[ref] != 0) continue;
						dx = (double)(x - u);
						dy = (double)(y - v);
						r = Math.sqrt(dx * dx + dy * dy);
						scrn = false;
						for (double i = 2.0; i < r; i += 0.5) {
							int idx =
								(int)((double)v + dy * (i / r) + 0.5) * w
							+	(int)((double)u + dx * (i / r) + 0.5);
							if (px[idx] == 0) {
								scrn = true;
								break;
							}
						}
						if (!scrn) {
							M += 1 / r;
							cnt++;
						}
					}
				}
				if (cnt > 0) {
					M /= (double)cnt;
					pe[cur] = M;
					if (M > maxM) maxM = M;
				}
				
			}
		}
		if (DEBUG) System.out.println(" maxM = " + maxM);
		for (int i = 0; i < w * h; i++) {
			if (pe[i] > thresh || px[i] == 0) px[i] += 0xff0000;
			px[i] += 0xff000000;
			px[i] += (int)(pe[i] / maxM * 255) << 8;
		}

		// 摜HƁA̕Gx
		double lc = 0;
		int S = 0;
		for (int y = 1; y < h - 1; y++) {
			cur = y * w + 1;
			for (int x = 1; x < w - 1; x++, cur++) {
				if ((px[cur] & 0xff0000) == 0) continue;
				S += 1;
				if (((px[cur - 1] & 0xff0000) == 0) ||
					((px[cur + 1] & 0xff0000) == 0) ||
					((px[cur - w] & 0xff0000) == 0) ||
					((px[cur + w] & 0xff0000) == 0))	lc += 1;
			}
		}

		// ʕ\
		double cmplxo = lco * lco / So;
		double cmplx = lc * lc / S;
		if (DEBUG) System.out.println(" Length l = " + lco + " -> " + lc);
		if (DEBUG) System.out.println(" Surface S = " + So + " -> " + S);
		if (DEBUG) System.out.println(" comlexity C=l^2/S = " + cmplxo + " -> " + cmplx);
		if (DEBUG) System.out.println(" comlexity diff. = " + (cmplxo - cmplx));

	}

}
