package imgpdfapp;

import java.io.*;
import java.util.*;
import acolor.*;
import tangram.*;
import tangram.svcs.*;

/**
 * javade tangram PDF Writer
 *   @(#)jvdtPDFWriter.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  18 June.2006
 */
public class jvdtPDFWriter
	extends Imgs
{
	private boolean DEBUG = false;			// fobOp

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 */
	public jvdtPDFWriter() {
	}

	/**
	 * PDF Writer
	 */
	public void writeoutPDF(
		String fn, GeomBank gb, Tangram tan, Listios lios, int col, int mode)
	{
		double w = 620.0, h = 876.0;
		double x, y;
		double trim = 40;
		double trimtp = 20;
		double trimbt = 40;
		double ttlh = 50;
		double efw = w - trim * 2;
		double efh = h - (trimtp + trimbt + ttlh);

		String s = "", t = "";
		final String PDF13HEADER = "%PDF-1.3\r";
		final int lenPDF13HEADER = PDF13HEADER.length();
		final String PDFOBJ10 = "1 0 obj\r<< /Type /Catalog\r/Outlines 2 0 R\r/Pages 3 0 R\r>>\rendobj\r";
		final int lenPDFOBJ10 = PDFOBJ10.length() + lenPDF13HEADER;
		final String PDFOBJ20 = "2 0 obj\r<< /Type /Outlines\r/Count 0\r>>\rendobj\r";
		final int lenPDFOBJ20 = PDFOBJ20.length() + lenPDFOBJ10;
		final String PDFOBJ30 = "3 0 obj\r<< /Type /Pages\r/Kids[4 0 R]\r/Count 1\r>>\rendobj\r";
		final int lenPDFOBJ30 = PDFOBJ30.length() + lenPDFOBJ20;
		final String PDFOBJ40 = "4 0 obj\r<< /Type /Page\r/Parent 3 0 R\r" +
			"/MediaBox[0 0 " + w + " " + h + "]\r/Contents 5 0 R\r" +
			"/Resources\r<<\r/ProcSet [/PDF]\r/Font\r<< /F0\r<<\r/Type /Font\r/Name /F0\r/Subtype /Type1\r/BaseFont /Times-Roman\r/Encoding /WinAnsiEncoding\r>>\r>>\r>>\r" +
			">>\rendobj\r";
		final int lenPDFOBJ40 = PDFOBJ40.length() + lenPDFOBJ30;
		String PDFOBJ50;
		int lenPDFOBJ50;
		final String PDFEOF = "%%EOF\r";

		FileWriter fw;
		try {
			fw = new FileWriter(fn);
		} catch(Exception e) {
			System.out.println(e);
			return;
		}

		writeout(fw, PDF13HEADER);
		writeout(fw, PDFOBJ10);
		writeout(fw, PDFOBJ20);
		writeout(fw, PDFOBJ30);
		writeout(fw, PDFOBJ40);

		double LineWidth = 1 - (1 - ratio) / 2;
		if (LineWidth > 1.0) LineWidth = 1.0;
		s = LineWidth + " w\r"
			+ "0.0 0.0 0.0 RG\r"
			+ "0.0 0.0 0.0 rg\r"
			+ "2 j\r";

		s += "BT\r/F0 32 Tf\r0 0 0 rg ";
		s += (float)(trim) + " " + (float)(h - trimtp - 32) + " Td (" + tan.getPuzzleName() + ") Tj\rET\r";

		int N = lios.getCount();
		for (int n = 0; n < N; n++) {
			x = trim   + ((double)(n % col) + 0.5) / col * efw;
			y = trimtp + ((double)(n / col) + 0.5) / ((N + col - 1) / col) * efh
				+ ttlh;
			y = h - y;

			setSlide((int)x, (int)y);
	
			PieceInfo pi = new PieceInfo();
			PieceInfoTool.copy(pi, lios.get(n));

			for (int m = 0; m < pi.num; m++) {
				s += "% " + m + "\r";
		
				double rofst = (double)n*0 / (double)lios.getCount();
				double r = (double)m / (double)pi.num;
				AColor.setHSV((rofst * 300 + 120 * r) % 360, 0.25, 1.0);

// hԂ̐FƗ֊s̐Fς
				if (mode == 1) {
				s += ((double)AColor.getR()/255) + " " + ((double)AColor.getG()/255) + " " + ((double)AColor.getB()/255) + " RG\r"
				   + ((double)AColor.getR()/255) + " " + ((double)AColor.getG()/255) + " " + ((double)AColor.getB()/255) + " rg\r";
				}

// hԂ̐Fς
			   if (mode == 2) {
				s += ((double)AColor.getR()/255) + " " + ((double)AColor.getG()/255) + " " + ((double)AColor.getB()/255) + " rg\r";
			   }
		
				GeomElem ge = GeomCalc.getPointList(gb, pi, m, ratio, slide_x, slide_y);
				GeomPoint p;
				for (Iterator i = ge.geompoints.iterator(); i.hasNext(); ) {
					p = (GeomPoint)i.next();
					switch (p.kind) {
						case GeomPoint.PATH_MOVETO:
						s += (float)p.x[0] + " " + (float)(slide_y * 2 - p.y[0]) + " m\r";
						break;
						case GeomPoint.PATH_LINETO:
						s += (float)p.x[0] + " " + (float)(slide_y * 2 - p.y[0]) + " l\r";
						break;
						case GeomPoint.PATH_QUADTO:
						s += (float)p.x[0] + " " + (float)(slide_y * 2 - p.y[0]) + " " +
							 (float)p.x[1] + " " + (float)(slide_y * 2 - p.y[1]) + " q\r";
						break;
						case GeomPoint.PATH_CURVETO:
						s += (float)p.x[0] + " " + (float)(slide_y * 2 - p.y[0]) + " " +
							 (float)p.x[1] + " " + (float)(slide_y * 2 - p.y[1]) + " " +
							 (float)p.x[2] + " " + (float)(slide_y * 2 - p.y[2]) + " c\r";
						break;
					}
				}
				s += "b\r";
			}

			s += "BT\r/F0 9 Tf\r0 0 0 rg ";
			s += (float)(slide_x - pi.name.length() * 2) + " " + (float)(slide_y - ratio * 256) + " Td (" + pi.name + ") Tj\rET\r";

		}
		int Length = s.length();
		PDFOBJ50 = "5 0 obj\r"
			+ "<</Length " + s.length() + ">>\r"
			+ "stream\r" + s + "endstream\rendobj\r";
		lenPDFOBJ50 = PDFOBJ50.length() + lenPDFOBJ40;
		writeout(fw, PDFOBJ50);

		s = "xref\r0 " + 6 + "\r0000000000 65535 f \r"
			+ decstr(lenPDF13HEADER) + " 00000 n \r"
			+ decstr(lenPDFOBJ10) + " 00000 n \r"
			+ decstr(lenPDFOBJ20) + " 00000 n \r"
			+ decstr(lenPDFOBJ30) + " 00000 n \r"
			+ decstr(lenPDFOBJ40) + " 00000 n \r"
			+ "trailer\r"
			+ "<< /Size " + 6 + "\r"
			+ "/Root 1 0 R\r"
			+ ">>\r"
			+ "startxref\r" + lenPDFOBJ50 + "\r";
		writeout(fw, s);
		writeout(fw, PDFEOF);

		try {
			fw.close();
		} catch(Exception e) {
			System.out.println(e);
			return;
		}

	}

	private String decstr(int x) {
		String s = "";
		int i, col = (int)(Math.log((double)x) / Math.log(10.0)) + 1;

		for (i = 0; i < (10 - col); i++) s += "0";
		s += Integer.toString(x);

		return s;
	}

	private void writeout(FileWriter fw, String s) {
		System.out.print(s);
		try {
			fw.write(s);
		} catch(Exception e) {
			System.out.println(e);
			return;
		}
	}
}
