package jvdtanapp.menupanel.pathicon;

import java.awt.*;
import java.awt.geom.*;
import java.awt.event.MouseEvent;

import jvdtanapp.*;

/**
 * pXACRNX
 *   @(#)PathIcon.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PathIcon {
	Common comm;

	// ACR
	public String name = "...";
	public int size = 16;
	public int capH = 0;
	public double x;
	public double y;
	public double rad = 0;
	public double zoom = 1.0;

	public boolean enabled = true;
	public boolean forcused = false;

	/**
	 * RXgN^
	 */
	public PathIcon(){
	}

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 */
	public PathIcon(Common comm){
		this.comm = comm;
	}

	/**
	 * Oo^
	 *   @param s ACR̖O
	 */
	public void setName(String s){
		name = s;
	}

	/**
	 * ANVĂяo
	 *   @return Ȃtrue
	 */
	public boolean callAction() {
		if (! enabled) return false;

		return action();
	}

	/**
	 * ANVs
	 *   @return Ȃtrue
	 */
	public boolean action() {
		return true;
	}

	/**
	 * Cl[u
	 */
	public void enable() {
		enabled = true;
	}

	/**
	 * fBZ[u
	 */
	public void disable() {
		enabled = false;
	}

	/**
	 * LǂԂ
	 */
	public boolean isEnabled() {
		return enabled;
	}

	/**
	 * tH[JXĂ邩ǂԂ
	 *   @return tH[JXĂ邩ǂ
	 */
	public boolean isForcused() {
		return forcused;
	}

	/**
	 * ACRɃ}EXڂĂ邩`FbN
	 *   @param e }EXCxg
	 *   @return Ԃωǂ
	 */
	public boolean judgeForcused(MouseEvent e){
		boolean changed = false;

		// łΔ肵Ȃ
		if (! isEnabled()) {
			boolean of = forcused;
			forcused = false;
			return of;
		}

		if (Math.abs(e.getX() - x) < size &&
			Math.abs(e.getY() - y) < size) {
			if (! forcused) changed = true;
			forcused = true;
		} else {
			if (forcused) changed = true;
			forcused = false;
		}
		return changed;
	}

	/**
	 * pX̑czƁA{g嗦ݒ肵āAACR`
	 *   @param g2 `
	 */
	public void drawPathIcon(Graphics2D g2){
		double ratio = 1.0 * zoom;

		int kind[]={ 0 };
		double xarr[]={ 0 };
		double yarr[]={ 0 };

		drawPathIcon_body(g2, kind, 0, 0, xarr, yarr, ratio);
	}

	/**
	 * ۂɃpXACR`
	 *   @param g2 `
	 *   @param kind pX̎ތQ
	 *   @param ox SxW
	 *   @param oy SxW
	 *   @param xarr xWQ
	 *   @param yarr yWQ
	 *   @param ratio g嗦
	 */
	public void drawPathIcon_body(
		Graphics2D g2,
		int[] kind,
		double ox,
		double oy,
		double[] xarr,
		double[] yarr,
		double ratio
	){
		// LtH[JXĂ班g
		if (isForcused() && isEnabled()) ratio *= 1.6;

		GeneralPath path = new GeneralPath();

		int i, idx = 0;
		for (i = 0; i < xarr.length; i++) {
			xarr[i] -= ox;
			yarr[i] -= oy;
		}
		for (i = 0; i < kind.length; i++) {
			switch (kind[i]) {
				case 0:
				path.moveTo((float)xarr[idx], (float)yarr[idx]);
				idx++;
				break;
				case 1:
				path.lineTo((float)xarr[idx], (float)yarr[idx]);
				idx++;
				break;
				case 2:
				path.quadTo((float)xarr[idx],   (float)yarr[idx],
							(float)xarr[idx+1], (float)yarr[idx+1]);
				idx += 2;
				break;
				case 3:
				path.curveTo((float)xarr[idx],  (float)yarr[idx],
							(float)xarr[idx+1], (float)yarr[idx+1],
							(float)xarr[idx+2], (float)yarr[idx+2]);
				idx += 3;
				break;
			}
		}
		path.closePath();
		path.transform(new AffineTransform(
			 Math.cos(rad) * ratio, Math.sin(rad) * ratio,
			-Math.sin(rad) * ratio, Math.cos(rad) * ratio,
			 x, y)
			);

/*
		// ֊s
		if (isEnabled()) {
			g2.setColor(comm.pathIcon_EdgeColor);
		} else {
			g2.setColor(comm.pathIcon_DisableEdgeColor);
		}
		g2.setStroke(new BasicStroke((float)(1.2 * zoom) + 6,
			BasicStroke.CAP_ROUND,
			BasicStroke.JOIN_BEVEL));
		g2.draw(path);
*/

		// 
		if (isEnabled()) {
			g2.setColor(comm.pathIcon_LineColor);
		} else {
			g2.setColor(comm.pathIcon_DisableLineColor);
		}
		g2.setStroke(new BasicStroke((float)(1.2 * zoom),
			BasicStroke.CAP_ROUND,
			BasicStroke.JOIN_BEVEL));
		g2.draw(path);

		// Ȃΐ
		if (! isEnabled()) {
			g2.setColor(comm.pathIcon_SlashColor);
			g2.setStroke(new BasicStroke((float)(4.0 * zoom)));
			g2.drawLine((int)x - size, (int)y - size, (int)x + size, (int)y + size);
		}

		// tH[JXĂ疼O\
		if (isEnabled() && isForcused()) {
			g2.setColor(comm.pathIcon_NameColor);
			g2.setFont(comm.pathIcon_NameFont);
			g2.drawString(name,
				(float)(x - size), (float)(y - (size + capH) * 8 / 5));
		}
	}
}
