package jvdtanapp.playpanel;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import jvdtanapp.*;
import tangram.svcs.*;
import tangram.*;

/**
 * vCplNX
 *   @(#)PlayPanel.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PlayPanel
		extends JPanel
		implements  MouseListener,
					MouseMotionListener,
					MouseWheelListener,
					Runnable {

	private boolean DEBUG = Common.DEBUG_PlayPanel;	// fobOp

	Common comm;
	MainFrame mf;

	public Tangram tan;
	public Listios lios;
	public Imgs imgs;
	public Opes opes;

	public Thread th = null;			// g̃^C}[XV邽߂̃Xbh
	public PseudoRipple ripple;			// g`NX
	public int RippleTimer;				// }EX{^𗣂ɔgȂ^C}[
	
	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param mf eNX
	 */
	public PlayPanel(Common comm, MainFrame mf) {
		this.comm = comm;
		this.mf = mf;

		tan = mf.tan;
		lios = mf.lios;
		imgs = new Imgs();
		opes = new Opes(tan, imgs);

		comm.setjvdtImgsparam(imgs);
		comm.setjvdtOpesparam(opes);

		ripple		= new PseudoRipple();
		th			= new Thread(this);
		
		addMouseMotionListener(this);
		addMouseListener(this);
		addMouseWheelListener(this);
	}

	/**
	 * ʂ`
	 *   @param g `
	 */
	private int bufWidth = 0;
	private int bufHeight = 0;
	public void paint(Graphics g) {
		Graphics2D g2 = (Graphics2D)g;

		// TCY
		if (getWidth() != bufWidth ||
			getHeight() != bufHeight) {
				if (DEBUG) System.out.println("Resize PlayPnael");				

				bufWidth = getSize().width;
				bufHeight = getSize().height;

				Common.setAA(g2);
				imgs.setSlide(bufWidth/2, bufHeight/2);	// jvdtImgsɉʃTCYʒm
		}

		if (comm.checkerBoard)
		{ // ñ`FbN͗l`
			int n = 0;
			for (int y = 0; y < bufHeight; y += 64){
				for (int x = 0; x < bufWidth; x += 64){
					if ((((x>>6) + (y>>6)) & 1) == 0) {
						n = 255 - ((x>>6)<<2);
					} else {
						n = 128 + ((x>>6)<<2) - ((y>>6)<<2);
					}
					
					g2.setColor(new Color(n,n,n));
					g2.fillRect(x, y, 64, 64);
				}
			}
		} else {
			g2.setColor(comm.playPanel_BGColor);
			g2.fillRect(0, 0, bufWidth, bufHeight);
		}
		// KCh`
		if (comm.GuideDispSW &&
			lios.getIndex() >= 0 && lios.getCount() > 0) {

			Color original_color = comm.pieces_Color;
			Stroke original_stroke = comm.solidLine_Stroke;
			PieceInfo pi = new PieceInfo();
			PieceInfoTool.copy(pi, lios.get(lios.getIndex()));

			imgs.setPiecesColor(comm.Guide_solidLine_Color);
			imgs.setPiecesColord(comm.Guide_solidLine_Color);
			imgs.setSolidLineStroke(comm.Guide_solidLine_Stroke);
			imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
							false, false, false, null);
			imgs.setPiecesColor(comm.playPanel_BGColor);
			imgs.setPiecesColord(comm.playPanel_BGColor);
			imgs.setSolidLineStroke(comm.Guide_bulkLine_Stroke);
			imgs.drawPieces(g2, tan.geombank, pi, tan.piext, PieceInfoExt.MODE_ALL,
							true, false, false, null);

			imgs.setPiecesColor(original_color);
			imgs.setPiecesColord(original_color);
			imgs.setSolidLineStroke(original_stroke);
		}

		// X[vs[X`
		imgs.drawPieces(g2, tan.geombank, tan.pinfo, tan.piext,
						PieceInfoExt.MODE_SLEEP, true,
						opes.getStateOpe() == Opes.STATE_OPE_ZOOMING,
						true, null);

		// ANeBus[X`
		imgs.drawPieces(g2, tan.geombank, tan.pinfo, tan.piext,
						PieceInfoExt.MODE_ACTIVE, false,
						opes.getStateOpe() == Opes.STATE_OPE_ZOOMING,
						true, null);

		// I``
		if (opes.getStateOpe() == Opes.STATE_OPE_SLCTRECT)
			imgs.drawSelectRect(g2, opes.rxs, opes.rys, opes.rxe, opes.rye);

		// g`
		ripple.drawRipple(g2);

		// g嗦\
		if (opes.getStateOpe() == Opes.STATE_OPE_ZOOMING) {
			g2.setColor(comm.List_NameColor);
			g2.drawString(((int)(imgs.ratio*100)) + "%", 2, 12);
		}

	}

	/**
	 * Xbh
	 */
	public void run(){
		try {
			while (true) {
				if (RippleTimer > 0) RippleTimer--;
				if (ripple.count() == 0) break;
				ripple.goRippleTime();
				repaint();
				th.sleep(25);
			}
			if (DEBUG) System.out.println("Thread Terminated");
		} catch (Exception e){
			System.out.println(e);
		}
	}
	
	/**
	 * ǧu
	 *   @param x xW
	 *   @param y yW
	 */
	public void putRippleEmbryo(int x, int y){
		if (! comm.rippleEnable) return;
		
		if (ripple.createRipple(x, y)) {	// Vg䂪ꂽǂ
			RippleTimer = 25;				// ^C}[XV

			if (! th.isAlive()) {			// XbhĂ邩ǂ
				th = new Thread(this);		// Xbh
				th.start();					// X^[g
				if (DEBUG) System.out.println("Thread Start");
			}

		}
	}

	/**
	 * }EXXi[Q
	 *   @param e }EXCxg
	 */
	public void mouseDragged(MouseEvent e) {
		e.consume();
		opes.mouseDragged(e);

		repaint();
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mousePressed(MouseEvent e) {
		e.consume();

		putRippleEmbryo(e.getX(), e.getY());

		// zC[{^ŃGfBbg
		if (e.getButton() == MouseEvent.BUTTON2) {
			if (comm.actionEditEdit()) {
				return;
			}
		}

		opes.mousePressed(e);
		repaint();
	}
	
	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mouseReleased(MouseEvent e) {
		e.consume();

		if (RippleTimer <= 0) {
			putRippleEmbryo(e.getX(), e.getY());
		}

		int laststate = opes.getStateOpe();
		opes.mouseReleased(e);
		repaint();

		// s[XŒ莞AAhD[obt@ɃGg[
		if (laststate == Opes.STATE_OPE_WAIT &&
			opes.getStateOpe() == Opes.STATE_OPE_NONE) {
				comm.actionEditEntry();
		}
	}
	
	/**
	 * }EXړ
	 *   @param e }EXCxg
	 */
	public void mouseMoved(MouseEvent e) {
		e.consume();

		opes.mouseMoved(e);

		if (opes.getStateOpe() != Opes.STATE_OPE_NONE) {
			repaint();
		}
	}

	/**
	 * }EXzC[Cxg
	 *   @param e }EXCxg
	 */
	public void mouseWheelMoved(MouseWheelEvent e) {
		if (comm.actionListMoveIndex(e.getWheelRotation())) {
			comm.refreshListPanel();
			repaint();
		}
	}

	public void mouseEntered(MouseEvent e) {}
	public void mouseExited(MouseEvent e) {}
	public void mouseClicked(MouseEvent e) {}

}
