package jvdtanapp.playpanel;

import java.awt.*;

/**
 * [gNX
 *   @(#)PseudoRipple.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PseudoRipple {
	public boolean DEBUG = true;			// fobOp

	private final int MAXRIPPLENUM = 10;	// g̍ő吔
	private boolean alive[];				// g䂪邩ǂ
	private int ox[];						// SxW
	private int oy[];						// SyW
	private int t[];						// ^C}[

	/**
	 * RXgN^
	 */
	public PseudoRipple(){
		alive 	= new boolean[MAXRIPPLENUM];
		ox 		= new int[MAXRIPPLENUM];
		oy 		= new int[MAXRIPPLENUM];
		t 		= new int[MAXRIPPLENUM];
		for (int i = 0; i <MAXRIPPLENUM; i++) alive[i] = false;
	}

	/**
	 * Vg̐
	 *   @param x SxW
	 *   @param y SyW
	 *   @return g䂪ꂽǂ
	 */
	public boolean createRipple(int x, int y) {
		for (int i = 0; i < MAXRIPPLENUM; i++) {
			if (! alive[i]) {
				ox[i] = x;
				oy[i] = y;
				t[i]  = 0;
				alive[i] = true;
				return true;
			}
		}
		return false;
	}

	/**
	 * g̐Ԃ
	 *   @return g̐
	 */
	public int count(){
		int c = 0;
		for (int i = 0; i <MAXRIPPLENUM; i++) c += (alive[i]) ? 1 : 0;
		return c;
	}
	
	/**
	 * g̃^C}[i߂
	 */
	public void goRippleTime(){
		for (int i = 0; i <MAXRIPPLENUM; i++) {
			if (alive[i]) t[i]++;
		}
	}
	
	/**
	 * g`
	 *   @param g2 `
	 */
	public void drawRipple(Graphics2D g2){
		int a[] = new int[MAXRIPPLENUM];
		int r;
		
		g2.setStroke(new BasicStroke(1.0f));

		// e
		for (int i = 0; i <MAXRIPPLENUM; i++) {
			if (! alive[i]) continue;
			a[i] = (int)(Math.exp(-(double)t[i] / 25.0) * 255.0);
			if (a[i] == 0) {
				alive[i] = false;
				continue;
			}
			r = t[i];
			
			g2.setColor(new Color(0, 0, 0, a[i] / 2));
			g2.drawOval(ox[i] - r + 10, oy[i] - r + 10, r * 2, r * 2);
		}
		
		// {
		for (int i = 0; i <MAXRIPPLENUM; i++) {
			if (! alive[i]) continue;
			r = t[i];

			g2.setColor(new Color(255, 255, 255, a[i]));
			g2.drawOval(ox[i] - r, oy[i] - r, r * 2, r * 2);
		}
	}
}
