package somapp;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;

import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JToggleButton;

/**
 * R\[plNX
 *   @(#)ConsolePanel.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  23 Nov.2007
 */
public class ConsolePanel
		extends JPanel
		implements ActionListener
{
	public final boolean DEBUG = true;
	private boolean isApplet;
	private boolean busy = false;

	MainPanel mp;
	TSOM tSOM = null;

	JButton btreadprecalc;
	JButton btcalc;
	JCheckBox cbrefimgout;
	JCheckBox cbmapimgout;
	JCheckBox cbmtximgout;
	JSpinner spmtximgw;
	JSpinner spmtximgh;
	JSpinner spmtximgc;
	JSpinner spmtximgr;
	
	/**
	 * RXgN^
	 *   @param comm ʃNX
	 *   @param mf eNX
	 */
	public ConsolePanel(boolean isApplet, MainPanel mp, TSOM tSOM) {
		this.isApplet = isApplet;
		this.mp = mp;
		this.tSOM = tSOM;

		setLayout(new BorderLayout());

		JPanel panel = new JPanel();
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));

		btreadprecalc = new JButton();
		btreadprecalc.setActionCommand("readprecalc");
		btreadprecalc.setText("Read and precalc");
		btreadprecalc.addActionListener(this);
		panel.add(btreadprecalc);
		
		btcalc = new JButton();
		btcalc.setActionCommand("calc");
		btcalc.setText("calc map");
		btcalc.addActionListener(this);
		panel.add(btcalc);

		cbrefimgout = new JCheckBox();
		cbrefimgout.setActionCommand("togglerefimgout");
		cbrefimgout.setText("refimgout");
		cbrefimgout.setSelected(tSOM.REFIMGOUT);
		cbrefimgout.addActionListener(this);
		panel.add(cbrefimgout);
	
		cbmapimgout = new JCheckBox();
		cbmapimgout.setActionCommand("togglemapimgout");
		cbmapimgout.setText("mapimgout");
		cbmapimgout.setSelected(tSOM.MAPIMGOUT);
		cbmapimgout.addActionListener(this);
		panel.add(cbmapimgout);
	
		cbmtximgout = new JCheckBox();
		cbmtximgout.setActionCommand("togglemtximgout");
		cbmtximgout.setText("mtximgout");
		cbmtximgout.setSelected(tSOM.MTXIMGOUT);
		cbmtximgout.addActionListener(this);
		panel.add(cbmtximgout);

		add("North", panel);
		
		panel = new JPanel();
		panel.setLayout(new FlowLayout(FlowLayout.CENTER));

		JLabel lb;

		lb = new JLabel();
		lb.setText("mtxw");
		panel.add(lb);
		spmtximgw = new JSpinner();
		spmtximgw.setValue(tSOM.mtximgw);
		spmtximgw.setValue(tSOM.mtximgw);
		panel.add(spmtximgw);
		
		lb = new JLabel();
		lb.setText("mtxh");
		panel.add(lb);
		spmtximgh = new JSpinner();
		spmtximgh.setValue(tSOM.mtximgh);
		panel.add(spmtximgh);
		
		lb = new JLabel();
		lb.setText("mtxc");
		panel.add(lb);
		spmtximgc = new JSpinner();
		spmtximgc.setValue(tSOM.mtximgcol);
		panel.add(spmtximgc);

		lb = new JLabel();
		lb.setText("mtxr");
		panel.add(lb);
		spmtximgr = new JSpinner();
		spmtximgr.setValue((int)(tSOM.mtximgr * 1000));
		panel.add(spmtximgr);

		add("South", panel);

	}

	/**
	 * ANVfBXpb`
	 */
	public void actionPerformed(ActionEvent e) {
		// dsh~
		if (!busy) { 
			busy = true;

			String command = e.getActionCommand();
			if (DEBUG) System.out.println(command);
	
			if (e.getSource() instanceof JButton) {

				tSOM.mtximgw = (Integer)(spmtximgw.getValue());
				tSOM.mtximgh = (Integer)(spmtximgh.getValue());
				tSOM.mtximgcol = (Integer)(spmtximgc.getValue());
				tSOM.mtximgr = (double)((Integer)(spmtximgr.getValue())) / 1000.0;
				
				if (command.equals("readprecalc")) {
					if (! isApplet) {
						// t@Cǂݍ
						JFileChooser chooser = new JFileChooser();
						chooser.setCurrentDirectory(new File("res"));
						int retval = chooser.showOpenDialog(this);
						if (retval == JFileChooser.APPROVE_OPTION) {
							String path = chooser.getSelectedFile().getPath();
							//String name = chooser.getSelectedFile().getName();
		
							tSOM.clear();
							tSOM.readSilhouettes(path);
							tSOM.precalculate();
							
							mp.setImage(tSOM.getImage());
							mp.repaint();
						}
					}			
				}
				if (command.equals("calc")) {
					tSOM.calculate();				

					mp.setImage(tSOM.getImage());
					mp.repaint();
				}
			}

			if (e.getSource() instanceof JToggleButton) {
				if (command.equals("togglerefimgout")) {
					tSOM.REFIMGOUT = !tSOM.REFIMGOUT;
				}
				if (command.equals("togglemapimgout")) {
					tSOM.MAPIMGOUT = !tSOM.MAPIMGOUT;
				}
				if (command.equals("togglemtximgout")) {
					tSOM.MTXIMGOUT = !tSOM.MTXIMGOUT;
				}
			}
			
			busy = false;
		}
	}	

}
