package tangram;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * }`oNNX
 *   @(#)GeomBank.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class GeomBank {
	public List<GeomElem> geombank;
	
	public static final String MOVETO  = "moveTo";
	public static final String LINETO  = "lineTo";
	public static final String QUADTO  = "quadTo";
	public static final String CURVETO = "curveTo";
	
	/**
	 * RXgN^
	 *   ^Õs[Xŏ
	 */
	public GeomBank() {
		geombank = new ArrayList<GeomElem>(20);
		clear();
	}
	
	/**
	 * }`XgNA
	 */
	public void clear() {
		geombank.clear();
	}

	/**
	 * }`Xgɒǉ
	 *   @param ge ǉ}`
	 */
	public void add(GeomElem ge) {
		geombank.add(ge);
	}

	/**
	 * w肳ꂽ̂̐}`Ԃ
	 *   @param id
	 *   @return ȂꍇnullԂ
	 */
	public GeomElem getGeomElem(String id) {
		GeomElem ge = null;

		Iterator<GeomElem> i;
		for (i = geombank.iterator(); i.hasNext(); ) {
			ge = (GeomElem)i.next();
			if (id.compareTo(ge.id) == 0) {
				return ge;
			} 
		}
		return null;
	}

	/**
	 * ^O̐}`oNZbg
	 */
	public void setTraditionalTangram() {
		GeomElem ge;

		ge = new GeomElem("Mt", 28, 28);
		ge.add(new GeomPoint(GeomPoint.PATH_MOVETO, 0, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 80));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 80, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 0));
		geombank.add(ge);

		ge = new GeomElem("St", 40, 14);
		ge.add(new GeomPoint(GeomPoint.PATH_MOVETO, 0, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 40, 40));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 80, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 0));
		geombank.add(ge);

		ge = new GeomElem("Sq", 40, 40);
		ge.add(new GeomPoint(GeomPoint.PATH_MOVETO, 40, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 40));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 40, 80));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 80, 40));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 40, 0));
		geombank.add(ge);

		ge = new GeomElem("Pa", 20, 60);
		ge.add(new GeomPoint(GeomPoint.PATH_MOVETO, 0, 40));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 120));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 40, 80));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 40, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 40));
		geombank.add(ge);

		ge = new GeomElem("Lt", 56, 80);
		ge.add(new GeomPoint(GeomPoint.PATH_MOVETO, 0, 80));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 80, 160));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 80, 0));
		ge.add(new GeomPoint(GeomPoint.PATH_LINETO, 0, 80));
		geombank.add(ge);
	}

	public String toString() {
		StringBuffer s = new StringBuffer();
		
		for (Iterator<GeomElem> i = geombank.iterator(); i.hasNext(); ) {
			GeomElem ge = (GeomElem)i.next();
			s.append("\t\t<geom id=\"");
			s.append(ge.id);
			s.append("\">\n");
			s.append("\t\t\t<p kind=\"origin\">");
			s.append(Double.toString(ge.local_ox));
			s.append(" ");
			s.append(Double.toString(ge.local_oy));
			s.append("</p>\n");
			for (Iterator<GeomPoint> j = ge.geompoints.iterator(); j.hasNext(); ) {
				GeomPoint gp = (GeomPoint)j.next();
				s.append("\t\t\t<p kind=\"");
				switch (gp.kind) {
					case GeomPoint.PATH_MOVETO:
					s.append(MOVETO);
					break;
					case GeomPoint.PATH_LINETO:
					s.append(LINETO);
					break;
					case GeomPoint.PATH_QUADTO:
					s.append(QUADTO);
					break;
					case GeomPoint.PATH_CURVETO:
					s.append(CURVETO);
					break;
				}
				s.append("\">");
				for (int k = 0; k < gp.num; k++) {
					s.append(Double.toString(gp.x[k]));
					s.append(" ");
					s.append(Double.toString(gp.y[k]));
					if (k + 1 != gp.num) s.append("  ");
				}
				s.append("</p>\n");
			}
			s.append("\t\t</geom>\n");
		}
		
		return s.toString();
	}
}
