package tangram;

import java.util.*;

/**
 * 􉽌vZNX
 *   @(#)GeomCalc.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  13 May 2007
 */
public class GeomCalc {

	/**
	 * RXgN^
	 */
	public GeomCalc() {
	}

	/**
	 * PieceInfo̎w肵s[X̉]E]EgEړ̍WvZ
	 *   ړƊgł́Ag傪ɍs
	 *   @param gb GeomBank
	 *   @param pi PieceInfo
	 *   @param n  s[Xԍ
	 *   @param ratio g嗦
	 *   @param sldx xړ
	 *   @param sldy xړ
	 *   @return ʂ̐}`
	 */
	public static GeomElem getPointList(GeomBank gb, PieceInfo pi, int n,
		double ratio, double sldx, double sldy)
	{
		GeomElem basege;
		GeomElem ge = new GeomElem();

		basege = gb.getGeomElem(pi.id[n]);
		if (basege == null) return null;

		double sin = Math.sin(pi.rad[n]);
		double cos = Math.cos(pi.rad[n]);
		double ox = basege.local_ox;
		double oy = basege.local_oy;

		for (Iterator<GeomPoint> i = basege.geompoints.iterator(); i.hasNext(); ) {
			GeomPoint basegp = (GeomPoint)i.next();
			GeomPoint gp = new GeomPoint();
			gp.kind = basegp.kind;
			gp.num = basegp.num;
			for (int j = 0; j < gp.num; j++) {
				gp.x[j] = pi.x[n] + cos * (pi.flip[n] * (basegp.x[j] - ox))
								  - sin * (basegp.y[j] - oy);
				gp.y[j] = pi.y[n] + sin * (pi.flip[n] * (basegp.x[j] - ox))
								  + cos * (basegp.y[j] - oy);

				gp.x[j] *= ratio;
				gp.y[j] *= ratio;

				gp.x[j] += sldx;
				gp.y[j] += sldy;
			}
			ge.add(gp);
		}

		return (ge);
	}
}
