package tangram;

/**
 * s[Xɂ܂c[Q
 *   @(#)PieceInfoTool.class
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 */
public class PieceInfoTool {

	/**
	 * RXgN^
	 */
	public PieceInfoTool() {
	}

	/**
	 * ^OZbg
	 *   @param pinfo Zbg
	 *   @return s[Xi=7j
	 */
	public static int setTraditionalTangram(PieceInfo pinfo) {
		int num  = 7;
		pinfo.name = "";

		if (pinfo.num  != num) {
			pinfo.num  = num;

			pinfo.x 	= new double[num];
			pinfo.y 	= new double[num];
			pinfo.rad 	= new double[num];
			pinfo.flip	= new double[num];
			pinfo.id 	= new String[num];
		}

		pinfo.id[0]		= "Mt";
		pinfo.x[0]		= -51.576286891558766;
		pinfo.y[0]		= -51.85501493832457;
		pinfo.rad[0]	= redrad2pi(6.283185307179586);
		pinfo.flip[0]	= 1.0;

		pinfo.id[1]		= "St";
		pinfo.x[1]		= 40.423713108441234;
		pinfo.y[1]		= -65.8550149383246;
		pinfo.rad[1]	= redrad2pi(6.283185307179586);
		pinfo.flip[1]	= 1.0;

		pinfo.id[2]		= "Sq";
		pinfo.x[2]		= 0.4237131084412278;
		pinfo.y[2]		= -39.855014938324544;
		pinfo.rad[2]	= redrad2pi(0.0);
		pinfo.flip[2]	= -1.0;

		pinfo.id[3]		= "St";
		pinfo.x[3]		= -25.57628689155881;
		pinfo.y[3]		= 0.1449850616754471;
		pinfo.rad[3]	= redrad2pi(4.71238898038469);
		pinfo.flip[3]	= 1.0;

		pinfo.id[4]		= "Pa";
		pinfo.x[4]		= -59.576286891558745;
		pinfo.y[4]		= 20.144985061675442;
		pinfo.rad[4]	= redrad2pi(6.283185307179586);
		pinfo.flip[4]	= 1.0;

		pinfo.id[5]		= "Lt";
		pinfo.x[5]		= 56.42371310844124;
		pinfo.y[5]		= 0.1449850616754258;
		pinfo.rad[5]	= redrad2pi(6.283185307179586);
		pinfo.flip[5]	= 1.0;

		pinfo.id[6]		= "Lt";
		pinfo.x[6]		= 0.42371310844125265;
		pinfo.y[6]		= 56.14498506167547;
		pinfo.rad[6]	= redrad2pi(1.5707963267948966);
		pinfo.flip[6]	= 1.0;

		return num;
	}

	/**
	 * PieceInfo̓eRs[
	 *   @param dstpinfo Rs[
	 *   @param srcpinfo Rs[
	 *   @return Rs[s[X
	 */
	public static int copy(PieceInfo dstpinfo, PieceInfo srcpinfo) {
		if (dstpinfo.num  != srcpinfo.num) {
			dstpinfo.num  = srcpinfo.num;

			dstpinfo.x 		= new double[srcpinfo.num];
			dstpinfo.y 		= new double[srcpinfo.num];
			dstpinfo.rad 	= new double[srcpinfo.num];
			dstpinfo.flip	= new double[srcpinfo.num];
			dstpinfo.id 	= new String[srcpinfo.num];
		}

		dstpinfo.name = srcpinfo.name.toString();

		for (int i = 0; i < srcpinfo.num; i++) {
			dstpinfo.x[i]   = srcpinfo.x[i];
			dstpinfo.y[i]   = srcpinfo.y[i];
			dstpinfo.rad[i] = redrad2pi(srcpinfo.rad[i]);
			dstpinfo.flip[i]= srcpinfo.flip[i];
			dstpinfo.id[i]  = srcpinfo.id[i].toString();
		}

		return dstpinfo.num;
	}

	/**
	 * PieceInfõs[XԂ
	 *   @return s[X
	 */
	public static int count(PieceInfo pinfo) {
		return pinfo.num;
	}

	/**
	 * VGbg̖Oݒ
	 *   @param s VGbg̖O
	 */
	public static void setName(PieceInfo pi, String s) {
		pi.name = s.toString();
	}

	/**
	 * VGbg̖O擾
	 *   @return VGbg̖O
	 */
	public static String getName(PieceInfo pi) {
		return 	pi.name.toString();
	}

	/**
	 * PieceInfoxWςԂ
	 *   @return xW
	 */
	public static double getXAverage(PieceInfo pi) {
		if (pi.num == 0) return 0;

		double xave = 0;
		for (int i = 0; i < pi.num; i++) xave += pi.x[i];
		return xave / (double)pi.num;
	}

	/**
	 * PieceInfoyWςԂ
	 *   @return yW
	 */
	public static double getYAverage(PieceInfo pi) {
		if (pi.num == 0) return 0;

		double yave = 0;
		for (int i = 0; i < pi.num; i++) yave += pi.y[i];
		return yave / (double)pi.num;
	}

	/**
	 * ws[X̑Ή]
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param drad ]px
	 */
	public static void rotate(PieceInfo pi, int n, double drad) {
		pi.rad[n] = redrad2pi(pi.rad[n] + drad);
	}

	/**
	 * ws[X̉]
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param rad ]px
	 */
	public static void rotateTo(PieceInfo pi, int n, double rad) {
		pi.rad[n] = redrad2pi(rad);
	}

	/**
	 * ws[X̋t]
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 */
	public static void rotReverse(PieceInfo pi, int n) {
		pi.rad[n] = redrad2pi(2 * Math.PI - pi.rad[n]);
	}

	/**
	 * ws[X̊pxw肵PʂɊۂ߂
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param unitdeg pxP
	 *   @return ۂɉ]px
	 */
	public static double adjustDegree(PieceInfo pi, int n, double unitdeg) {
		double drad = 0;
		double unitrad = unitdeg * Math.PI / 180.0;
		int unitmul;
		
		unitmul = (int)((pi.rad[n] + unitrad / 2.0) / unitrad);
		drad = (double)unitmul * unitrad - pi.rad[n];
		pi.rad[n] = redrad2pi(pi.rad[n] + drad);
		
		return drad;
	}

	/**
	 * 2΂ɐ܂Ԃ
	 *   @param rad WA
	 *   @return 2΂ɐ܂ԂpxiWAj
	 */
	public static double redrad2pi(double rad) {
		double redrad = rad;
		double dpi = 2 * Math.PI;
		for (;;) {
			if (redrad < 0) {
				redrad += dpi;
				continue;
			}
			if (redrad > dpi) {
				redrad -= dpi;
				continue;
			}
			break;
		}
		return redrad;
	}

	/**
	 * ws[X̑Έړ
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param dx xړ
	 *   @param dy yړ
	 */
	public static void move(PieceInfo pi, int n, double dx, double dy) {
		pi.x[n] += dx;
		pi.y[n] += dy;
	}

	/**
	 * ws[Ẍړ
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param x xW
	 *   @param y yW
	 */
	public static void moveTo(PieceInfo pi, int n, double x, double y) {
		pi.x[n] = x;
		pi.y[n] = y;
	}

	/**
	 * ws[X̑Δ]
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 */
	public static void flip(PieceInfo pi, int n) {
		pi.flip[n] = -pi.flip[n];
	}

	/**
	 * ws[X̔]
	 *   @param pi PieceInfo
	 *   @param n s[Xԍ
	 *   @param flp ][-1,1]
	 */
	public static void flipTo(PieceInfo pi, int n, double flp) {
		pi.flip[n] = flp;
	}

	/**
	 * to String
	 *   @param pi PieceInfo
	 *   @return PieceInfo
	 */
	public static String toString(PieceInfo pi) {
		StringBuffer s = new StringBuffer();
		s.append("\t\t<silhouette name=\"");
		s.append(getName(pi));
		s.append("\">\n");

		for (int i = 0; i < count(pi); i++ ) {
			s.append("\t\t\t");
			s.append(pi.id[i]);
			s.append(" ");
			s.append(pi.x[i]);
			s.append(" ");
			s.append(pi.y[i]);
			s.append(" ");
			s.append(pi.rad[i]);
			s.append(" ");
			s.append(pi.flip[i]);
			s.append("\n");
		}

		s.append("\t\t</silhouette>\n");
		
		return s.toString();
	}
}
