package tangram.svcs;

import java.awt.*;
import java.awt.geom.*;
import java.util.*;
import tangram.*;

/**
 * javade tangram `֘AT[rX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.3  20 May 2007
 */
public class Imgs {
	//private final boolean DEBUG = false;			// fobOp

	private boolean AntiAliasing = true;	// A`GCAX

	private final double minratio = 0.01;	// g嗦
	private final double maxratio = 10.0;	// g嗦

	public double ratio;					// g嗦
	public double slide_x = 0.0;			// ʂ̒SxW
	public double slide_y = 0.0;			// ʂ̒SW

	private Color pieces_Color = new Color(0, 0, 0, 255);	// \ʂ̐F
	private Color pieces_Colord = new Color(0, 0, 0, 255);	// ʂ̐F

	private Color dottedLine_Color = new Color(0, 0, 0, 180);
	private Stroke dottedLine_Stroke =
		new BasicStroke(2.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
						0, new float[]{1,4}, 0);
	private Stroke dashedLine_Stroke =
		new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
						0, new float[]{4,4}, 0);
	private Stroke solidLine_Stroke =
		new BasicStroke(1.0f, BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);

	/**
	 * RXgN^
	 *   @param comm ʃNX
	 */
	public Imgs() {
		setRatio(1.0);
	}

	public Imgs(double ratio) {
		setRatio(ratio);
	}

	/**
	 * ʒSWZbg
	 *   @param w ʂ̕[px]
	 *   @param h ʂ̍[px]
	 */
	public void setSlide(int w, int h) {
		slide_x = (double)w;
		slide_y = (double)h;
	}

	/**
	 * g嗦Zbg
	 *   @param r
	 */
	public void setRatio(double r) {
		if (r < minratio) r = minratio;
		if (r > maxratio) r = maxratio;
		ratio = r;

		setLineStroke(ratio);
	}

	/**
	 * ̍Wɂs[X̔ԍԂ
	 * @@@param tan ^ONX
	 * @@@param x xW
	 * @@@param y yW
	 * @@@return s[XԍBs[XȂ-1Ԃ
	 */
	public int whichPieceIsHere(Tangram tan, int x, int y) {
		GeomBank gb = tan.geombank;
		PieceInfo pi = tan.pinfo;
		PieceInfoExt pe = tan.piext;
		GeneralPath gp;

		for (int n = 0; n < pi.num; n++) {
			int m;
			// I[_[̎Ⴂs[Xɒׂ
			for (m = 0; m < pi.num; m++) if (pe.order[m] == n) break;
			GeomElem ge = GeomCalc.getPointList(gb, pi, m, ratio, slide_x, slide_y);
			if (ge == null) {
				break;
			}
			gp = getRawGeneralPath(ge);

			if (gp.contains((double)x, (double)y)) return m;
		}
		return -1;
	}

	/**
	 * A`GCAXݒ
	 *   @param g2 Kp
	 */
	public void setAntiAliasing(boolean AA) {
		AntiAliasing = AA;
	}
	private void setAA(Graphics2D g2) {
		if (AntiAliasing) {
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
								RenderingHints.VALUE_ANTIALIAS_ON);
		} else {
			g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, 
								RenderingHints.VALUE_ANTIALIAS_OFF);
		}
	}

	/**
	 * s[XI``
	 *   @param g2 `
	 *   @param xs `xW
	 *   @param ys `yW
	 *   @param xe `ExW
	 *   @param ye `EyW
	 */
	public void drawSelectRect(Graphics2D g2, int xs, int ys, int xe, int ye) {
		setAA(g2);
		g2.setColor(dottedLine_Color);
		g2.setStroke(dottedLine_Stroke);
		g2.setXORMode(Color.WHITE);

		int w = Math.abs(xe - xs) + 1;
		int h = Math.abs(ye - ys) + 1;
		xs = Math.min(xs, xe);
		ys = Math.min(ys, ye);
		g2.drawRect(xs, ys, w, h);
	}

	/**
	 * s[X`
	 *   @param g2 `
	 *   @param gb GeoomBank
	 *   @param pi PieceInfo
	 *   @param pe PieceInfoExt
	 *   @param mode ǂ̃[h̃s[X`
	 *   @param filling hԂǂ
	 *   @param dashed ֊sjɂ邩ǂ
	 *   @param autostroke Xg[NĐݒ肷邩ǂ
	 *   @param stroke Xg[NݒAnullȂNX̐ݒɏ]
	 */
	public void drawPieces(
		Graphics2D g2, GeomBank gb, PieceInfo pi, PieceInfoExt pe,
		int mode,
		boolean filling,
		boolean dashed,
		boolean autostroke,
		Stroke stroke)
	{
		GeneralPath gp;
		setAA(g2);

		if (autostroke) setLineStroke(ratio);
		if (! dashed) {	g2.setStroke(solidLine_Stroke);
		} else {		g2.setStroke(dashedLine_Stroke);
		}
		if (stroke != null) g2.setStroke(stroke);

		for (int n = 0; n < pi.num; n++) {
			int m;

			// I[_[̎Ⴂs[Xɕ`
			for (m = 0; m < pi.num; m++) if (pe.order[m] == pi.num - 1 - n) break;
			if ((pe.mode[m] & mode) != 0) {

				// \ŐFς
				if (pi.flip[m] > 0) {
					// \
					g2.setColor(pieces_Color);
				} else {
					// 
					g2.setColor(pieces_Colord);					
				}

				GeomElem ge = GeomCalc.getPointList(gb, pi, m, ratio, slide_x, slide_y);
				if (ge == null) {
					break;
				}
				gp = getRawGeneralPath(ge);

				if (filling) g2.fill(gp);
				g2.draw(gp);
			}
		}
	}

	/**
	 * GeomElemGeneralPathɕϊ
	 *   @param ge ϊGeomElem
	 *   @return geGeneralPathɕϊĕԂ
	 */
	public GeneralPath getRawGeneralPath(GeomElem ge) {
		GeneralPath gp = new GeneralPath();
		GeomPoint p;

		for (Iterator<GeomPoint> i = ge.geompoints.iterator(); i.hasNext(); ) {
			p = (GeomPoint)i.next();
			switch (p.kind) {
				case GeomPoint.PATH_MOVETO:
				gp.moveTo((float)p.x[0], (float)p.y[0]);
				break;
				case GeomPoint.PATH_LINETO:
				gp.lineTo((float)p.x[0], (float)p.y[0]);
				break;
				case GeomPoint.PATH_QUADTO:
				gp.quadTo((float)p.x[0], (float)p.y[0],
						  (float)p.x[1], (float)p.y[1]);
				break;
				case GeomPoint.PATH_CURVETO:
				gp.curveTo((float)p.x[0], (float)p.y[0],
						  (float)p.x[1], (float)p.y[1],
						  (float)p.x[2], (float)p.y[2]);
				break;
			}
		}
		gp.closePath();

		return gp;
	}

	/**
	 * s[X̐Fݒ
	 * @param color
	 */
	public void setPiecesColor(Color color) {
		pieces_Color = color;
	}
	public void setPiecesColord(Color color) {
		pieces_Colord = color;
	}

	/**
	 * ̑Đݒ
	 * @param ratio g嗦
	 */
	public void setLineStroke(double ratio){
		if (AntiAliasing) {
			// 
			dashedLine_Stroke =
			new BasicStroke(((ratio < 1.0) ? ((float)(1 - (1 - ratio) / 4)) : 1.0f) + 0.5f,
							BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
							0, new float[]{4,4}, 0);
			solidLine_Stroke =
			new BasicStroke(((ratio < 1.0) ? ((float)(1 - (1 - ratio) / 4)) : 1.0f) + 0.5f,
							BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);
		} else {
			// X
			dashedLine_Stroke =
			new BasicStroke((ratio < 1.0) ? (float)ratio : 1.0f,
							BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL,
							0, new float[]{4,4}, 0);
			solidLine_Stroke =
			new BasicStroke((ratio < 1.0) ? (float)ratio : 1.0f,
							BasicStroke.CAP_BUTT, BasicStroke.JOIN_BEVEL);
		}
	}

	public void setDottedLineColor(Color color) {
		dottedLine_Color = color;
	}
	public void setDottedLineStroke(Stroke stroke) {
		dottedLine_Stroke = stroke;
	}
	public void setDashedLineStroke(Stroke stroke) {
		dashedLine_Stroke = stroke;
	}
	public void setSolidLineStroke(Stroke stroke) {
		solidLine_Stroke = stroke;
	}
	public Stroke getSolidLineStroke() {
		return solidLine_Stroke;
	}

}

