package tangram.svcs;

import tangram.*;

/**
 * javade tangram VGbgXgIOT[rX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 *   @version  0.2  03 Nov.2007
 */
public class Listios {
	private final boolean DEBUG = false;				// fobOp

	private SilhouetteList sillist;
	private XMLs xmls;
	private int lstidx = -1;

	/** 
	 * RXgN^
	 */
	public Listios() {
		sillist = new SilhouetteList();
		xmls = new XMLs();
		lstidx = -1;
	}

	/**
	 * RXgN^
	 * @param newname
	 */	
	public Listios(String newname) {
		sillist = new SilhouetteList(newname);
		xmls = new XMLs();
		lstidx = -1;
	}
	
	/** 
	 * VGbgXg̃NA
	 */
	public void clear() {
		sillist.clear();
		lstidx = -1;
	}

	/**
	 * XgVGbgo
	 *   @param n CfbNX
	 */
	public PieceInfo get(int n) {
		if (n < 0 || sillist.getCount() == 0) return null;
		return (PieceInfo)sillist.get(n);
	}

	/**
	 * Xgɒǉ
	 *   @param pi ǉPieceInfo
	 */
	public void add(PieceInfo pi) {
		if (lstidx < 0 || lstidx + 1 == sillist.getCount()) {
			sillist.add(pi);
			lstidx++;
		} else {
			sillist.add(lstidx, pi);
		}
	}

	/**
	 * XgɒP}Œǉ
	 *   @param pi ǉPieceInfo
	 */
	public void insert(PieceInfo pi) {
		if (lstidx < 0) {
			sillist.add(pi);
			lstidx++;
		} else {
			sillist.add(lstidx, pi);
		}
	}

	/**
	 * OtăXgɒǉ
	 *   @param s VGbg̖O
	 *   @param pi ǉPieceInfo
	 */
	public void add(String s, PieceInfo pi) {
		PieceInfoTool.setName(pi, s);
		add(pi);
	}

	/**
	 * Xg폜
	 */
	public boolean delete() {
		if (lstidx < 0 || sillist.getCount() == 0) return false;

		sillist.delete(lstidx);
		if (lstidx + 1 > sillist.getCount()) lstidx--;

		return true;
	}

	/**
	 * Xg̒Ԃ
	 *   @return Xg̒
	 */
	public int getCount() {
		return sillist.getCount();
	}

	/**
	 * ݂̃CfbNXԂ
	 *   @return CfbNX
	 */
	public int getIndex() {
		return lstidx;
	}

	/**
	 * CfbNX̎w
	 *   @param CfbNX
	 *   @return ωǂ
	 */
	public boolean moveIndexTo(int n) {
		if (getCount() == 0 || n < 0) return false;

		int oldidx = lstidx;
		lstidx = n;
		if (lstidx >= getCount()) lstidx = getCount() - 1;
		if (lstidx < 0) lstidx = 0;

		return (lstidx != oldidx);
	}

	/**
	 * CfbNX̑Έړ
	 *   @param CfbNX̕ω
	 *   @return ωǂ
	 */
	public boolean moveIndex(int n) {
		if (getCount() == 0) return false;

		int oldidx = lstidx;
		lstidx += n;
		if (lstidx >= getCount()) lstidx = getCount() - 1;
		if (lstidx < 0) lstidx = 0;

		return (lstidx != oldidx);
	}

	/**
	 * Xg̖Oݒ
	 *   @param s Xg̖Oiۂɂ̓t@Cj
	 */
	public void setName(String s) {
		sillist.setName(s.toString());
	}

	/**
	 * Xg̖O擾
	 *   @return Xg̖O
	 */
	public String getName() {
		return sillist.getName();
	}
	
	/**
	 * XML^OƃVGbgXgǂݍ
	 *   @param tan ^O
	 *   @param s \[X
	 *   @param isOnlyPieceset
	 *   @param isResource \[Xǂ
	 *   @return ǂݍ݂ɐǂ
	 */
	public boolean loadXML(Tangram tan, String s, boolean isOnlyPieceset, boolean isResource) {
		if (! xmls.perseXML(tan, sillist, s, isOnlyPieceset, isResource)) {
			// ǂݍݎs
			if (DEBUG) System.out.println("Failed to loadXML");

			tan.setTraditionalTangram();	// ^Oŏ
			sillist.clear();				// XgNA

			return false;
		}

		if (DEBUG) System.out.println("jvdtListios GeomBank Result");
		if (DEBUG) System.out.println(tan.geombank.toString());
		if (DEBUG) System.out.println("jvdtListios Initial PieceInfo Result");
		if (DEBUG) System.out.println(PieceInfoTool.toString(tan.pinit));

		if (getCount() > 0) lstidx = 0;
		return true;
	}
	
	/**
	 * XMLɃ^OƃVGbgXg
	 *   @param tan ^O
	 *   @param s \[X
	 *   @param isResource \[Xǂ
	 *   @return ݂ɐǂ
	 */
	public boolean saveXML(Tangram tan, String s, boolean isResource) {
		if (isResource) return false;

		if (! xmls.putXML(tan, sillist, s, false)) {
			// ݎs
			if (DEBUG) System.out.println("Failed to saveXML");

			return false;
		}
		return true;
	}
}
