package tangram.svcs;

import java.util.*;
import java.awt.event.MouseEvent;

import tangram.*;

/**
 * javade tangram s[XIy[V֘AT[rX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.1  14 Apr.2007
 */
public class Opes {
	private boolean DEBUG = false;				// fobOp

	private Tangram tan;
	private Imgs imgs;

	public boolean sleepchanged = false;
	public boolean activechanged = false;
	public boolean ratiochanged = false;

	private int state_selected;
	public static final int STATE_SEL_NONE = 0;
	public static final int STATE_SEL_SINGLE = 1;	
	public static final int STATE_SEL_MULTI = 2;	

	private int state_operation;
	public static final int STATE_OPE_NONE = 0x00;
	public static final int STATE_OPE_MOVE = 0x01;
	public static final int STATE_OPE_WAIT = 0x02;
	public static final int STATE_OPE_TRAIL = 0x03;
	public static final int STATE_OPE_ROTATE = 0x04;
	public static final int STATE_OPE_WAITRECT = 0x10;
	public static final int STATE_OPE_SLCTRECT = 0x11;
	public static final int STATE_OPE_ZOOMING = 0x20;
	private boolean doublepressed = false;

	// _W
	private boolean vertexAttach = false;

	// K]
	private boolean adaptiveRotation = false;

	// ϐ
	double hx, hy;
	double vx, vy;
	double ratiodtheta;
	double tmprad;

	// 萔
	final double dthetac = 0.025;
	final double ratiopowlv = 0.2;
	final double ratiominlim = 0.01;
	final double ratiomaxlim = 1.0;

	// ]ϐ
	int	dcx[] = new int [1024];
	int	dcy[] = new int [1024];
	int dcxp;
	int	dcxn, dcxs, dcys, dcxabs;
	int	dcxsmin = 32;
	int	dcxabsmax = 200;
	int	flipsens = 8;
	int	fssens = 5;

	// }EXW
	private int mx = 0;
	private int my = 0;
	private int dx = 0;
	private int dy = 0;
	private int oldmx = 0;
	private int oldmy = 0;

	// s[XI`W
	public int rxs = 0;
	public int rys = 0;
	public int rxe = 0;
	public int rye = 0;

	/**
	 * RXgN^
	 *   @param tan ^ONX
	 *   @param imgs ^O`T[rXNX
	 */	
	public Opes(Tangram tan, Imgs imgs) {
		this.tan = tan;		// GeomBank, PieceInfo, PieceInfoExt
		this.imgs = imgs;	// ratio, slidex, slidey
		resetFlags();
	}

	/**
	 * _W̐ݒ
	 * @param flag
	 */
	public void setVertexAttach(boolean flag) {
		vertexAttach = flag;
	}

	/**
	 * K]̐ݒ
	 * @param flag
	 */
	public void setAdaptiveRotation(boolean flag) {
		adaptiveRotation = flag;
	}

	/**
	 * changedtÕZbg
	 */
	private void resetFlags() {
		sleepchanged = false;
		activechanged = false;
		ratiochanged = false;
	}

	/**
	 * X[vs[XɕύXԂ
	 *   @return X[vs[XɕύXtrue
	 */
	public boolean isChangedSleep() {
		return sleepchanged;
	}

	/**
	 * ANeBus[XɕύXԂ
	 *   @return ANeBus[XɕύXtrue
	 */
	public boolean isChangedActive() {
		return activechanged;
	}

	/**
	 * g嗦ɕύXǂԂ
	 * @return
	 */
	public boolean isChangedRatio() {
		return ratiochanged;
	}

	/**
	 * ԂԂ
	 *   @return 
	 */
	public int getStateOpe() {
		return state_operation;
	}

	/**
	 * IԂԂ
	 *   @return 
	 */
	public int getStateSel() {
		return state_selected;
	}

	/**
	 * }EXJ[\̗XV
	 *   @param e }EXCxg
	 */
	public void updateMouseHistory(MouseEvent e) {
		if (state_operation == STATE_OPE_WAIT) {
			// Jҋ@̏ꍇ
			if (Math.abs(mx - e.getX()) + Math.abs(my - e.getY()) <= 2) {
				// ړʂȂꍇAXVȂ				
				dx = dy = 0;
				return;
			}
		}

		// ʏ̍XV
		oldmx = mx;
		oldmy = my;

		mx = e.getX();
		my = e.getY();
		
		dx = mx - oldmx;
		dy = my - oldmy;
	}
	
	/**
	 * hbO
	 *   @param e }EXCxg
	 */
	public void mouseDragged(MouseEvent e) {
		updateMouseHistory(e);
		if ((dx == 0) && (dy == 0)) return;

		resetFlags();

		// `I҂̏ꍇ
		if (state_operation == STATE_OPE_WAITRECT) {
			// }EXx`IɈڍs
			if ((rxs - mx) * (rxs - mx) + (rys - my) * (rys - my) > 40) {
				if (DEBUG) System.out.println("STATE: WAIT RECT -> SELECT RECT");

				state_operation = STATE_OPE_SLCTRECT;

				activechanged = true;
			}
		}

		// `Ȉꍇ
		if (state_operation == STATE_OPE_SLCTRECT) {
			rxe = mx;
			rye = my;

			int xs = Math.min(rxs, rxe);
			int xe = Math.max(rxs, rxe);
			int ys = Math.min(rys, rye);
			int ye = Math.max(rys, rye);

			state_selected = STATE_SEL_NONE;

			for (int i = 0; i < tan.pinfo.num; i++) {
				int x = (int)(imgs.slide_x + tan.pinfo.x[i] * imgs.ratio);
				int y = (int)(imgs.slide_y + tan.pinfo.y[i] * imgs.ratio);

				if (x >= xs && x <= xe && y >= ys && y <= ye) {
					// s[X̒S`ȂI
					// s[X̏ԂςȂobNobt@`
					if (tan.piext.mode[i] == PieceInfoExt.MODE_SLEEP)
						sleepchanged = true;
					tan.activeOne(i);

					// Is[Xv
					if (state_selected == STATE_SEL_NONE) {
						state_selected = STATE_SEL_SINGLE;
					} else if (state_selected == STATE_SEL_SINGLE) {
						state_selected = STATE_SEL_MULTI;
					}

				} else {
					// s[X̒S`OȂJ
					// s[X̏ԂςȂobNobt@`
					if (tan.piext.mode[i] == PieceInfoExt.MODE_ACTIVE)
						sleepchanged = true;
					tan.sleepOne(i);
				}
			}

			activechanged = true;
		}

		// s[XIĂꍇ
		if (state_selected != STATE_SEL_NONE) {
			// s[XJҋ@ȂAĂшԂ֖߂
			if (state_operation == STATE_OPE_WAIT) {
				if (DEBUG) System.out.println("STATE: WAIT -> TRAIL");

				state_operation = STATE_OPE_TRAIL;
			}

			// ԂȂ
			if (state_operation == STATE_OPE_TRAIL) {
				trailing(true);
			
				activechanged = true;

				return;
			}

			// ]ԂȂ]
			if (state_operation == STATE_OPE_ROTATE) {
				final double rLimit = 0.01;
				final double rConst = 90.0;
				double r = (tan.getActivesOriginY() - dyty(my))
							/ imgs.ratio;

				// K]łȂΉ]ʂ͌Œ
				if (!adaptiveRotation) r = (r < 0) ? -rConst : rConst;

				// [Z΍
				if (Math.abs(r) < rLimit) r = (r < 0) ? -rLimit: rLimit;

				r = (double)dx / r * (Math.PI/2);

				r = Math.max(r, -Math.PI/16);
				r = Math.min(r,  Math.PI/16);
				tan.rotate(r);

				activechanged = true;

				return;
			}

			// Y[~OȂ{XV
			if (state_operation == STATE_OPE_ZOOMING) {
				double oldratio = imgs.ratio;
				double oldoxave = tan.getActivesOriginX();
				double oldoyave = tan.getActivesOriginY();

				imgs.setRatio(imgs.ratio - (double)dy / (double)imgs.slide_y);

				// S̃Y𒀎␳
				double dratio = (imgs.ratio - oldratio) / imgs.ratio;
				tan.move(-oldoxave * dratio, -oldoyave * dratio);
				
				activechanged = true;

				return;
			}
		}
	}
	
	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mousePressed(MouseEvent e) {
		if (DEBUG) System.out.println("mousePressed");
		updateMouseHistory(e);
		resetFlags();

		// {^ꂽ
		if (e.getButton() == MouseEvent.BUTTON1) {

			// ԂԂȂs[XE
			if (state_selected == STATE_SEL_NONE &&
				state_operation == STATE_OPE_NONE) {
	
				int n;
				if ((n = imgs.whichPieceIsHere(tan, e.getX(), e.getY())) >= 0) {
					// s[XI
					if (DEBUG) System.out.println("STATE: NONE -> TRAIL");
					if (DEBUG) System.out.println("Selected Piece " + n);
	
					state_selected = STATE_SEL_SINGLE;
					state_operation = STATE_OPE_TRAIL;
	
					changeOderTop(tan, n);
					tan.activeOne(n);

					resetTrailing();
	
					sleepchanged = true;
					activechanged = true;

					return;

				} else {
					// nł΋`I҂Ɉڍs
					if (DEBUG) System.out.println("STATE: NONE -> WAIT RECT");
	
					state_selected = STATE_SEL_NONE;
					state_operation = STATE_OPE_WAITRECT;

					// I`̎n_Zbg
					rxs = mx;
					rys = my;

					return;
				}
			}		
		}

		// E{^ꂽ
		if (e.getButton() == MouseEvent.BUTTON1 ||
			e.getButton() == MouseEvent.BUTTON3) {

			// E҂E]Ԃ炳ɉE{^ꂽ
			if (state_selected != STATE_SEL_NONE &&
				(((state_operation == STATE_OPE_WAIT ||
				   state_operation == STATE_OPE_TRAIL) &&
				  e.getButton() == MouseEvent.BUTTON3) ||
				 (state_operation == STATE_OPE_ROTATE &&
				  e.getButton() == MouseEvent.BUTTON1))) {

				// pxۂ
				if (DEBUG) System.out.println("Adjust Angle");

				double drad = 0;
				double oxave = tan.getActivesOriginX();
				double oyave = tan.getActivesOriginY();

				drad = tan.adjustDegree15();
				tmprad  = PieceInfoTool.redrad2pi(tmprad + drad);

				double sin = Math.sin(tmprad);
				double cos = Math.cos(tmprad);

				// E҂Ȃ
				// x_̈ʒuv邽߂̕sړ
				if (state_operation == STATE_OPE_WAIT ||
					state_operation == STATE_OPE_TRAIL) {
					tan.move(
						dxtx(mx) +
						hx * cos - hy * sin -
						oxave
						,
						dyty(my) +
						hx * sin + hy * cos -
						oyave
					);
				}
					
				// 삪̂ő҂͋IɈԂ֖߂
				if (state_operation == STATE_OPE_WAIT) {
					state_operation = STATE_OPE_TRAIL;
				}

				activechanged = true;

				doublepressed = true;

				return;
			}

			// s[XړԂŉE{^ꂽ
			if (state_selected != STATE_SEL_NONE &&
				state_operation == STATE_OPE_MOVE) {

				// {^Ȃs[XJҋ@ֈڍs
				// iẼ{^Ȃ獶{^Dj
				if (e.getButton() == MouseEvent.BUTTON1) {
					if (DEBUG) System.out.println("STATE: MOVE -> WAIT");
	
					state_operation = STATE_OPE_WAIT;

					resetTrailing();

					return;
				}

				// E{^Ȃ]ֈڍs
				if (e.getButton() == MouseEvent.BUTTON3) {
					if (DEBUG) System.out.println("STATE: MOVE -> ROTATE");
	
					state_operation = STATE_OPE_ROTATE;
	
					return;
				}
			}
		}
	
		// E{^ꂽ
		if (e.getButton() == MouseEvent.BUTTON3) {

			// 삪Ȃ΃X[~OJn
			if (state_selected == STATE_SEL_NONE &&
				state_operation == STATE_OPE_NONE) {
				if (DEBUG) System.out.println("STATE: NONE -> ZOOMING");
				
				state_selected = STATE_SEL_MULTI;
				state_operation = STATE_OPE_ZOOMING;

				tan.activeAll();

				sleepchanged = true;
				activechanged = true;

				return;
			}
		}
	}

	/**
	 * {^ꂽ
	 *   @param e }EXCxg
	 */
	public void mouseReleased(MouseEvent e) {
		if (DEBUG) System.out.println("mouseReleased");
		updateMouseHistory(e);
		resetFlags();

		// {^ꂽ
		if (e.getButton() == MouseEvent.BUTTON1) {

			// `I҂inōNbNjȂSs[XI
			if (state_operation == STATE_OPE_WAITRECT) {
				if (DEBUG) System.out.println("STATE: WAIT RECT -> MOVE");

				state_selected = STATE_SEL_MULTI;
				state_operation = STATE_OPE_MOVE;
	
				tan.activeAll();

				resetTrailing();
				resetFlipping();
	
				sleepchanged = true;
				activechanged = true;

				return;
			}

			// `Ȉꍇ
			if (state_operation == STATE_OPE_SLCTRECT) {

				// `󂾂ԂԂɖ߂
				if (state_selected == STATE_SEL_NONE) {
					if (DEBUG) System.out.println("STATE: SELECT RECT -> NONE");

					state_operation = STATE_OPE_NONE;

					activechanged = true;

					return;

				// Es[X΂I
				} else {
					if (DEBUG) System.out.println("STATE: SELECT RECT -> MOVE");

					state_operation = STATE_OPE_MOVE;

					resetTrailing();
					resetFlipping();

					activechanged = true;

					return;
				}
			}
		}

		// E{^ꂽ
		if (e.getButton() == MouseEvent.BUTTON1 ||
			e.getButton() == MouseEvent.BUTTON3) {

			// {^ĂԂꍇ͓ɉȂ
			if (doublepressed) {
				doublepressed = false;

				return;

			// {^ǂꂽꍇ
			} else {
				// s[XIĂꍇ
				if (state_selected != STATE_SEL_NONE) {
					// E]ԂȂړԂֈڍs
					if (state_operation == STATE_OPE_TRAIL ||
					    state_operation == STATE_OPE_ROTATE) {
						if (DEBUG) System.out.println("STATE: TRAIL or ROTATE -> MOVE");
		
						// ɉ]ԂłΈZbg
						if (state_operation == STATE_OPE_ROTATE) {
							resetTrailing();
						}

						state_operation = STATE_OPE_MOVE;
		
						resetFlipping();

						return;

					// s[XJҋ@Ȃs[XJ
					} else if (state_operation == STATE_OPE_WAIT) {
						if (DEBUG) System.out.println("Release Piece(s)");
						if (DEBUG) System.out.println("STATE: WAIT -> NONE");
		
						if (DEBUG) System.out.println("Adjust Location");
						adjustlocation();

						state_selected = STATE_SEL_NONE;
						state_operation = STATE_OPE_NONE;
		
						tan.sleepAll();
						sleepchanged = true;
						activechanged = true;

						return;
					}
				}
			}
		}

		// E{^ꂽ
		if (e.getButton() == MouseEvent.BUTTON3) {

			// Y[~OȂI
			if (state_operation == STATE_OPE_ZOOMING) {
				if (DEBUG) System.out.println("STATE: ZOOMING -> NONE");
	
				state_selected = STATE_SEL_NONE;
				state_operation = STATE_OPE_NONE;

				tan.sleepAll();
				sleepchanged = true;
				activechanged = true;
				ratiochanged = true;

				return;
			}
		}
	}

	/**
	 * }EXړ
	 *   @param e }EXCxg
	 */
	public void mouseMoved(MouseEvent e) {
		updateMouseHistory(e);
		resetFlags();

		// s[XIĂꍇ
		if (state_selected != STATE_SEL_NONE) {
			// s[XړԂȂړ
			if (state_operation == STATE_OPE_MOVE) {

				trailing(false);

				activechanged = true;

				return;
			}
		}
	}

	/**
	 * ԍñs[X擪ɂĂ
	 *   @param tan ^ONX
	 *   @param n 擪ɂĂs[X̔ԍ
	 */
	private void changeOderTop(Tangram tan, int n) {
		int no = tan.piext.order[n];

		for (int i = 0; i < tan.pinfo.num; i++) {
			if (tan.piext.order[i] < no) tan.piext.order[i]++;
		}
		tan.piext.order[n] = 0;
	}

	/**
	 * ʍWn^ONXWn֕ϊ
	 *   @param mx ʏxW
	 */
	private double dxtx(int mx) { return ((double)mx - imgs.slide_x) / imgs.ratio; }

	/**
	 * ʍWn^ONXWn֕ϊ
	 *   @param my ʏyW
	 */
	private double dyty(int my) { return ((double)my - imgs.slide_y) / imgs.ratio; }

	/**
	 * 邽߂̕ϐ
	 */
	private void resetTrailing() {
		if (DEBUG) System.out.println("reset trailing parameters");

		double oxave = tan.getActivesOriginX();
		double oyave = tan.getActivesOriginY();
		tmprad = tan.getActivesRadian();

		double rx = oxave - dxtx(mx);
		double ry = oyave - dyty(my);

		hx = rx * Math.cos(-tmprad) - ry * Math.sin(-tmprad);
		hy = rx * Math.sin(-tmprad) + ry * Math.cos(-tmprad);
		
		vx = 0;
		vy = 0;

		// Ps[X̓͐}`oN猟
		if (state_selected == STATE_SEL_SINGLE) {
			ratiodtheta = 0;
			for (int i = 0; i < tan.pinfo.num; i++) {
				if (tan.piext.mode[i] == PieceInfoExt.MODE_ACTIVE)
				ratiodtheta = Math.sqrt(
							  Math.pow(rx, 2)
							+ Math.pow(ry, 2)
						) / (tan.geombank.getGeomElem(tan.pinfo.id[i])).charlen;
			}

		// s[X̓̓s[X̍WZo
		} else {
			ratiodtheta = 0;
			double maxdistance = 0;
			for (int i = 0; i < tan.pinfo.num; i++) {
				if (tan.piext.mode[i] == PieceInfoExt.MODE_ACTIVE) {
					double distance = Math.sqrt(
								  Math.pow(tan.pinfo.x[i] - oxave, 2)
								+ Math.pow(tan.pinfo.y[i] - oyave, 2));
					if (distance > maxdistance) maxdistance = distance;
				}
			}
			ratiodtheta = Math.sqrt(
						  Math.pow(rx, 2)
						+ Math.pow(ry, 2)
					) / maxdistance;
		}

		if (ratiodtheta < ratiominlim) ratiodtheta = 0;
		else ratiodtheta = (ratiodtheta - ratiominlim) / (1.0 - ratiominlim);
	
		ratiodtheta = Math.pow(ratiodtheta, ratiopowlv);

		// ΓIɎx_ỎłꍇɁA]eȂ̂C}
		if (ratiodtheta > ratiomaxlim) {
			if (DEBUG) System.out.println("before ratiodtheta = " + ratiodtheta);
			ratiodtheta = ratiomaxlim * Math.pow(ratiomaxlim / ratiodtheta, 4);
			if (DEBUG) System.out.println("after ratiodtheta = " + ratiodtheta);
		}
	}

	/**
	 * 
	 *   @param isTrailing falseȂ狭sړ
	 */
	private void trailing(boolean isTrailing) {
		double oxave = tan.getActivesOriginX();
		double oyave = tan.getActivesOriginY();

		double pgx, pgy;
		double radpg, radv;
		double drad;
		double dtheta;

		pgx = dxtx(oldmx) - oxave;
		pgy = dyty(oldmy) - oyave;

		vx = (vx + dxtx(mx) - dxtx(oldmx)) / 2;
		vy = (vy + dyty(my) - dyty(oldmy)) / 2;

		radpg = Math.atan2(pgx, pgy);
		radv  = Math.atan2( vx,  vy);

		drad = radpg - radv;
		if (Math.abs(drad) >  Math.PI) drad = Math.PI + radv - radpg;

		dtheta = Math.sqrt(vx * vx + vy * vy) * Math.sin(drad);
		dtheta *= ratiodtheta;

		if (isTrailing) {
			double finaldtheta = dtheta * dthetac;
			tan.rotate(finaldtheta);
			tmprad += finaldtheta;
			tmprad  = PieceInfoTool.redrad2pi(tmprad);
		} 

		double sin = Math.sin(tmprad);
		double cos = Math.cos(tmprad);

		tan.move(
			dxtx(mx) +
			hx * cos - hy * sin -
			oxave
			,
			dyty(my) +
			hx * sin + hy * cos -
			oyave
		);

		if (! isTrailing) flipping();
	}

	/**
	 * ]̂߂̕ϐ
	 */
	private void resetFlipping() {
		if (DEBUG) System.out.println("reset flipping parameters");
		dcxp = 0;
		dcxs = 0;
		dcys = 0;
		dcxabs = 0;
		dcxn = flipsens * fssens;
		for(int i = 0; i < 1024; i++) dcx[i] = 0;
	}

	/**
	 * ]`FbNƔ]
	 */
	private void flipping() {
		dcx[dcxp] = dx;
		dcy[dcxp] = dy;
		dcxs += dx;
		dcys += dy;
		dcxabs += Math.abs(dx);
		dcxp = (dcxp+1) & 1023;
		dcxs -= dcx[(dcxp+1024-dcxn) & 1023];
		dcys -= dcy[(dcxp+1024-dcxn) & 1023];
		dcxabs -= Math.abs(dcx[(dcxp+1024-dcxn) & 1023]);
		if((Math.abs(dcxs)<dcxsmin) &&
		   (dcxabs>dcxabsmax) &&
		   (Math.abs(dcys)<dcxsmin)
		){
			if (DEBUG) System.out.println("flip");
			tan.flipH();

			// Ps[X̔]́A}EXJ[\̍WSA
			// s[X̔]́AVGbg̎Sōs
			if (state_selected == STATE_SEL_SINGLE) {
				hx = -hx;
				tmprad = 2 * Math.PI - tmprad;
				tmprad = PieceInfoTool.redrad2pi(tmprad);
			}

			resetFlipping();
		}
	}

	/**
	 * s[Xʒu̔
	 */
	private void adjustlocation() {
		if (!vertexAttach) return;
		
		PieceInfo pi = tan.pinfo;

		GeomElem ge, ge_;
		double r, rmin = 16;
		double dx, dxmin = 0; 
		double dy, dymin = 0; 
			
		for (int i = 0; i < pi.num; i++) {
			if (tan.piext.mode[i] == PieceInfoExt.MODE_ACTIVE) {

				ge = GeomCalc.getPointList(tan.geombank, pi, i,
					1.0, 0.0, 0.0);
				for (Iterator<GeomPoint> gpi = ge.geompoints.iterator(); gpi.hasNext(); ) {
					GeomPoint p = (GeomPoint)gpi.next();

					for (int j = 0; j < pi.num; j++) {
						if (tan.piext.mode[j] == PieceInfoExt.MODE_SLEEP) {

							ge_ = GeomCalc.getPointList(tan.geombank, pi, j,
								 1.0, 0.0, 0.0);

							for (Iterator<GeomPoint> gpi_ = ge_.geompoints.iterator(); gpi_.hasNext(); ) {
								GeomPoint p_ = (GeomPoint)gpi_.next();

								dx = p_.x[p_.num - 1] - p.x[p.num - 1];
								dy = p_.y[p_.num - 1] - p.y[p.num - 1];

								r = Math.pow(dx, 2) + Math.pow(dy, 2);
								if (r < rmin) {
									dxmin = dx;
									dymin = dy;
									rmin = r;
							}	}
					}	}
				}
		}	}
		tan.move(dxmin, dymin);
	}
}
