package tangram.svcs;

import tangram.*;

/**
 * javade tangram AhD[}l[W[
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 *   @version  0.1  14 Apr.2007
 */
public class Undom {
	private boolean DEBUG = false;				// fobOp

	int maxundonum;
	int top, bottom;
	int index;
	PieceInfo pib[];
	String puzzle;

	/**
	 * RXgN^
	 * 	@param maxundonum őAhD[Gg[
	 */
	public Undom(int maxundonum) {
		this.maxundonum = maxundonum;
		pib = new PieceInfo[maxundonum];
	}

	/**
	 * RXgN^
	 * @param tan
	 * @param maxundonum
	 */	
	public Undom(Tangram tan, int maxundonum) {
		this.maxundonum = maxundonum;
		pib = new PieceInfo[maxundonum];

		reset(tan);
		entry(tan);
	}
	
	/**
	 * AhD[obt@̃Zbg
	 * 	@param tan s[XƃpY𓾂
	 * 
	 * 	kӁlZbgAxGg[sKv
	 */
	public void reset(Tangram tan) {
		if (DEBUG) System.out.println("jteUndom Reset");

		// obt@̏
		int piecenum = tan.pinfo.num;
		for (int i = 0; i < maxundonum; i++) {
			pib[i] = new PieceInfo(piecenum);
		}

		// pYT
		puzzle = tan.puzzle;

		top = 0;
		index = -1;
		bottom = -1;
	}

	/**
	 * AhD[obt@̓KXZbg
	 * 	@param tan pY𓾂
	 */
	public boolean adpreset(Tangram tan) {
		// TĂpYƈႤꍇɃZbg
		if (!puzzle.equals(tan.puzzle)) {
			reset(tan);
			return true;
		}
		return false;
	}

	/**
	 * AhD[obt@ɃGg[
	 * 	@param tan
	 */
	public void entry(Tangram tan) {
		entryCommon();
		tan.exportPinfo(pib[index]);
	}

	public void entry(PieceInfo pi) {
		entryCommon();
		PieceInfoTool.copy(pib[index], pi);
	}

	private void entryCommon() {
		if (DEBUG) System.out.println("jteUndom Entry");

		if (index >= 0) {
			if (((bottom - top + maxundonum) % maxundonum) == maxundonum - 1)
				top = (top + 1) % maxundonum;
		}
		index = (index + 1) % maxundonum;
		bottom = index;
	}

	/**
	 * AhD[
	 * 	@return AhD[łȂfalse
	 */
	public boolean undo(Tangram tan) {
		if (!isUndoable()) return false;
		if (DEBUG) System.out.println("jteUndom Undo index=" + index);

		index = (index - 1 + maxundonum) % maxundonum;
		tan.importPinfo(pib[index]);
		return true;
	}

	/**
	 * zAhD[
	 * 	@return AhD[łȂfalse
	 */
	public boolean virtualUndo() {
		if (!isUndoable()) return false;
		if (DEBUG) System.out.println("jteUndom Virtual Undo index=" + index);

		index = (index - 1 + maxundonum) % maxundonum;
		return true;
	}

	/**
	 * hD[
	 * 	@return hD[łȂfalse
	 */
	public boolean redo(Tangram tan) {
		if (!isRedoable()) return false;
		if (DEBUG) System.out.println("jteUndom Redo index=" + index);

		index = (index + 1) % maxundonum;
		tan.importPinfo(pib[index]);
		return true;
	}

	/**
	 * AhD[ł邩ǂԂ
	 */
	public boolean isUndoable() {
		if (index == top) {
			return false;
		} else {
			return true;
		}
	}

	/**
	 * hD[ł邩ǂԂ
	 */
	public boolean isRedoable() {
		if (index == bottom) {
			return false;
		} else {
			return true;
		}
	}

}
