package tangram.svcs;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.Date;
import java.util.List;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import tangram.GeomBank;
import tangram.GeomElem;
import tangram.GeomPoint;
import tangram.LocalName;
import tangram.PieceInfo;
import tangram.PieceInfoTool;
import tangram.Tangram;

/**
 * XMLǂݏNX
 *
 *   @author   Hiroshi Okuda / Kys
 *   @version  0.0  11 Mar.2006
 *   @version  0.1  14 Apr.2007
 */
public class XMLs {
	private boolean DEBUG = false;			// fobOp

	private final String formatVersion = "0.0";
	private final String encodingName = "UTF-8";

	public XMLs() {
	}

	/**
	 * XML\[XpYs[XƃVGbgXgǂݍ
	 *   @param tan ^ONXB}`oNXV
	 *   @param sillist VGbgXgNX
	 *   @param s t@C
	 *   @param isOnlyPieceset
	 *   @param isResource \[Xǂ
	 *   @return ǂݍ݂ǂ
	 */
	public boolean perseXML(
		Tangram tan,
		SilhouetteList sillist,
		String s,
		boolean isOnlyPieceset,
		boolean isResource)
	{
		String pcsname;
		int pcsnum;

		GeomPoint gp;
		GeomElem  ge;
		PieceInfo pi;

		tan.geombank.clear();
		sillist.clear();
		sillist.setName(s);		// t@CXgɃRs[

		try {
			// hLgr_[t@Ng𐶐
			DocumentBuilderFactory dbfactory = DocumentBuilderFactory.newInstance();

			// hLgr_[𐶐
			DocumentBuilder builder = dbfactory.newDocumentBuilder();

			// p[XsDocumentIuWFNg擾
			Document doc;
			if (isResource) {
				// \[Xǂݍ
				doc = builder.parse(getClass().getClassLoader().getResourceAsStream(s));
			} else {
				// t@CVXeǂݍ
				doc = builder.parse(new File(s));
			}
			// [gvf擾
			Element root = doc.getDocumentElement();
			if (root == null) {
				if (DEBUG) System.out.println("Illeagal input.");
				return false;
			}
			if (root.getTagName().compareTo("jte") != 0) {
				if (DEBUG) System.out.println("Illeagal input.");
				return false;
			} 

			// o[W`FbN
			String ver = root.getAttribute("format");
			if (!ver.equals(formatVersion)) {
				if (DEBUG) System.out.println("Illeagal input.");
				return false;
			}
			if (DEBUG) System.out.println("versionF" + ver);

			// s[XZbg擾
			if (DEBUG) System.out.println("***** s[XZbg *****");
			Element pcsroot = (Element)(root.getElementsByTagName("pieceset")).item(0);

			// s[XZbg擾
			pcsname = pcsroot.getAttribute("name");
			if (DEBUG) System.out.println("nameF" + pcsname);
			tan.setPuzzleName(pcsname);

			// [J̃Xg̎擾
			tan.clearLocalPuzzleNames();
			NodeList localnamelist = root.getElementsByTagName("localname");
			for (int i = 0; i < localnamelist.getLength(); i++) {
				Element localnameelem = (Element)localnamelist.item(i);
				String lang = localnameelem.getAttribute("iso3language");
				String name = localnameelem.getAttribute("name");
				tan.addLocalPuzzleName(lang, name);
				if (DEBUG) System.out.println(lang + "F" + name);
			}

			// s[X擾
			pcsnum = (int)Double.parseDouble(pcsroot.getAttribute("num"));
			if (DEBUG) System.out.println("num:" + pcsnum );
			pi = new PieceInfo(pcsnum);

			// s[X̊􉽏擾
			if (DEBUG) System.out.println("***** s[X̊􉽏 *****");

			NodeList geomlist = pcsroot.getElementsByTagName("geom");
			for (int i = 0; i < geomlist.getLength(); i++) {

				Element geomelem = (Element)geomlist.item(i);
				// id擾
				String geomid = geomelem.getAttribute("id");
				ge = new GeomElem();
				ge.setId(geomid);

				if (DEBUG) System.out.println("--------<" + geomid );

				// id̃s[X̊􉽏擾
				NodeList plist = geomelem.getElementsByTagName("p");
				for (int j = 0; j < plist.getLength(); j++) {
					Element pelem = (Element)plist.item(j);
					// 
					String pkind = pelem.getAttribute("kind");
					// W
					String pnode = pelem.getFirstChild().getNodeValue();

					double p[] = split(pnode);

					if (pkind.compareTo("origin") == 0) {
						ge.local_ox = p[0];
						ge.local_oy = p[1];
					} else if (pkind.compareTo(GeomBank.MOVETO) == 0) {
						gp = new GeomPoint(GeomPoint.PATH_MOVETO,
											p[0], p[1]);
						gp.num = 1;
						ge.add(gp);
					} else if (pkind.compareTo(GeomBank.LINETO) == 0) {
						gp = new GeomPoint(GeomPoint.PATH_LINETO,
											p[0], p[1]);
						gp.num = 1;
						ge.add(gp);
					} else if (pkind.compareTo(GeomBank.QUADTO) == 0) {
						gp = new GeomPoint(GeomPoint.PATH_QUADTO,
											p[0], p[1], p[2], p[3]);
						gp.num = 2;
						ge.add(gp);
					} else if (pkind.compareTo(GeomBank.CURVETO) == 0) {
						gp = new GeomPoint(GeomPoint.PATH_CURVETO,
											p[0], p[1], p[2], p[3], p[4], p[5]);
						gp.num = 3;
						ge.add(gp);
					}

					if (DEBUG) System.out.println("kindF" + pkind + " node:" + pnode );
				}
				tan.geombank.add(ge);

			}

			// fBtHg̔zu擾
			if (DEBUG) System.out.println("***** fBtHg̃s[Xzu *****");

			Element silelem = (Element)(pcsroot.getElementsByTagName("silhouette")).item(0);
			pi = resolvesilhouette(pcsnum, silelem);
			tan.importPinit(pi);
			tan.importPinfo(pi);
			tan.breakup();

			if (isOnlyPieceset) return true;

			// VGbgXg擾
			if (DEBUG) System.out.println("***** VGbgXg *****");

			Element silroot = (Element)(root.getElementsByTagName("silhouettes")).item(0);
			if (silroot == null) return true;

			NodeList silnodelist = silroot.getElementsByTagName("silhouette");
			for (int i = 0; i < silnodelist.getLength(); i++) {
				silelem = (Element)silnodelist.item(i);

				pi = resolvesilhouette(pcsnum, silelem);
				sillist.add(pi);
			}
		} catch (Exception e) {
			e.printStackTrace();
			return false;
		}

		return true;
	}

	/**
	 * XMLVGbg֓WJ
	 *   @param pcsnum s[X
	 *   @param silelem XML̃VGbgvf
	 *   @return VGbg(PieceInfo)
	 */
	private PieceInfo resolvesilhouette(int pcsnum, Element silelem) {
		PieceInfo pi = new PieceInfo(pcsnum);
		String name = silelem.getAttribute("name");
		String s = silelem.getFirstChild().getNodeValue();
		String[] ps = s.split("\\s");			// Xy[Xŋ؂
		int inum = 0;
		for (int i = 0; i < ps.length; i++) {	// 󔒗vf
			if (ps[i].length() > 0) ps[inum++] = ps[i];
		}

		// PieceInfo֊i[
		pi.num = pcsnum;
		pi.name = name;
		for (int i = 0; i < pcsnum; i++) {
			pi.id[i]   = ps[i * 5];
			pi.x[i]    = Double.parseDouble(ps[i * 5 + 1]);
			pi.y[i]    = Double.parseDouble(ps[i * 5 + 2]);
			pi.rad[i]  = Double.parseDouble(ps[i * 5 + 3]);
			pi.rad[i]  = PieceInfoTool.redrad2pi(pi.rad[i]);
			pi.flip[i] = Double.parseDouble(ps[i * 5 + 4]);
		}

		if (DEBUG) {
			System.out.println("nameF" + name );
			for (int i = 0; i < pcsnum; i++) {
				s = "";
				for (int j = 0; j < 5; j++) {
					s = s + " <" + ps[i * 5 + j] + ">";
				}
				System.out.println("\t" + s );
			}
		}
		return pi;
	}

	/**
	 * Xy[X؂肩doublez𐶐
	 *   @param s Ƃ̕
	 *   @return doublez
	 */
	private double[] split(String s) {
		String[] ps = s.split("\\s");			// Xy[Xŋ؂
		int inum = 0;
		for (int i = 0; i < ps.length; i++) {	// 󔒗vf
			if (ps[i].length() > 0) ps[inum++] = ps[i];
		}

		double[] p = new double[inum];			// doublezɕϊ
		for (int i = 0; i < inum; i++) {
			p[i] = Double.parseDouble(ps[i]);
		}

		return p;
	}

	/**
	 * XML^O
	 */
	private final String XML_HeaderO = "<?xml version=\"1.0\" ";
	private final String XML_EncodingO = "encoding=\"";
	private final String XML_EncodingC = "\" ";
	private final String XML_HeaderC = "?>\n";
	private final String XML_jteO = "<jte ";
	private final String XML_jteVersionO = "format=\"";
	private final String XML_jteVersionC = "\">\n";
	private final String XML_jteLastupdateO = "<lastupdate date=\"";
	private final String XML_jteLastupdateC = "\"/>\n\n";
	private final String XML_jtePiecesetOname = "\t<!-- Pieceset -->\n\t<pieceset name=\"";
	private final String XML_jtePiecesetOnum = "\" num=\"";
	private final String XML_jtePiecesetCnum = "\">\n";
	private final String XML_jteOlnl = "\t\t<localname iso3language=\"";
	private final String XML_jteOlnn = "\" name=\"";
	private final String XML_jteClnn = "\"/>\n";
	private final String XML_jtePiecesetO = "\n";
	private final String XML_jtePiecesetC = "\t</pieceset>\n\n";
	private final String XML_jteSilhouettesO = "\t<!-- Silhouette List -->\n\t<silhouettes>\n";
	private final String XML_jteSilhouettesC = "\t</silhouettes>\n";
	private final String XML_jteC = "</jte>\n";

	/**
	 * XML\[XɃpYs[XƃVGbgXg
	 *   @param tan ^ONX
	 *   @param sillist VGbgXgNX
	 *   @param s \[Xt@C
	 *   @param isResource \[Xǂ
	 *   @return ݂ɐǂ
	 */
	public boolean putXML(
		Tangram tan,
		SilhouetteList sillist,
		String s,
		boolean isResource)
	{
		if (isResource) return false;

		FileOutputStream fos;
		OutputStreamWriter osw;
		BufferedWriter bw;
		try {
			fos = new FileOutputStream(s);
			osw = new OutputStreamWriter(fos , encodingName);
			bw = new BufferedWriter(osw);
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		StringBuilder x = new StringBuilder(XML_HeaderO);
		x.append(XML_EncodingO);
		x.append(encodingName);
		x.append(XML_EncodingC);
		x.append(XML_HeaderC);
		x.append(XML_jteO);
		x.append(XML_jteVersionO);
		x.append(formatVersion);
		x.append(XML_jteVersionC);
		x.append(XML_jteLastupdateO);
		x.append(new Date().toString());
		x.append(XML_jteLastupdateC);

		x.append(XML_jtePiecesetOname);
		x.append(tan.getPuzzleName());
		x.append(XML_jtePiecesetOnum);
		x.append(PieceInfoTool.count(tan.pinfo));
		x.append(XML_jtePiecesetCnum);

		List<LocalName> namedict = tan.getLocalPuzzleNames();
		for (int i = 0; i < namedict.size(); i++) {
			x.append(XML_jteOlnl);
			x.append(((LocalName)(namedict.get(i))).getKey());
			x.append(XML_jteOlnn);
			x.append(((LocalName)(namedict.get(i))).getName());
			x.append(XML_jteClnn);
		}

		x.append(XML_jtePiecesetO);
		x.append(tan.geombank.toString());
		x.append(PieceInfoTool.toString(tan.pinit));
		x.append(XML_jtePiecesetC);

		if (sillist.getCount() > 0) x.append(XML_jteSilhouettesO);
		try {
			bw.write(x.toString());
			if (DEBUG) System.out.println(x.toString());
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		if (sillist.getCount() > 0) {
			for (int i = 0; i < sillist.getCount(); i++) {
				x.delete(0, x.length());
				x.append(PieceInfoTool.toString(sillist.get(i)));
				try {
					bw.write(x.toString());
					if (DEBUG) System.out.println(x.toString());
				} catch(Exception e) {
					System.out.println(e);
					return false;
				}
			}
		}

		x.delete(0, x.length());
		if (sillist.getCount() > 0) x.append(XML_jteSilhouettesC);
		x.append(XML_jteC);
		try {
			bw.write(x.toString());
			bw.close();
			osw.close();
			fos.close();
			if (DEBUG) System.out.println(x.toString());
		} catch(Exception e) {
			System.out.println(e);
			return false;
		}

		return true;
	}

}
